2009-08-18 Didrik Pinte <dpinte@dipole-consulting.com>

  * NEWS : updated to 1.2.2 release
  * Thuban/UI/view.py : improved mouse wheel zooming support
  * Thuban/Model/resource.py : updated for latest GDAL support
  * Thuban/UI/viewport.py : unconstrainted the scale bounds
  * Thuban/version.py : updated to 1.2.2 (before setting it back to 1.2.svn)

2009-08-13 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/classgen.py : applying patch from Anthony Lenton solving a
    problem generating class on 64bits system

2009-08-13 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/projdialog.py : removing inexistant ProjPanel.Clear() method calls

2009-07-09 Didrik Pinte <dpinte@dipole-consulting.com>

  * libraries/thuban/gdalwarp.py : fixing bug loading files with GDAL thanks to
    Evan Rouault
  * test/test_baserenderer.py : added a test replicating the problem loading 
    files with GDAL

2009-06-29 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/resource.py : freezing support improved

2009-06-27 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/view.py : added mouse wheel zoom support

2009-06-02 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/projlist.py : removed called to inexistant __del__ method on
                            wx.ListCtrl

2009-05-18 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/colordialog.py : update wxpython lib to wx (will not work with 2.4)
  * Thuban/UI/dock.py : removed deprecated call to SetSashBorder
  * Thuban/UI/projdialog.py : fix a utf problem when calling pyprojection
  
2009-05-18 Didrik Pinte <dpinte@dipole-consultin.com>

  * Thuban/UI/application.py : removed unneeded hardcoded load of extensions

2009-05-18 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/__init__.py, application.py : bugfix for wxpython 2.8
  * setup.py : removed some unneeded dll's from wxproj compilation
  * Thuban/Lib/fileutil.py : added get_thuban_dir() method managing freezed path's
  * Thuban/__init__.py, Thuban/Model/resource.py : uses the new get_thuban_dir() method

2009-05-18 Didrik Pinte <dpinte@dipole-consulting.com>

  * setup.py : updated to run with wxpython 2.8

2009-04-04 Didrik Pinte <dpinte@dipole-consulting.com>

  * Thuban/UI/mainwindow.py : completed command methods by allowing to remove
    from menu and toolbar

2009-03-30 Didrik Pinte <dpinte@dipole-consulting.com>

   * Thuban/version.py : resetted to svn release (thanks to Bernhard check)

2009-03-20 Didrik Pinte <dpinte@dipole-consulting.com>

   * Thuban/Model/transient.db.py, Thuban/version.py : added support for sqlite3 module

2009-03-18 Didrik Pinte <dpinte@dipole-consulting.com>

   * Thuban/UI/view.py, viewport.py  : support mouse double click events
   * Thuban/UI/mainwindow.py : support tools providing a wx.Bitmap icon in
     place of a path to Thuban resources

2009-02-19 Didrik Pinte <dpinte@dipole-consulting.com>

    * Thuban/UI/dock.py : bugfix for docking/undocking events

2008-12-03 Didrik Pinte <dpinte@dipole-consulting.com>

    * Extensions/wms/layer.py : added a very simple caching mechanism

2008-12-03 Didrik Pinte <dpinte@dipole-consulting.com>

    * Extensions/wms/layer.py : bugfix in projection management

2008-11-18 Didrik Pinte <dpinte@dipole-consulting.com>

    * libraries/thuban/gdalwarp.cpp : support the use of GDAL MEM driver for GDAL
      versions >= 1.5

2008-007-24 Bernhard Reiter <bernhard@intevation.de>
	
	* NEWS: Added summary of changes since the 1.2.1 release. Fixed some
	  typos.

2008-007-24 Bernhard Reiter <bernhard@intevation.de>
	
	* Thuban/thuban_cfg.py: Enabled wms extension. 
	*  Extensions/wms/__init__.py: Minor comment fix.

2008-06-23  Didrik Pinte <dpinte@dipole-consulting.com>
	* Extension/wms/__init__.py, wms.py, layer.py : copyright left to
	Intevation.

2008-06-19  Didrik Pinte <dpinte@dipole-consulting.com>
	* Extension/wms/__init__.py, wms.py, layer.py : wms extension has been
	update to use owslib 0.3. Extension is not stable but usable.

2008-06-03  Bernhard Reiter <bernhard@intevation.de>

	* test/test_baserenderer.py, testtest_layer.py: Give the
	gdal_support_status if there is no gdal support. Gives a better hint
	about why this is missing (e.g. no gdalwarp.so). Thanks to 
	Anthony Lenton.

2008-06-02  Bernhard Herzog  <bh@intevation.de>

	* Resources/XML/thuban-1.2.1.dtd, Resources/XML/thuban-1.1.dtd:
	Declare the attributes field and field_type of the element
	classification as optional in the syntactically correct way.

2008-05-23 Bernhard Reiter <bernhard@intevation.de>

	* README: Added a hint that the requirements need to be installed
	for building. Also added a section for installing, renaming the
	former section to building.

2008-04-18 Didrik Pinte <dpinte@dipole-consulting.com>

	* Thuban/UI/legend.py : changed the use of wx.MemoryDC to 
	wx.ScreenDC in order to allow compilation under Mac and wx 2.8

	* libraries/pyshapelib/shptreemodule.c : bugfix coming from Debian
	see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=469007

2008-02-13 Bernhard Reiter <bernhard@intevation.de>

	* test/test_save.py, Thuban/Model/load.py, setup.py: 
	Mixed tabs and spaces indentation is bad, thus removed the tabs
	from these inconsistant files.

	* Doc/technotes/release_process.txt: Better use thuban-announce@
	to announce. ;)

2008-02-03 Bernhard Reiter <bernhard@intevation.de>

	* Thuban/version.py, setup.py: Changing version number back to svn
	now that 1.2.1 is released.

2008-02-03 Bernhard Reiter <bernhard@intevation.de>

	* NEWS: Adding release date.

	* Releasenotes.txt: Adding release date and hint about reported
	gdal 1.5.0 problem.

2008-02-02 Bernhard Reiter <bernhard@intevation.de>

	* MANIFEST.in: Added "MANIFEST".

	* Doc/technotes/release_process.txt: Added option  --force-manifest
	and explanation to the source archive creation step.

	* po/de.po: Fixed translation for the contact section in the
	About dialog.

2008-02-02 Didrik Pinte <dpinte@dipole-consulting.com>

	* po/fr.po : updated all the fuzzy translations.

2008-02-01 Didrik Pinte <dpinte@dipole-consulting.com>

	* Extensions/umn_mapserver/mf_handle.py : bugfix due to the wx 2.6 
	update.

	* po/fr.po : translation improved.

2008-01-31 Bernhard Reiter <bernhard@intevation.de>

	File format dtd is now thuban-1.2.1.dtd. Fixed tests for this.

	* Resources/XML: Renaming thuban-1.2.0.dtd to thuban-1.2.1.dtd
	as Thuban 1.2.0 actually used 1.1-dev.dtd.

	* Resources/XML/thuban-1.2.1.dtd: Enabled keyword expansion again
	so that the header is clean now, bumped copyright to 2008.

	*  Thuban/Model/save.py: Using thuban-1.2.1.dtd now.

	*  Thuban/Model/load.py: Added  thuban-1.2.1.dtd instead of 
	thuban-1.2.0.dtd as recognised file formats.

	* test/test_save.py, test/test_load.py: Using thuban-1.2.1.dtd now.


2008-01-31 Bernhard Reiter <bernhard@intevation.de>

	Adding new Czech translation by new translator Jachym Cepicky.

	* Thuban/UI/about.py: Adding entry for Czech translation. Adding
	Didrik Pinte to the French translation. Adding Bernhard Reiter to
	the German translation.

	* po/*.po, po/de.po: Updated with string changes in the about dialog.

	* po/cs.po: New Czech translation contributed by Jachym Cepicky.
	
	* News: Mentioned new Czech translation.

	* MANIFEST.in: Also distribute the file Releasenotes.txt

	* Releasenotes.txt: Added a hint about that notes 
	 might be added after a source release. Thus looking for updates
	 is sensible.

2008-01-30 Bernhard Reiter <bernhard@intevation.de>

	* Releasenotes.txt: Fixed a typo.

2008-01-30 Bernhard Reiter <bernhard@intevation.de>

	* Thuban/Model/save.py: Using the new thuban-1.2.0.dtd.

	* Thuban/Model/load.py: Add the thuban-1.2.0.dtd to the list.

	* Resources/XML/thuban-1.2.0.dtd: New. Without the masktype attribute.

2008-01-30 Bernhard Reiter <bernhard@intevation.de>

	Preparing for release.

	* Thuban/version.py, setup.py: Moved version number to 1.2.1.

	* Thuban/UI/about.py: Bumped copyright to 2008.

	* README: Added hint that there are tests and a manual 
	to the installation section. Also a hint about the manual for the
	packagers.

	* Doc/manual/README: Mentioned the "Makefile" as prefered method.

	* Releasenotes.txt: Drafted an announcement and notes for 1.2.1.

	* po/*: Run the update (basically a date change)

2008-01-29 Bernhard Reiter <bernhard@intevation.de>

	* NEWS: Updated changes up to upcoming release 1.2.1.

2008-01-28 Bernhard Reiter <bernhard@intevation.de>

	Updated German translation.

	*  Extensions/svgexport/svgsaver.py,
	Extensions/umn_mapserver/mf_handle.py,  Extensions/wms/infodialog.py:
	Fixed small typo.

	* po/*.po: Updated (three small typos)

	* po/de.po: Brought translation uptodate.

2008-01-27   Bernhard Reiter <bernhard@intevation.de>

	Changed a few places in Thuban and Extensions to convert wx
	strings to internal string encoding. 

	* Thuban/UI/classgen.py: Checked for return strings from wx problems.
	Added one clarifing comment, removed two unused variables.

	* Thuban/UI/mainwindow.py(OpenSession, SaveSessionAs, TableOpen): Using 
	internal_from_wxstring for the pathname.

	* Thuban/UI/tableview.py(doExport):  Using internal_from_wxstring
	for the pathname.

	* Thuban/UI/view.py(MapCanvas.Export):  Using internal_from_wxstring
	for the pathname.

	* Extensions/bboxdump/bboxdump.py(OnSelectFilename),
	Extensions/export_shapefile/export_shapefile.py,
	Extensions/gns2shp/gns2shp.py, Extensions/importAPR/importAPR.py,
	Extensions/svgexport/maplegend.py, Extensions/svgexport/svgsaver.py,
	Extensions/umn_mapserver/mf_import.py: Using
	internal_from_wxstring for the pathname.

2008-01-26   Bernhard Reiter <bernhard@intevation.de>
	
	Fixed projection dialog so you can set [#586].
	(Part of the problems that arise with wx returning unicode.)

	* Thuban/UI/projdialog.py: translating filenames from dlg.GetPaths()
	and dlg.GetPath() to internal encoding using internal_from_wxstring().
	This fixes #586 (projection exception when changing projection).
	Using variable "path" in ProjFrame:_OnImport() more consistently.
	(__GetProjection): Using internal_from_wxstring() for the
	project parameters.

2008-01-21   Didrik Pinte <dpinte@itae.be>

	Updated fr.po to support Extensions localised strings

	* po/fr.po: Some translations

2008-01-19   Bernhard Reiter <bernhard@intevation.de>

	Strings in the Extensions are now also localised.

	* Extensions/umn_mapserver/mf_import.py,
	Extensions/umn_mapserver/mf_handle.py,
	Extensions/umn_mapserver/__init__.py,
	Extensions/umn_mapserver/mf_export.py, Extensions/ogr/__init__.py,
	Extensions/ogr/ogrdialog.py: Changed encoding from latin-1 to
	iso-8859-15 because the xgettext Debian Version: 0.16.1-2 does not
	recognise "latin-1".

	* po/Makefile: Added the toplevel files of the Extensions 
	to be considered as POT sources.

	* po/*.po: Updated with a lot of strings from the Extensions.
	
	* po/de.po: Some translations.

2008-01-19   Bernhard Reiter <bernhard@intevation.de>

	New installation wide configuration file thuban_cfg.py which by
	default tries to import all interesting Extensions coming with Thuban.

	Extentions are now all under the menu entry with the same name,
	their maturity will be indicated by leading string in the menu text.

	* Thuban/versions.py(verify_versions): Updated reference revisions 
	for checking the loaded libraries according to the README.

	* Thuban/UI/application.py: Started using the logging module for
	error message and runtime information.
	(read_startup_files): Trying to read new site wide startup file
	Thuban/thuban_cfg.py.

	* Thuban/thuban_cfg.py: New. Tries to import each interesting
	Extension (in a non-elegant way).

	* packaging/windows/thubanstart.py: Disabled import of default
	extensions as this is done in thuban_cfg.py now.

	* README: Mentioned thuban_cfg.py instead of the ugly method
	of thubanstart.py for each user's home directory.

	*  Extensions/export_shapefile/export_shapefile.py,
	Extensions/importAPR/importAPR.py: Moved them under "Extensions" menu,
	but marked them "(experimental) " in the menu entry text. Bumped
	copyright to include 2008.

	* Extensions/ogr/ogrstart.py: Separated the "(testing) " marking
	string from the rest of the menu entry.

	*  Doc/manual/thuban-manual.xml: Updated manual to include
	thuban_cfg.py and different handling of Extensions. Bumped copyright
	to include 2008.

2008-01-09   Bernhard Reiter <bernhard@intevation.de>

	Making Thuban robust against shapefiles which contain empty shapes.

	* libraries/thuban/wxproj.cpp(project_points): setting an exception
	now if called with no points at all. This is necessary, because 
	the NULL pointer already indicates an error condition, thus it
	cannot be used to indicate that there was no point in the result.
	(draw_polygon_shape, (point_in_polygon_shape): stop if there 
	are no points in the shape.
	Propagate an error condition on failure of (project_points()).
	(point_in_polygon_shape): shifted some lines around to allow
	a cleanup jump point.

	* Thuban/Model/layer.py, Thuban/UI/viewport.py: removed unused import
	of  point_in_polygon_shape.

2008-01-08   Bernhard Reiter <bernhard@intevation.de>

	* libraries/thuban/wxproj.cpp(project_points): made function robust
	against being called with no points. (also fixes main defect related 
	to [#571] (MemoryError when adding a particular shp layer))

2007-12-09   Bernhard Reiter <bernhard@intevation.de>

	WMS Extention improvements: Better logging for problem analysis. 
	Requirements: "logging" module is needed, included with Python 2.3.

	* Extentions/wms/test/test_domutils.py: Used same trick as in 
	test_ogclib.py to support.initthuban() so the test now runs.

	* Extensions/wms/capabilities.py: Added logging module and now
	starts logging the capabilities downloaded. As the wms extention
	is still experimental I have added the configuration so that
	DEBUG is written to stderr.

	* README: Requirements bumbed Python min to 2.3.5. because
	of the use of the logging module.

2007-12-08   Bernhard Reiter <bernhard@intevation.de>

	* po/es.po: Translation update by Daniel Calvelo.
	* po/fr.po: Translation update by Daniel Calvelo.
	* po/*: Updated the .po files. With many put thuban-devel@ in
	as "Language-Team". Also updated the "Project-ID-Version" to say
	Thuban 1.2.

2007-11-29   Bernhard Reiter <bernhard@intevation.de>
	
	Wms-Extension: Nasa as second example URL added.

	 * Extensions/wms/wms.py: Activated Nasa as URL and deleted
	 the other lines which were commented out.

2007-11-28   Bernhard Reiter <bernhard@intevation.de>

	Databaseconnections: some fixes.

	* Thuban/Model/postgisdb.py(_fetch_table_information()): also
	quote the tablename, which otherwise would not work when there is
	a "_" in the table name. It probably is a good idea anyway.

	* Thuban/UI/dbdialog.py(ChooseDBTableDialog.GetTable()): transform
	some resulting strings into internal encoding.

	* Thuban/UI/mainwindow.py(AddDBLayer()): print a traceback to stderr
	if the dataconnection fails to help analysing when there is a problem.

	* Extensions/ogr/ogrdialog.py: Fixed some wx calls building the dialog.

2007-11-28   Bernhard Reiter <bernhard@intevation.de>

	Wms-Extension: some fixes in order to make it work again.

	*  Extensions/wms/test/test_parser.py: removed import of adjustpath,
	but instead used the same method as other Extensions to call
	the support.initthuban() function from the toplevel "test" directory.

	* Extensions/wms/infodialog.py(calcText()): removed encode('latin1')
	as the Title already should be in the internal Thuban encoding.

	*  Extensions/wms/properties.py:  removed encode('latin1')
        as the Title already should be in the internal Thuban encoding.
	Added copyright year 2007. Fixed reference to wx.EVT_BUTTON.

	* Extensions/wms/layer.py: Using internal_from_.unicode now to bring
	 the layer title in the right encoding.


	* Extensions/wms/wms.py: adapting call to draw_raster_layer as
 	draw_raster_layer() got the calling parameters changed in rev2618.
	Changed the preset selection choice towards demo.intevation.org, as
	the frida wms does not seem to work anymore these days.
	Fixed reference to EVT_BUTTON (was probably an oversight from the wx2.6
	migration.)

2007-11-26  Bernhard Reiter <bernhard@intevation.de>

	* README: Added remark that extension can have their own
	additional requirements.

	* Extensions/ogr/ogrstart.py: Re-added parameters for wx.FileDialog()
	that had been accidently dropped in r2746. Transformed result from
	GetPaths to internal encoding. Refactored map to mymap. Removed two
	unused variables from select_file_format().

	* Thuban/UI/altpathdialog.py: transformed result from GetPaths to
	internal encoding. Made sure the translation is actually used as
	the _() function will only match on a fixed string.
	* po/*: updated all po files (minor for altpathdialog.py).
	* po/de.po: improved translation for altpathdialog.py.

2007-11-25  Bernhard Reiter <bernhard@intevation.de>

	* po/*: Updated all po files.
	* po/de.po: Fixed two translations.

2007-11-23  Bernhard Reiter <bernhard@intevation.de>

	* README: upgraded requirement for psycopg from 1.0.x to 2.0.x
	which is necessary since rev. 2768, Wed May 9 2007.

2007-06-27  Didrik Pinte <dpinte@itae.be>

	umn_mapserver extension bug fixing due to the wx 2.6 migration

	* Extensions/umn_mapserver/mf_import.py: import corrections

2007-06-23  Bernhard Reiter <bernhard@intevation.de>
	
	* thuban.py: Added the __name__="__main__" trick so you can
	import thuban without starting the application directly.
	This makes debugging possible.

	* Thuban/UI/view.py (MapCanvas.Print): Creating a PrintDialogData
	object first and setting a parameter, which reenables printing 
	at least on Debian Sarge with python-wxgtk2.6 2.6.3.2.0bpo1.
	Bumped copyright line to include 2007.

2007-06-23  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/version.py: Enable to indicate branch names in the 
	thuban_release-svn-display.

	* Thuban/UI/about.py: Mentioning the version number of the GNU GPL.

2007-06-22  Bernhard Reiter <bernhard@intevation.de>

	INCOMPATIBLE CHANGE with Thuban 1.1 (development series) and 1.2.0:
	Changing the raster layer attributes towards always 
	using an alpha channel. As we require wx2.6 there is no real use-case 
	for bitmap and this fixes a problem on the windows platform.

	* NEWS: adding note about the major change using alpha always.

	* Thuban/UI/renderer.py: Removed diversion for wx <2.5.3 as 
	we require >= 2.6 now. Bumping copyright, adding author Bernhard.

	* Thuban/UI/rasterlayerproperties.py: Removed diversion for
	wx <2.5.3 as we require >= 2.6 now, so we always can do alpha channel. 
	Added author Bernhard Reiter and copyright year 2007. 
	Removed two old code lines which were commented out.
	Commented out the code for the mask type selection.

	* Thuban/Model/layer.py: Made masktype = MASK_ALPHA default for new
	raster images. Bumping copyright.

	* test/test_layer.py: made test_raster_layer() expect MASK_ALPHA.
	Bumping copyright.

	* Thuban/Model/load.py: if there is no masktype set, use alpha.
	This means the behaviour changes for files saved with Thuban-1.1,
	but this has been a development version. As bitmap does not work
	on some platforms (windows currently) it will even fix a problem 
	there. Bumping copyright

	* test/test_load.py: Removed masktype from example file. Bumping
	copyright.

	* Thuban/Model/save.py: Do not save raster attribute "masktype" 
	anymore. Bumping copyright.

	* test/test_save.py: Not expecting "masktype" to be saved anymore.
	Bumping copyright.

2007-06-22  Bernhard Reiter <bernhard@intevation.de>

	Minor documentation cleanups. 

	* NEWS: Corrected python version relation indicating which python
	versions call modules with the locale set.

	* README: (minor) better formatting: added a few more lines breaks.
	Packagers: Added hints that enabling all extensions would be cool.

2007-05-22  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/mainwindow.py: using a loop for several raster filenames.
	Thanks to Jachym Cepicky and Bernhard Herzog. Closes [#403] "can not
	add raster layer". And adds the ability to open more then one raster
	file from one open dialog by multiple selection.

2007-05-22  Bernhard Herzog  <bh@intevation.de>

	* Extensions/ogr/ogrshapes.py: Move the __future__ import to the
	top of the file.  Otherwise Python will not recognize it and
	Python 2.5 will even throw a SyntaxError

2007-05-10  Didrik Pinte <dpinte@itae.be>

	* packaging/windows/Thuban-1.2.0_1.exe.readme.txt : installation
	instruction for the windows InnoSetup version.

2007-05-10  Didrik Pinte <dpinte@itae.be>

	Migration to psycopg2 to support UTF8 environments

	* Thuban/Model/postgisdb.py : psycopg2 migration
	* test/postgissupport.py, test_postgis_db.py : psycopg2 migration

2007-05-07  Bernhard Reiter <bernhard@intevation.de>

	* Releasenotes.txt: Improved the language on the announcement,
	which is now ready. Also improved windows hints where raster works,
	but only with alpha. Put the Revision keyword on top.

2007-05-03  Didrik Pinte <dpinte@itae.be>

	* Thuban/UI/dock.py, classifier.py : Little fixes with GetSize methods

2007-04-25  Didrik Pinte <dpinte@itae.be>
	
	* Releasenotes.txt : win32 installer warning added

2007-04-25  Bernhard Reiter <bernhard@intevation.de>

	Improvements (thanks to Samuel Mesa for reporting the problems):
	o The class generator selector will work even in other languages.
	o Layer titles from filenames are saved in the correct encoding, so
	  strings can be assembled from them, 
	  e.g. for the Layer Projection dialog.

	* Thuban/UI/mainwindow.py: translating filenames from dlg.GetPaths()
	to internal encoding using internal_from_wxstring().

	* Thuban/UI/mainwindow.py: Refactored, now the build-in function map() 
	can be used again:
	a) renamed local variables map to mymap. It was covering up map().
	b) removed calls filling  map = self.Map() in
	DatabaseManagement()and LayerProjection() as the result was not
	used and MapCanvas.Map() does not have a side effect.

	*  Thuban/UI/classgen.py(ClassGenDialog): translating result from
	genChoice.GetString() back to internal encoding.
	
	*  Thuban/UI/__init__.py: Added internal_from_wxstring() and
	ugly code that actually sets this function. Using and internal
	variable _wx_can_be_imported that install_wx_translation() will set.

	* Doc/technotes/string_representation.txt: fixed a typo and 
	made the text less string about dbf files not providing encoding
	information, but it might be that some of them do.

2007-04-12  Bernhard Reiter <bernhard@intevation.de>

	* Releasenotes.txt: Added as a repository for the announcements
	and noteworthy issues. Included draft announcement.
	
	* NEWS: Moved over known issues of 1.2.0 to Releasenotest.txt because
	that is a better place for it. Later issues get fixed and 
	NEWS should be an overview of the important changes over time.

2007-04-12  Bernhard Reiter <bernhard@intevation.de>

	* test/localessupport.py: replaced getlocale with setlocale
	because of a python problem that the output of getlocale cannot
	be used as input of setlocale in all cases. python 2.3 2.4 2.5
	had the problem, see
	sf[ 1699853 ] locale.getlocale() output fails as setlocale() input
	https://sourceforge.net/tracker/index.php?func=detail&aid=1699853&group_id=5470&atid=105470
	Did some minor formatting. Added German_Germany.1252 encoding 
	from window XP experiments to try.

	* Thuban/Model/proj.py: replaced getlocale with setlocale.
	This avoids an exception on windows xp sp2 German. But it does
	not fix the raster display problem. The second attempt of setlocale
	can be removed.

2007-03-17  Didrik Pinte <dpinte@itae.be>

	*  Extensions/ 
	drawshape/drawshape.py, 
	export_shapefile/export_shapefile.py,
	ogr/ogrdialog.py, ogrstart.py,
	svgexport/maplegend.py, svgsaver.py,
	umn_mapserver/mf_export.py, mf_handle.py, mf_import.py,
	wms/infodialog.py, properties.py, wms.py: final updates for the 
	wx 2.6 transition

	*  setup.py : updated the gdal path for win32, added a missing 
	ressource for the mouseposition extension

2007-03-14  Bernhard Reiter <bernhard@intevation.de>

	*  Doc/technotes/release_process.txt: Improved with SVN instructions,
	uploading and setting back the version numbers again.

	* Thuban/version.py, setup.py: Changing version to "svn" after
	release.

2007-03-14  Didrik Pinte <dpinte@itae.be>

	* Thuban/UI/classgen.py: bugfix - Close button now really closes the 
	dialog window (closes #309)

2007-03-13  Bernhard Reiter <bernhard@intevation.de>

	More release preparations: Translation string updated.  Release date 
	added.

	* po/*: Updated .po files with new strings. 

	* po/de.po: Completed German translation (3 missing, one fuzzy).

	* README: Bumped minium requirement of pysqlite to 1.0.1 (as I believe
	Thuban was tested with on Debian.)

	* NEWS: New phrasing for "changes up to". Added release date.

	*  Thuban/UI/about.py: Added fileencoding information, otherwise
	xgettext from 0.16.1 did not want to run on this file.

	* Thuban/UI/__init__.py: Calling wx.Locale() with with parameter
	wx.LANGUAGE_DEFAULT now. Without this change no message catalog is
	loaded in wxPython 2.6.3.2.1.5 and thus the translation would not work. 

	* setup.cfg: Change tarball compression from gzip to bzip2.

	* packaging/debian: Moved the directory in here from toplevel,
	because there could be several debian packaging dirs and this
	is outdated.

	* MANIFEST.in: Added toplevel ChangeLog to distribution.
	Made sure that files under packaging are actually packaged.

2007-02-26 Bernhard Reiter <bernhard@intevation.de>

	* MANIFEST.in: Added *.xmi to Doc so that ThubanModel.xmi is included.

	* Extensions/svgexport/TODO: Added findings about how to write raster
	in SVG.

	* Extensions/svgexport/svgmapwriter.py: untabified two lines. 
	Fixed a typo.

	* Doc/ThubanModel.xmi: Updated the format of the umbrello file.
	Loaded and saved with umbrello 1.3.2, manually changed the
	codegeneration tag to be empty again and change the XMI.model
	to not contain a local path.
	Now umbrello 1.5.5 also opens the file without crashing. 
	Thanks to Philippe LeGrand who discovered the problem and the
	solution and filed report 141279 on bugs.kde.org for this umbrello
	problem.

2007-02-21 Didrik Pinte <dpinte@itae.be>

	* Extensions/umn_mapserver/__init__.py : UTF8 locales bugfix

2007-02-20 Bernhard Reiter <bernhard@intevation.de>

	* Thuban/version.py, setup.py: Getting ready for release 1.2.0.
	Using this version number.

	* Doc/README: fixed a typo.

	* Doc/technotes/release_process.txt: Updated. Reference platform
	is Debian Etch now. If windows, it should be window XP.
	Marked a few entries in the instructions as "Old:".

	* README: Bumped requirements to wxWidgets 2.6.3.2 and gdal 1.3.2.. 
	Added urls for homepage and infrastructure on wald. Fixed a typo.

	* MANIFEST.in: Added subdir "packaging" which should be in the tarball.

	* NEWS: Completed changes from 1.1.0 until today as gathered from
	the Changelog entries. Added small section about OGR known problems
	because we do not have a release-notes file so far.

	* Doc/manual/thuban-manual.xml: Removed the installation instructions
	as they are outdated and they should be only in one place.
	Bumped version number of the document to 1.2.0. Marked it as Draft
	in the title.

	* Extensions/svgexport/: Get ready for release. Bump version
	number to 1.0.1. Adjusted numbers in TODO.

	* Thuban/UI/about.py: Reworked the about text. It shows now
	when somebody was active on Thuban. Added a list of maintainers.
	Bernhard Reiter is the current maintainer, following up on Bernhard
	Herzog. 

	* Extensions/export_shapefile/export_shapefile.py: untabify.

	* test/README: Added example how to set the PATH for postgis on
	Debian Etch.

2007-01-13 Didrik Pinte <dpinte@itae.be>

	bboxdump, gns2shp, importAPR, mouseposition, ogr, profiling, svgexport
	extensions migrated to wxPython 2.6

	* Extensions/bboxdump/bboxdump.py: 
	updated wx statements

	* Extensions/gns2shp/gns2shp.py: 
	updated wx statements

	* Extensions/importAPR/importAPR.py:
	updated wx statements

	* Extensions/mouseposition/mouseposition.py:
	updated wx statements

	* Extensions/ogr/
	ogrdialog.py, ogrstart.py:
	updated wx statements

	* Extensions/profiling/profiling.py:
	updated wx statements

	* Extensions/svgexport/
	maplegend.py, svgsaver.py:
	updated wx statements


2007-01-08 Didrik Pinte <dpinte@itae.be>
	
	export_shapefile extension migrated to wxPython 2.6

	* Extensions/export_shapefile/export_shapefile.py: 
	updated wx statements, changed the FileDialog to wx.SAVE (was wx.OPEN)

2007-01-08 Didrik Pinte <dpinte@itae.be>
	
	umn_mapserver extension migrated to wxPython 2.6

	* Extensions/umn_maserver/
	mf_handle.py, mf_import.py, mf_export.py: 
	update wx imports to 2.6 policy

2007-01-06 Didrik Pinte <dpinte@itae.be>

	UTF-8 locales support reading non utf-8 files. 
	This is a workaround and not a real bugfix. See 
	http://wald.intevation.org/tracker/index.php?func=detail&aid=118 
	for more details

	* Thuban/UI/tableview.py, controls.py, baserenderer.py, view.py: 
	decode text from iso-8859-1 encoding.

2007-01-01 Bernhard Reiter <bernhard@intevation.de>

	* test/postgissupport.py, test/test_postgis_db.py: adding an 
	explicit WITH OIDS to the create table commands. This fixes tests
	that rely on an oid column to be present for postgresql >=8.0.
	Thanks for Frank Koormann for the hint.

2006-11-06 Didrik Pinte <dpinte@itae.be>

	* libraries/thuban/wxproj.cpp: bugfix - allow compilation with
	msvc++ toolkit 2003

2006-11-06 Bernhard Reiter <bernhard@intevation.de>

	Made it easier to run PostGIS test on Debian Etch. Improving
	https://wald.intevation.org/tracker/index.php?func=detail&aid=173 .

	* test/postgissupport.py: Taking pg_ctl and initdb commands
	from internal variables now. Adding deactivated example values
	for Debian Etch.  
	find_postgis_sql(): Added special line for Debian Etch postgresql-8.1.
	Added copyright year 2006.

2006-10-25 Bernhard Reiter <bernhard@intevation.de>
	
	Moved ogr Extension to Extension menu.

	* Extensions/ogr/
	__init__.py, ogrstart.py, ogrshapes.py, ogrdialog.py
	test/test_OGRShapestore.py, test/__init__.py: 
	adding encoding information and made sure Autor's names 
	with an umlaut are actually written with an umlaut.

	* Extensions/ogr/ogrstrat.py: now registering in menu "Extensions",
	having a "(testing)" string before the submenu to prepare for 1.2.0
	release.  Bumped copyright year to 2006.

2006-10-15 Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/renderer.py: Added module variable verbose and
	added verbose output before doing a raster projection.
	Minor: Added (c) year 2006.

	* test/test_baserenderer.py: Added new function
	test_projected_raster_decimalcommalocale()
	Added new author Bernhard Reiter and new copyright year 2006.

	* libraries/thuban/gdalwarp.cpp(ProjectRasterFile): Adding
	switching to LC_NUMERIC "C" and back before calling GDAL functions -
	only #if python >=2.4 .

2006-10-10 Didrik Pinte <dpinte@itae.be>

	Win32 build updates 

	* setup.py : 
	    - update to the latest libs for win32 setup tasks
		- added gdal and Lib content to the inno setup build task
		- added stable and experimental extensions to setup packages

	* thuban.py :
		- gdal support for win32 inno installation

2006-10-10 Didrik Pinte <dpinte@itae.be>

	* Thuban/Model/layer.py (Layer.GetLabelPosFromShape): new method 
	extracted from Thuban/UI/viewport.py
	* Thuban/UI/viewport.py (Viewport.LabelShapeAt): uses new method

2006-09-28 Didrik Pinte <dpinte@itae.be>

	* Thuban/UI/classgen.py: bugfix due to wx2.6 update

	* Thuban/UI/view.py: removed non needed declaration

	* Thuban/UI/selection.py : typo correction

2006-09-24 Bernhard Reiter <bernhard@intevation.de>

	* Thuban/Model/proj.py(_do_we_have_to_work_around_broken_proj): 
	Making the test more robust for observed python 2.3 problems
	with setlocale().

	* test/runtests.py: Added new option ---setdecimalcommalocale
	to run all tests with an LC_NUMERIC that uses comma as decimal_point.
	Minor: Added (c) year 2006. Fixed typo in a docstring.

	* test/test_transientdb.py: Minor: Added (c) year 2006. Fixed typo in
	a docstring.

2006-09-23 Bernhard Reiter <bernhard@intevation.de>

	* Extensions/ogr/test/test_OGRShapestore.py: fixed skip_if_no_ogr()
	and added it to TestOGRTable.setUp() so that all tests get skipped
	if ogr cannot be imported. Added (c) year 2006.

2006-09-18 Didrik Pinte <dpinte@itae.be>
	
	* wxPython 2.6 update : wx 2.4 syntax has been updated to 2.6
	
2006-09-18 Bernhard Reiter <bernhard@intevation.de>

	Fixed proj behaviour with python >=2.4 when decimal_point != '.'.

	* Thuban/UI/application.py: Fixed warning dialog when gdal is missing.

	* test/test_proj.py: new test_lc_numeric_robustness(). Added author
	Bernhard Reiter and new copyright year 2006.

	* Thuban/Model/proj.py: New _do_we_have_to_work_around_broken_proj()
	and Projection.assuregoodlocale(), Projection.assureinitlocale().
	Added author Bernhard Reiter and (c) 2006.

2006-09-15 Bernhard Reiter <bernhard@intevation.de>

	* README: added RXP and pyRXP as optional for tests.

	* test/localessupport.py: New. Contains a helper function
	to find a locale with comma used as decimal_point.

2006-08-31 Bernhard Reiter <bernhard@intevation.de>

	* README: fixed URLs to sqlite and pysqlite.

	* Thuban/UI/about.py: Added Didrik Pinte as contributor. Extended
	  copyright range to include 2006.

2006-06-29 Didrik Pinte <dpinte@itae.be>

	* Thuban/UI/main.py: circular import fix.

2006-06-27 Frank Koormann <frank@intevation.de>

	New Classification "Pattern": Classify text attributes by regexp.

	* Thuban/Model/classification.py (class ClassGroupPattern): 
	New, group is associated with a regular expression.
	(Classification._compile_classification): Store compiled regexp and
	original group for pattern.
	(Classification.FindGroup): Added pattern.

	* Thuban/UI/classifier.py 
	(ClassGrid._OnLabelRightClicked, ClassGrid.labelPopup): 
	New, add popup to select singleton/pattern.
	(ClassTable.GetRowLabelValue, ClassTable.GetValueAsCustom,
	ClassTable.SetValueAsCustom): Added pattern.
	(ClassTable.__ParseInput): Autodetect singleton/pattern.

	* Thuban/Model/save.py (SessionSaver.write_classification): 
	Added pattern.

	* Thuban/Model/load.py (SessionLoader.start_clpattern,
	SessionLoader.end_clpattern): New, process pattern elements.

	* test/test_classification.py (class TestClassGroupPattern): New.
	(TestClassification.test_add_pattern, 
	TestClassification.test_multiple_groups_textual,
	TestClassification.test_deepcopy_textual): New.
	(TestClassification.test_multiple_groups_numerical): 
	Renamed test_multiple_groups.
	(TestClassification.test_deepcopy_numerical): Renamed test_deepcopy.

	* test/test_save.py (SaveSessionTest.testClassifiedLayer): 
	Added pattern.

	* test/test_load.py (ClassificationTest.TestLayers, TestClassification):
	Added pattern.

	* test/test_layer.py 
	(TestLayerModification.test_set_classification_textual): New
	(TestLayerModification.test_set_classification_numerical):
	Renamed test_set_classification.

	* Doc/manual/thuban-manual.xml: Added pattern to layer classification
	description.

	* Resources/XML/thuban-1.1.dtd: Added clpattern element and attribs.

2006-06-29 Didrik Pinte <dpinte@itae.be>

	* Thuban/version.py: Bugfix determination of SQLite, the wright one !
	  
2006-06-28 Didrik Pinte <dpinte@itae.be>

	* packaging/windows/thubanstart.py: sample file loading all the stable
	extensions
	
2006-06-28 Didrik Pinte <dpinte@itae.be>

	* Thuban/version.py: Bugfix determination of SQLite on old and recent
	systems (support pysqlite1 and pysqlite2)

2006-06-27 Frank Koormann <frank@intevation.de>

	* Thuban/version.py: Bugfix determination of SQLite on old systems.

2006-05-17 Didrik Pinte <dpinte@itae.be>
	* Extensions/ogr/__init__.py : updated test for win32 and correct
	imports

2006-05-15 Didrik Pinte <dpinte@itae.be>
	Ashamed ... still some tabs in the files

	* Thuban/version.py : tabs removed	
	* Thuban/Model/transientdb.py : tabs removed

2006-05-15 Didrik Pinte <dpinte@itae.be>

	* Thuban/version.py : coding style correction	
	* Thuban/Model/transientdb.py : coding style correction

2006-05-15 Didrik Pinte <dpinte@itae.be>

	* Thuban/version.py : Updated imports to support pysqlite2

	* Thuban/Model/transientdb.py : Updated imports to support pysqlite2
	Patched the querying system to support the param style of pysqlite2

2006-04-24 Didrik Pinte <dpinte@itae.be>

	* Extensions/svgexport/__init__.py: The extension now works on win32
	architecture. Bug #87 corrected.

2006-04-20 Bernhard Reiter <bernhard@intevation.de>

	* Doc/technotes/coding_guidelines.txt: Changed text from CVS to SVN.
	Removed emacs specific hint and replaced it with a general hint
	that editors might support writing changelogs.

2006-04-12 Bernhard Reiter <bernhard@intevation.de>

	* Thuban/version.py: Changed thuban_release mechanism to use "svn"
	instead of "cvs".

2006-03-31  Bernhard Reiter <bernhard@intevation.de>

	* libraries/thuban/wxproj.cpp: including proj_api.h instead of
	projects.h now. According the Frank Warmerdam and man pj_init
	this is the public interface to proj. Thus I have changed PJ to projPJ.
	And I could remove the hack to avoid clashes with typedef PVALUE
	and #define LP in projects.h clashing with symbols when trying to 
	build on windows. The file is cleaner and nicer now.

2006-03-29  Bernhard Reiter <bernhard@intevation.de>

	* libraries/thuban/wxproj.cpp: undef LP to avoid clash when 
	trying to build with mingw.

2005-10-18  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/about.py: remove unused import of getdefaultlocale.
	Added display of internal encoding to the about dialog text.

	* Extensions/svgexport/__init__.py: changed version to "1.0.0+cvs".

2005-10-18  Bernhard Reiter <bernhard@intevation.de>

	Startup improved: We fail right away if the internal encoding could
	not be determined.

	* Thuban/__init__.py (get_internal_encoding): new.

	* test/test_stringrepresentation.py (class TestInternalEncoding): 
	Preserve the internal encoding for the tests in this class.

2005-10-17  Bernhard Reiter <bernhard@intevation.de>

	* test/test_stringrepresentation.py: New file, for now testing
	that set_internal_coding() is throwing an exception for bad exceptions.

	* Thuban/__init__.py (set_internal_encoding): added a forwards
	and backward translation, so that we fail early if the 
	internal_encoding is bad.

2005-10-17  Bernhard Reiter <bernhard@intevation.de>

	svgexport 1.0.0cvs: Fixed ARC layer writing: No filling is done.
	You could actually get polylines with filling in between,
	when the classification for the lines had a fill color.
	E.g. this happens when you generate a classification from a ramp.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	New test_export_arc_no_fill(). Extend copyright notice to 2005.

	* Extensions/svgexport/svgmapwriter.py
	(SVGRenderer.draw_shape_layer_incrementally()):
	Setting TRANSPARENT_BRUSH for shaptype ARC. 
	Extend copyright notice to 2005.

	* Extensions/svgexport/__init__.py: Extend copyright notice to 2005.

2005-09-08  Frank Koormann <frank@intevation.de>

	* Doc/manual/thuban-manual.xml (Map Management): Fixed typo reported 
	by Erik (sigra.at.home.se)

2005-08-18  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/renderer.py (ScreenRenderer.draw_selection_incrementally): 
	Call the right method for the default size.

2005-08-11  Jan-Oliver Wagner <jan@intevation.de>

	* Extensions/export_shapefile: New.

	* Extensions/export_shapefile/__init__.py: New. Initialize
	the export_shapefile extension.

	* Extensions/export_shapefile/export_shapefile.py: New.
	Exports a layer as a Shapefile.

2005-08-08  Jan-Oliver Wagner <jan@intevation.de>

	* po/de.po: String fixes. This fixes Debian bug #313843.

2005-07-27  Jan-Oliver Wagner <jan@intevation.de>

	Remove the attributes from the layer element in
	.thuban files for the save routine.
	This also solves RT bug #3149,
	https://intevation.de/rt/webrt?serial_num=3149

	* test/test_load.py: (TestSingleLayer, TestNonAsciiColumnName,
	TestLayerVisibility, TestSymbolSize, TestClassification, TestLabels,
	TestLayerProjection, TestJoinedTable, TestLabelLayer): Removed
	attributes from layer element to classification clnull element.

	* test/test_save.py (SaveSessionTest.testSingleLayer,
	SaveSessionTest.testLayerProjection,
	SaveSessionTest.testClassifiedLayer,
	SaveSessionTest.test_joined_table, SaveSessionTest.test_save_postgis):
	Removed attributes from layer element to classification clnull element.
	(test_save_postgis.NonConnectionStore._fetch_table_information):
	added pretending to have a shape_type.

	* Resources/XML/thuban-1.1.dtd: Make the attributes field
	and field_type of classification optional.

	* Thuban/Model/classification.py (Classification.TreeItem.build_info):
	Added output of size.

	* Thuban/Model/load.py (SessionLoader.start_classification):
	Change attribute 'field' and 'field_type' from obligatory to
	optional to allow empty classes (ie.  only with a default=clnull).

	* Thuban/Model/save.py (SessionSaver.write_layer): Don't write
	any attributes anymore for the layer element.
	(SessionSaver.write_classification): Even if there is no
	classification field, still write the classification because
	the clnull (default) symbol will not be defined anymore as
	part of the layer element.

2005-07-05  Bernhard Herzog  <bh@intevation.de>

	* setup.py (setup call): Version 1.1.0

	* NEWS: Update for 1.1.0

	* MANIFEST.in: Add *.txt to files taken from Doc.  Otherwise the
	technores won't be included

	* Thuban/UI/about.py (About.__init__): Extend copyright notice to
	2005

	* po/de.po: Updated.

2005-07-05  Bernhard Herzog  <bh@intevation.de>

	* README: gdal 1.1.8 is too old.  1.2.5 works.

2005-07-05  Bernhard Herzog  <bh@intevation.de>

	* Resources/XML/thuban-1.1.dtd (rasterlayer): Add the opacity and
	masktype attributes.

2005-07-05  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/layer.py (Layer.__mangle_bounding_box)
	(Layer.ClipBoundingBox): Rename ClipBoundingBox to
	__mangle_bounding_box.  See the comments in the code and RT #2845

	* test/test_layer.py (TestLayer.test_arc_layer_with_projection):
	Remove the explicit test of ClipBoundingBox.  The method isn't
	public anymore and the direct call in the test wasn't necessary in
	the first place.  If ClipBoundingBox (now __mangle_bounding_box)
	isn't called, the return value of ShapesInRegion will be
	different.

2005-07-05  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/viewport.py (ViewPort.set_view_transform): Handle
	ZeroDivisionError exceptions.  I don't know when they happen
	exactly.  It probably happens when the projections aren't set
	properly.

2005-07-01  Bernhard Herzog  <bh@intevation.de>

	First step towards unicode.  With this roughly we're at step 1
	string_representation.txt

	* Doc/technotes/string_representation.txt: New.  Document how
	strings are represented in Thuban and how to get to a Unicode
	Thuban.

	* Thuban/__init__.py (set_internal_encoding)
	(unicode_from_internal, internal_from_unicode): New. The first few
	functions for the internal string representation

	* Thuban/UI/about.py (unicodeToLocale): Removed.  Use
	internal_from_unicode instead.

	* Thuban/UI/__init__.py (install_wx_translation): Determine the
	encoding to use for the internal string representation.  Also,
	change the translation function to return strings in internal
	representation even on unicode builds of wxPython

	* Thuban/Model/load.py (SessionLoader.check_attrs): Decode
	filenames too.
	(SessionLoader.start_clrange): Use check_attrs to decode and check
	the attributes.

	* Thuban/Model/xmlreader.py (XMLReader.encode): Use
	internal_from_unicode to convert unicode strings.

	* Thuban/Model/xmlwriter.py (XMLWriter.encode): Use
	unicode_from_internal when applicable

	* test/runtests.py (main): New command line option:
	internal-encoding to specify the internal string encoding to use
	in the tests.

	* test/support.py (initthuban): Set the internal encoding to
	latin-1

	* test/test_load.py (TestSingleLayer.test, TestClassification.test)
	(TestLabelLayer.test): Use the internal string representation when
	dealing with non-ascii characters

	* test/test_load_1_0.py (TestSingleLayer.test)
	(TestClassification.test, TestLabelLayer.test): Use the internal
	string representation when dealing with non-ascii characters

	* test/test_load_0_9.py (TestSingleLayer.test)
	(TestClassification.test): Use the internal string representation
	when dealing with non-ascii characters

	* test/test_load_0_8.py (TestUnicodeStrings.test): Use the
	internal string representation when dealing with non-ascii
	characters

	* test/test_save.py (XMLWriterTest.testEncode)
	(SaveSessionTest.testClassifiedLayer): Use the internal string
	representation when dealing with non-ascii characters where
	applicable

2005-06-30  Bernhard Herzog  <bh@intevation.de>

	* test/runtests.py: Untabify.

2005-06-30  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/renderer.py (ScreenRenderer.draw_selection_incrementally): 
	untabify.

2005-06-30  Bernhard Herzog  <bh@intevation.de>

	* Extensions/ogr/test/__init__.py: Add missing coding directive

2005-06-28  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/renderer.py (ScreenRenderer.draw_selection_incrementally):
	Use the default size for rendering selected items of default type.
	Fixes part 2 of https://intevation.de/rt/webrt?serial_num=3149

2005-06-28  Jan-Oliver Wagner <jan@intevation.de>

	* Extensions/importAPR/apr.py (APR_BShSym): Extend by 'Stripple'.
	(APR_TClr.GetThubanColor): Fix bug in color interpretation.
	Thanks to Frank Koormann who identified this problem.

	* Extensions/importAPR/importAPR.py (APR_VShSym): New. Just
	another symbol identified.

2005-06-27  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: More translations.

2005-05-12  Jonathan Coles <jonathan@intevation.de>
	
	* Thuban/UI/projdialog.py: Add missing import, which led to an
	exception when opening a layer's projection.

2005-05-09  Bernhard Herzog  <bh@intevation.de>

	* test/support.py (FileLoadTestCase.filename): Fix doc-string.

2005-05-09  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py (PostGISConnection.connect): Set the
	connection to autoconnect.  Fixes RT#3148.

	* test/test_postgis_db.py
	(TestPostGISSpecialCases.test_simple_error_handling): New test
	that attempts to reproduce RT#3148.

2005-05-06  Jonathan Coles <jonathan@intevation.de>

	Add support for saving and loading the opacity and mask type
	properties of RasterLayers. Also add support for proper use
	of alpha information while drawing images not in 'RAW' format.
	If transparency in an image format (e.g, PNG) is supported by
	wxWidgets then the image would previously have been draw with 
	transparent regions, but the opaque regions would have been 
	unaffected by a change in the layer's opacity. This patch
	corrects the problem.

	* Thuban/Model/layer.py (RasterLayer): Added opacity and
	masktype parameters to the constructor, and set the
	appropriate variables to those values.

	* Thuban/Model/load.py (SessionLoader.start_rasterlayer): Added
	code to read the opacity and mask type of the layer and construct
	a new layer with the additional parameters.

	* Thuban/Model/save.py (SessionSaver.write_layer): Added code
	to save the opacity and mask type of a layer.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_layer): Pass
	the opacity of the layer to draw_raster_data rather than the layer.
	(BaseRenderer.draw_raster_data): Remove the layer parameter because
	the function doesn't need to know about the layer. Add the optional 
	opacity parameter whose default is 1.0. Add 'PNG' as a supported
	graphics format.

	* Thuban/UI/renderer.py (MapRenderer.draw_raster_data): Fixed
	signature to match that in BaseRenderer. Use the new opacity argument
	in place of calling layer.Opacity(). In the case where the
	format is not 'RAW', alpha_data is None and the loaded image has
	alpha information, use the file's alpha information. This is
	still subject to the layer's opacity setting.

	* test/test_baserenderer.py (SimpleRenderer.draw_raster_data): 
	Fixed signature to match that in BaseRenderer.

	* test/test_load.py (TestRasterLayer): Change file_contents to
	include opacity and masktype variables.
	(TestRasterLayer.test): Include tests for opacity and masktype
	changes.

	* test/test_save.py (SaveSessionTest.testRasterLayer): Restructure
	test to cover a variety of combinations of masktype and opacity
	settings.

2005-05-02  Jan-Oliver Wagner <jan@intevation.de>

	* debian/rules: add --use-wx-python-swig-hack
	to the build command.
	Thanks to Moritz Lennert for pointing this out.

2005-04-28  Jan-Oliver Wagner <jan@intevation.de>

	Introduce OGRFileShapeStore in ogr extension.
	This allows at least that loaded shapefile shape stores
	can be saved correctly in the thuban session file
	and reloaded again (reload is via core shapefile
	routine, not OGR). For other types, .thuban files
	can not be reloaded for the time being.

	* Extensions/ogr/ogrshapes.py (OGRFileShapeStore): New. This
	class ist to be used for any file-based shape stores
	accessed through OGR.

	* Extensions/ogr/ogrstart.py (open_with_ogr): Added
	forgotten _ for i18n. Adapted call OpenFileShapestore
	regarding new parameter.
	(OpenFileShapestore): Use OGRFileShapeStore instead of
	OGRShapeStore. Fix return value (None instead of null).
	Add new parameter "mainwindow" to avoid accessing global
	context.

2005-04-27  Jan-Oliver Wagner <jan@intevation.de>

	Introduce FileShapeStore as generalization for
	file-based shape stores. In a first instance
	this allows additional modules to handle shapefile
	format as well, namely the OGR extension.

	* Thuban/Model/data.py: Various small fixes in doc-strings.
	(FileShapeStore): New class.
	(ShapefileStore): Derive from FileShapeStore.
	(ShapefileStore.__init__): Call __init__ of FileShapeStore,
	rename self.table to self._table, initialize self._bbox
	(ShapefileStore._open_shapefile): Use self._bbox instead of self.bbox
	and self.FileName() instead of self.filename.
	(ShapefileStore.Table): Use self._table instead of self.table.
	(ShapefileStore.FileName): Removed (moved to FileShapeStore).
	(ShapefileStore.BoundingBox):  Use self._bbox instead of self.bbox.

	* Thuban/Model/save.py: Replace ShapefileStore by FileShapeStore.
	(SessionSaver.write_data_containers): Only use methods of the
	base class FileShapeStore.

2005-04-26  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/wms.py (render_wms_layer): Adjusted the render
	function to the modified render engine

2005-04-25  Martin Schulze  <joey@infodrom.org>

	* Thuban/UI/renderer.py (MapRenderer.projected_raster_layer):
	Added a description according to the CVS log message

2005-04-23  Martin Schulze  <joey@infodrom.org>

	* Thuban/UI/renderer.py: Added a missing import

2005-04-23  Russell Nelson  <nelson@crynwr.com>

	* Thuban/UI/view.py (MapCanvas.OnMiddle{Up,Down}): Changed the
	way the previous tool is remembered, so that middle-button
	panning works even if you haven't selected a tool.

2005-04-11  Bernhard Herzog  <bh@intevation.de>

	* libraries/thuban/wxproj.cpp: Move the compatibility code that
	deals with the wxPython 2.4 version of wxPython.h into the #ifdef
	branch that includes wxPython.h because it's only needed when
	wxPython.h is used.  Also, it won't compile when
	USE_WX_PYTHON_SWIG_HACK is set otherwise.

2005-04-07  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/classifier.py (ClassGrid.__init__): Use -1 as the ID.
	(ID_CLASS_TABLE): Removed. It wasn't used anywhere except in
	ClassGrid.__init__ and it's value is outside of the valid
	range (must be < 32768).  wxPython 2.5 complains about it with an
	exception.

2005-04-05  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: More translations.

2005-04-05  Bernhard Herzog  <bh@intevation.de>

	* libraries/thuban/wxproj.cpp: Make it work with a wxPython.h from
	wxPython 2.4 as well.  Also, remove a now obsolete comment.

2005-04-05  Bernhard Herzog  <bh@intevation.de>

	Use wxPython.h by default but provide a workaround when it isn't
	available.

	* setup.py (wxproj_extension): New variable.  Assign the Extension
	instance for Lib.wxproj to this variable instead of putting it
	directly into the listso that it can be accessed by other code
	later.
	(thuban_build_ext.user_options): Added boolean option
	--use-wx-python-swig-hack.
	(thuban_build_ext.initialize_options): Initialize the new option
	to False.
	(thuban_build_ext.finalize_options): If the new option was given,
	define the preprocesser macro USE_WX_PYTHON_SWIG_HACK.
	(thuban_build_ext): Update the doc-string

	* libraries/thuban/wxproj.cpp: Normally we use
	wx/wxPython/wxPython.h now.  Only if USE_WX_PYTHON_SWIG_HACK is
	defined, use swigPtrConvertHack.h instead.

	* libraries/thuban/swigPtrConvertHack.h: Remove the code that was
	copied over from wxPython.h.
	(decode_pointer_new): New.  Equivalent of decode_pointer for
	wxPython 2.5.
	(wxPyConvertSwigPtr): Modified to cope with wxPython 2.5 as well.

	* README: Add section on potential build problems which explains
	how the work-around for a missing wxPython.h is activated.

2005-03-29  Bernhard Herzog  <bh@intevation.de>

	* test/postgissupport.py (find_postgis_sql): Added yet another
	potential location for (lw)postgis.sql because the file has moved
	again in postgis 1.0.0 rc4.

2005-03-29  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/legend.py (BMP_SIZE_W, BMP_SIZE_H): Set both to 16 to
	match the site of the legend_icon_layer icon.  Otherwise wxpython
	2.5 complains when the legend is created with the error:

	PyAssertionError: C++ assertion "(bitmap.GetWidth() == m_width &&
	bitmap.GetHeight() == m_height) || (m_width == 0 && m_height ==
	0)" failed in ./src/generic/imaglist.cpp(81): invalid bitmap size
	in wxImageList: this might work on this platform but definitely
	won't under Windows.

2005-03-23  Jonathan Coles <jonathan@intevation.de>

	These changes add support for adjusting the opacity of a raster layer.

	* Thuban/Model/layer.py (RasterLayer.Opacity): Replaces AlphaOpacity.
	(RasterLayer.SetOpacity): Replaces SetAlphaOpacity. Also triggers
	a LAYER_CHANGED event if the opacity actually changes.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_data): Added
	layer parameter needed in the implementation of this method in
	renderer.py.

	* Thuban/UI/layerproperties.py (LayerProperties.dialog_layout): Fixed
	typo 00 -> 0.

	* Thuban/UI/rasterlayerproperties.py (RasterLayerProperties): Added
	control to adjust opacity.

	* Thuban/UI/renderer.py (MapRenderer.draw_raster_data): Scale the 
	alpha data based on the opacity level of the layer. 

	* test/test_baserenderer.py (SimpleRenderer.draw_raster_data): Now
	accepts a layer parameter.

	* test/test_layer.py (TestLayerModification.test_raster_layer): 
	Rename opacity method calls and add test for LAYER_CHANGED.

2005-03-16  Bernhard Herzog  <bh@intevation.de>

	* test/test_connector.py (DeletionTestMixin.check_deletions)
	(DeletionTestMixin.check_deletetions): renamed to check_deletions.
	update the callers.

2005-03-14  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: More translations.

2005-03-10  Jan-Oliver Wagner <jan@intevation.de>

	Introducing initialization callbacks for extensions.

	* Thuban/UI/extensionregistry.py (ExtensionDesc.__init__): Added
	optional parameter init_callback.
	(ExtensionDesc.init_ext): New. Executes the callback and sets
	a status.

	* Thuban/UI/application.py (ThubanApplication.OnInit): Add the
	initialization of the extensions.
	(ThubanApplication.init_extensions): Init all extensions.

	* Thuban/UI/about.py (About.__init__): Added status of the extensions
	to the about text.

	* Extensions/gns2shp/__init__.py: Added init method for Extension
	description.
	(init): New. Contains the initialization of the module.

2005-03-04  Nina Hüffmeyer <nhueffme@intevation.de>

	* Extensions/ogr/ogrdialog.py: Added a dialog, which asks for
	OGRConnection to open a datasource. Removed dialog to display all
	available drivers. Added some doc strings.

	* Extensions/ogr/ogrstart.py: Added menu entry for opening an
	OGRDatasource with a string. Added two opening methods which return an
	OGRDatasource (either data from file or from DB).

	* Extensions/ogr/ogrshapes.py: Added class OGRGeometry, which
	represents a geometry reference of an OGRFeature. OGRShape now has a
	list of referenced geometry objects (important for geometry
	collections).
	For OGRShapeStores loaded from a DB an ID column can be specified now.

2005-02-22  Jan-Oliver Wagner <jan@intevation.de>

	* test/test_map.py (TestMapWithContents.test_tree_info):
	Added label layer for comparison.

2005-02-18  Jonathan Coles <jonathan@intevation.de>

	* libraries/thuban/gdalwarp.cpp (GetImageData): Optimize the loop
	which builds a mask. Handle the majority of an image in a loop,
	creating 8 bits at a time. Later, handle the edge case where less
	than 8 bits are packed. 

2005-02-18  Bernhard Herzog  <bh@intevation.de>

	* test/test_baserenderer.py (TestBaseRenderer.setUp): Fix
	doc-string

2005-02-18  Jonathan Coles <jonathan@intevation.de>

	* setup.py: Remove wx_cs_params from gdal compile options.

2005-02-18  Jonathan Coles <jonathan@intevation.de>

	Refactored baserenderer.py and renderer.py to remove baserenderer.py's
	dependencies on wxPython. Added a new method projected_raster_layer()
	that returns a raster layer image in projected space. This must be
	implemented in classes derived from BaseRenderer. This also eliminates
	the dependency on gdal in baserenderer.py.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_layer): Call
	new projected_raster_layer() to get projected raster image instead
	of directly calling ProjectRasterFile().
	(BaseRenderer.projected_raster_layer): New. This must be implemented
	by derived classes. It takes almost the same arguments as ProjectRasterFile
	did and returns a projected image with mask and alpha data (if requested).
	(BaseRenderer.render_map_incrementally): Remove the check for gdal since
	that check will be done in MapRenderer.projected_raster_layer(). This
	also allows other implementations to use different projection code.

	* Thuban/UI/renderer.py (MapRenderer.projected_raster_layer):
	Implementation of BaseRenderer.projected_raster_layer. Checks for 
	gdal support and wxPython version. Also handles exceptions from
	ProjectRasterFile.

	* libraries/thuban/gdalwarp.cpp: Removed checks for wxPython versions
	and added a variable which can be set through the options argument
	of ProjectRasterFile.

	* test/test_baserenderer.py (SimpleRenderer.projected_raster_layer): New.
	Calls ProjectRasterFile and returns the result.
	(TestBaseRenderer.test_projected_raster_layer): New. Tests the results
	of calling projected_raster_layer() with different options.
	(TestBaseRenderer.test_raster_no_projection): Removed tests based on
	wxPython version and all tests of masks and alpha channels. These are
	now in test_projected_raster_layer().

2005-02-17  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/Model/map.py, Thuban/Model/label.py: Fixed
	doc-strings to comply with coding_guidelines.

2005-02-17  Jan-Oliver Wagner <jan@intevation.de>

	Docstring improvements and minor fixes for labellayer.

	* Thuban/Model/map.py:
	(Map, Map.Destroy, Map.RemoveLayer, Map.ClearLayers,
	Map.Layers, Map.HasLayers, Map.MoveLayerToTop,
	Map.RaiseLayer, Map.LowerLayer, Map.MoveLayerToBottom,
	Map.ProjectedBoundingBox, Map.GetProjection): Improved/added
	doc string.
	(Map.BoundingBox): Removed superfluous test for label_layer
	and improved doc string.
	(Map.TreeInfo): Added label_layer and improved sdo string.

	* Thuban/Model/label.py: Added import of _.
	(Label, Label.__init__): Improved/added doc string.
	(LabelLayer, LabelLayer.__init__, LabelLayer.Labels,
	LabelLayer.RemoveLabel, LabelLayer.ClearLabels):
	Improved/added doc string.
	(LabelLayer.AddLabel): Use already defined names for
	align strings and improved doc string.
	(LabelLayer.TreeInfo): New. Return the object data for
	the tree view.

2005-02-16  Jonathan Coles <jonathan@intevation.de>

	Further wxPython 2.5 changes using patches from Daniel Calvelo Aros 
	so that that wxproj doesn't crash. Added GUI support for selecting
	alpha channel (opacity can't be selected yet).

	NOTE: If wxPython.h is including in future distribution packages
	then it will not be necessary to have the files swigPtrConvertHack.h
	and wxPython_int.h included with Thuban. This is hopefully
	a temporary workaround.

	* setup.py (thuban_build_ext.finalize_options): gdalwarp needs
	access to the macro wxCHECK_VERSION so that it will properly 
	generate a bit mask. There was a problem between wx2.4 and wx2.5
	that this works around.

	* Thuban/Model/layer.py (RasterLayer.UseMask): Removed in favor
	of RasterLayer.MaskType.
	(RasterLayer.SetUseMask): Removed in favor of RasterLayer.SetMaskType
	(RasterLayer.MaskType): New. Returns the type of mask to use. Can
	specify none, a bitmap, or an alpha channel.
	(RasterLayer.SetMaskType): New. Set what kind of mask to use.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_layer):
	Set the raster warping options for the mask based on the value
	of RasterLayer.MaskType.

	* Thuban/UI/legend.py (LegendTree.__FillTreeLayer): Remove 
	deprecated calls to SetItemSelectedImage in favor of SetItemImage
	with wxTreeItemIcon_Selected.

	* Thuban/UI/rasterlayerproperties.py: Support selecting to use
	an alpha channel for the mask.

	* Thuban/UI/renderer.py (MapRenderer.draw_raster_data): Use alpha
	data if it is available and an alpha channel is supported under
	the current version of wxPython.

	* libraries/thuban/gdalwarp.cpp (GetImageData): Added compiler define
	to select whether 1's or 0's select the desired portion of an image
	in the bit mask. wx2.4 has a bug where the documentation is the opposite
	from behavior.
	(ProjectRasterFile): Only generate an alpha channel if the version
	of wxPython is >= 2.5.3.

	* libraries/thuban/wxproj.cpp: Applied patches from Daniel Calvelo Aros.
	When wxPython >= 2.5.3 use the special swig functions to decode an
	object's address.

	* libraries/thuban/swigPtrConvertHack.h: Includes conditional code
	based on the version of wxPython. If >= 2.5.3 use the special swig
	functions from wxPython to decode wxPython objects, otherwise use
	the old method of retrieving the address from the object __repr__ string.

	* libraries/thuban/wxPython_int.h: Copied from wxPython source. 
	Unnecessary code was removed to make it smaller. 

	* test/test_baserenderer.py (TestBaseRenderer.test_raster_no_projection):
	Add tests for returning an alpha channel.

	* test/test_layer.py (TestLayerModification.test_raster_layer): Fix
	tests that used removed functions UseMask and SetUseMask


2005-02-08  Bernhard Herzog  <bh@intevation.de>

	More wxPython 2.5 changes.  This time taken from a patch from
	Daniel Calvelo Aros.

	* Thuban/UI/tableview.py (QueryTableFrame.__init__)
	(QueryTableFrame.__init__): Pass the size of a spacer as a single
	item.

	* Thuban/UI/projdialog.py (ProjFrame.build_dialog)
	(ProjFrame.build_dialog): Pass the size of a spacer as a single
	item.

	* Thuban/UI/dbdialog.py (ChooseDBTableDialog.__init__): Pass the
	size of a spacer as a single item.

	* Thuban/UI/classifier.py (Classifier.dialog_layout): Pass the
	size of a spacer as a single item.

2005-02-08  Bernhard Herzog  <bh@intevation.de>

	Compatibility with wxPython 2.5.  The changes should make it work
	better with 2.5 while still keeping compatibility with 2.4.  There
	are still problems with 2.5, though.

	* Thuban/UI/dock.py (DockableWindow.__CreateBorder): Pass the size
	of a spacer as a single item.

	* Thuban/UI/classifier.py (ClassGroupPropertiesCtrl): Derive only
	from wxControl

	* Thuban/UI/legend.py (LegendTree): When running with wxPython <
	2.5, add an implementation of the GetFirstChild method that does
	not require the second parameter.
	(LegendTree.find_layer, LegendTree._OnMsgMapLayersAdded)
	(LegendTree._OnMsgMapLayersRemoved, LegendTree.DeleteAllItems)
	(LegendTree.DeleteChildren, LegendTree.__ShowHideLayer): Do not
	pass the second parameter to GetFirstChild

2005-02-08  Nina Hüffmeyer <nhueffme@intevation.de>

	* Extensions/ogr/ogrshapes.py: Removed some print commands.

	* Extensions/ogr/ogrstart.py: Changed the GUI. OGR is no longer an
	additional menu but appears as a possibility in the menu Map.

2005-02-07  Jonathan Coles <jonathan@intevation.de>
	* libraries/thuban/gdalwarp.cpp: Removed the macros PYTHON_ERR
	and PYTHON_ERRF since they were no longer necessary.

2005-02-07  Bernhard Reiter <bernhard@intevation.de>
	* Thuban/UI/classifier.py (ClassGrid.DeleteSelectedRows):
	Enable translation for message string.

2005-02-06  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/infodialog.py (wmsInfoDialog.__init__): Adjusted
	the arguments of the contstructor to fit the global scheme

2005-01-31  Nina Hüffmeyer <nhueffme@intevation.de>

	* Extensions/ogr/ogrdialog.py: Added class ogrdialog.py, which provides
	some dialogs needed to start ogr.
	
	* Extensions/ogr/__init__.py: Changed comments to avoid encoding
	warnings.

	* Extensions/ogr/test/test_OGRShapestore.py: Changed comments to avoid
	encoding warnings.

2005-01-28  Jonathan Coles <jonathan@intevation.de>

	* libraries/thuban/gdalwarp.cpp (GetImageData): Recode how the
	mask is packed into a bit array. It's now slightly faster.

2005-01-28  Jonathan Coles <jonathan@intevation.de>

	* Thuban/Model/layer.py (RasterLayer.__init__): Make use_mask
	default to true.

	* Thuban/Model/load.py (SessionLoader.start_rasterlayer): Remove 
	code that loads the state of the layer's use_mask flag. Its 
	usefulness is still being debated.

	* Thuban/Model/save.py (SessionSaver.write_layer): Remove
	code that saves the state of the layer's use_mask flag. Its 
	usefulness is still being debated.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_layer): Pass
	options to ProjectRasterFile based on the state of layer.UseMask().
	Catch more exceptions from ProjectRasterFile so that Thuban doesn't
	quit is there is a problem projecting.
	(BaseRenderer.draw_raster_data): Change the documentation to 
	describe the new format (XBM) that the mask data will be in.

	* Thuban/UI/renderer.py (MapRenderer.draw_raster_data): The mask
	data is in XBM format when format='RAW' which means it doesn't 
	need to be converted to a wxImage before being used as a mask
	for a wxBitmap. Assume that if format != 'RAW' that the image
	data and mask data are in the same format.

	* libraries/thuban/gdalwarp.cpp (GetImageData): If alpha is enabled
	and a mask is requested, convert the alpha band to a bit array in 
	XBM format. if an alpha channel is requested, simply return the 
	data in the alpha band. Provide better error handling by returning
	python error messages (also fixes RT #2947).
	(ProjectRasterFile): Support multiple mask options, rather than simply
	a flag indicating that a mask should or should not be used. Provide 
	better error handling by returning python error messages.

	* test/test_baserenderer.py (TestBaseRenderer.test_raster_no_projection):
	Add mask data to test.

	* test/test_layer.py (TestLayer.test_raster_layer): Test that a layer
	should use the mask by default.
	(TestLayerModificaton.test_raster_layer): Test that a layer should use 
	the mask by default.

	* test/test_load.py (TestRasterLayer.test): Remove testing for
	use_mask flag in file.

	* test/test_save.py (SaveSessionTest.testRasterLayer): Remove testing
	for use_mask in file.

	* test/test_load_1_0_1.py: Removed. Shouldn't have been checked in.
	
2005-01-26  Jonathan Coles <jonathan@intevation.de>

	Add a new dialog box for raster layers. The dialog box allows
	the user to toggle a mask that is generated by ProjectRasterFile
	and is used to only draw the real parts of the projected image.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_layer):
	Instruct the warping code to generate a mask if the raster layer 
	requests one. 
	(BaseRenderer.draw_raster_data): Removed obsolete optional mask argument.

	* Thuban/UI/renderer.py (MapRenderer.draw_raster_data): Removed
	obsolete optional mask argument.

	* Thuban/UI/classifier.py (Classifier): Change the parent class
	to LayerProperties and rework the code to support layout calls
	from the parent.
	(Classifier.dialog_layout): New. Layout the dialog box.
	(Classifier.map_layers_removed): Removed. Moved to parent class.
	(Classifier.map_replaced): Removed. Moved to parent class.
	(Classifier._OnTry): Renamed to OnTry to support parent class.
	(Classifier.OnClose): Removed. Supplied in parent class.
	(Classifier._OnCloseBtn): Removed. Supplied in parent class as OnCloseBtn.
	(Classifier._OnOK): Renamed to OnOK to support parent class.
	(Classifier._OnRevert): Renamed to OnRevert to support parent class.

	* Thuban/UI/layerproperties.py: New. Base class for layer properties
	dialog boxes.

	* Thuban/UI/rasterlayerproperties.py: New. Class for displaying
	raster layer properties.

	* libraries/thuban/gdalwarp.cpp: Replace the old gdalwarp.cpp code
	with the non-simple version supplied with gdal. This allows added
	features such as creating an alpha band.
	(GetImageData): Generate a mask array from the alpha band that is 
	generated by gdal if the user has selected it. Try to support images 
	that have more than three bands, such as images with RGB plus an 
	alpha band.
	(ProjectRasterFile): Convert python argument for mask and tell
	gdal to enable or disable an alpha band.

	* Thuban/Model/layer.py (BaseLayer.Type): New. Returns a string
	describing what kind of layer the class is. Defaults to "Unknown",
	but should be overridden by subclasses.
	(Layer.Type): New. Override base class method.
	(RasterLayer.__init__): Create a flag for using a mask. Record extra 
	data from gdal for display in the properties dialog.
	(RasterLayer.Type): New. Override base class method.
	(RasterLayer.UseMask): New. Returns True if the mask should be used.
	(RasterLayer.SetUseMask): New. Set if the mask should be used.
	(RasterLayer.ImageInfo): New. Return extra information about the image.

	* Thuban/Model/load.py (SessionLoader.start_rasterlayer): Load
	the mask information.

	* Thuban/Model/save.py (SessionSaver.write_layer): Save mask information.

	* Thuban/UI/mainwindow.py: Register the RasterLayerProperties and
	Classifier classes as dialogs to use with the proper layer types.

	* test/test_baserenderer.py (TestBaseRenderer.test_raster_no_projection):
	Fix test.

	* test/test_layer.py (TestLayer.test_raster_layer): Test new methods.
	(TestLayerModification.build_path): New. Support function.
	(TestLayerModification.test_raster_layer): New. Test new methods.

	* test/test_save.py (SaveSessionTest.testRasterLayer): Add tests for mask.

	* test/test_load.py (TestRasterLayer): Add tests for mask.

	* test/test_load_1_0_1.py: New. Copied from test_load.py.

	* test/test_baserenderer.py (SimpleRenderer.draw_raster_data): Removed
	obsolete optional mask argument.

2005-01-26  Nina Hüffmeyer <nhueffme@intevation.de>

	* Extensions/ogr/ogrshapes.py: Added two dictionaries to ShapeStore 
	which maps the ids and the ordinals. Fixed RowIdToOrdinal(),
	RowOrdinalToId() and ReadRowAsDict().

	* Extensions/ogr/ogrstart.py: Added menu item which opens database
	layers for existing database connections.

	* Extensions/ogr/test/test_OGRShapestore.py: Fixed a message string.


2005-01-26  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: More translations.

2005-01-24  Bernhard Herzog  <bh@intevation.de>

	Rework the status bar updates a bit to make sure the message about
	the projections is produced at the right times.

	* Thuban/UI/mainwindow.py (MainWindow.update_status_bar_messages):
	New class variable with messages that may require a status bar
	update.
	(MainWindow.view_position_changed)
	(MainWindow.update_status_bar): Rename from view_position_changed
	to update_status_bar.  It's meaning has changed now that it may
	also generate messages about problems with projection settings.
	(MainWindow.__init__): Use the new update_status_bar_messages
	class variable to subscribe update_status_bar
	(MainWindow.set_position_text): Update doc-string.  This method
	has to be renamed at some point.  See doc-string and comments.
	(MainWindow.OnClose): Unsubscribe update_status_bar from all
	messages in update_status_bar_messages

	* Thuban/UI/viewport.py (ViewPort.forwarded_map_messages): New
	class attribute.  map messages to be forwarded by the viewport.
	(ViewPort._subscribe_map, ViewPort._unsubscribe_map): (un)subscribe
	the messages in forwarded_map_messages

2005-01-21  Bernhard Herzog  <bh@intevation.de>

	* test/postgissupport.py (PostGISDatabase.__init__): Tweak
	doc-string
	(find_postgis_sql): Update for postgis-1.0.0-rc1, which uses a
	different name for the initialization SQL file.

2005-01-21  Jonathan Coles <jonathan@intevation.de>

	* Thuban/UI/baserenderer.py (proj_params_to_str): New. Takes
	a projection and returns a formatted string representing the 
	parameters to feed to gdalwarp. This function eliminates
	redundancy in draw_raster_layer().
	(BaseRenderer.render_map_incrementally): Removed the optimization which
	drew the top most raster layer first and then only those vector-
	based layers that are above it. With the support for transparency
	this optimization breaks correct behaviour.
	(BaseRenderer.draw_raster_layer): Reorganize code to support possible
	future enhancements to raster layer bounding box. The old behaviour has
	not changed. Also, change calling parameters to draw_raster_data()
	to specify new RAW data format and mask.
	(BaseRenderer.draw_raster_data): Change signature to include an optional
	parameter for mask information. Change documentation to mention
	support for new parameter and added option for RAW data format.
	The data argument is now a list of [width, height, data].

	* Thuban/UI/renderer.py (MapRenderer.draw_raster_data): Add new optional
	mask parameter. Add new condition for RAW format, which 
	significantly reduces rendering time. Add condition for 
	mask parameter.

	* libraries/thuban/gdalwarp.cpp (GetImageData): New. Creates a 
	data array of RGB values from the projected image returned from 
	the gdal warping functions. In the case of palette based images, it
	converts the NO_DATA index to the mask color.
	(ProjectRasterFile): Removed all custom memory driver references
	and replaced it with the standard in-memory dataset provided
	by gdal. The return data is no longer a BMP file, but an array
	of RGB values, one set triple per pixel.

	* libraries/thuban/bmpdataset.cpp: Removed. Unnecessary.
	* libraries/thuban/cpl_mfile.h: Removed. Unnecessary.
	* libraries/thuban/cpl_mfile.cpp: Removed. Unnecessary.

	* setup.py (thuban_build_ext.finalize_options): Removed mention
	of cpl_mfile.cpp and bmpdataset.cpp files in the list of source
	files. These are obsolete with the new version of gdalwarp.cpp

	* test/test_baserenderer.py (SimpleRenderer.draw_raster_data):
	Updated signature.
	(TestBaseRenderer.test_raster_no_projection): Changed the test
	data to be data in the uncompressed RAW format returned from
	ProjectRasterFile.

2005-01-21  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.view_position_changed): Made
	string available for i18n.

2005-01-20  Russell Nelson  <nelson@crynwr.com>

	* Resources/Projections/defaults.proj: Ruin the speling of the
	Lambert-93 projection so it doesn't run into the wx UTF-8 bug.
	It's the wrong thing to do in the long run, but it's necessary for
	those users until that bug is fixed.  Otherwise the projection
	dialog segfaults.  Better to annoy some Lambert-93 users with a
	spelling mistake than every Fedora Core 3 user of Thuban-CVS.

2005-01-20  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.view_position_changed): Added
	docstring and comment that the warning code here is a hack.

2005-01-20  Russell Nelson  <nelson@crynwr.com>

	* Thuban/UI/mainwindow.py (MainWindow.view_position_changed): Warn
	user about misprojected layers when their lat/lon bounding
	box exceeds rational lat/lon values.

2005-01-20  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/about.py (unicodeToLocale): Improved:
	Use 'ascii' and then 'replace' for other characters 
	when getdefaultlocale returns None. Thanks to Bernhard H. .

2005-01-20  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/classgen.py (GenQuantilesPanel.OnRetrieve): Added a comment
	that OnRangeText might be called twice and using None as argument.

2005-01-20  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/classgen.py (GenQuantilesPanel.OnRetrieve): Add a
	OnRangeText(0) to work around a different in wx Behaviour noticed
	on MacOSX, thanks to Lorenzo Moretti and Daniel Calvelo for the fix.

2005-01-20  Bernhard Reiter <bernhard@intevation.de>

	* Thuban/UI/about.py: take iso-8859-15 when getdefaultlocale returns
	None. (Fixes rt#2910.)
	
2005-01-18  Frank Koormann <frank@intevation.de>

	New Extension: mouseposition
	Tool to collect mouse click positions (map coordinates) in a dialog.
 
	* Extensions/mouseposition/__init__.py: New, extension registration

	* Extensions/mouseposition/mouseposition.py: New, implements the 
	dialog and adds a tool to Thuban mainwindow.

	* Extensions/mouseposition/position.xpm: New, icon for tool.

2005-01-14  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: More translations.

2005-01-11  Frank Koormann <frank@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.DuplicateLayer):
	Fix indention bug.

2005-01-09  Frank Koormann <frank@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.DuplicateLayer):
	BugFix 2901: Explicitly copy layers ClassificationColumn since it 
	is not part of the layers Classification.

2005-01-03  Frank Koormann <frank@intevation.de>

	* Thuban/UI/renderer.py (ScreenRendererdraw_selection_incrementally):
	BugFix 2883: Former implementation only worked on classified point 
	layers: KeyError was raised, now use the default size if field is None. 

2004-12-27  Bernhard Reiter <bernhard@intevation.de>

	svgexport 1.0.0cvs: Fixed label export.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	class TestSVGRenderer(): New class; new test test_label_font().

	* Extensions/svgexport/svgmapwriter.py
	(SVGRenderer.label_font()): initialised Font size with self.factor now, 
	makes test_label_font happy.

	* Extensions/svgexport/TODO: crossed out fixed label export item.
	Added item for options.

	* Extensions/svgexport/__init__.py: Bumped version to 1.0.0cvs.

2004-12-27  Russell Nelson  <nelson@crynwr.com>

	Middle mouse button pans.

	* Thuban/UI/view.py (MapCanvas.__init__): Subscribe also
	OnMiddleDown and OnMiddleUp events.
	(MapCanvas.OnMiddleDown): New. Activate the pan tool and remember the
	previously used tool.
	(MapCanvas.OnMiddleUp): New. Reactivate the remebered tool used before
	pressing the middle mouse button.

2004-12-27  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: More translations.

2004-12-23  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/projdialog.py (ProjFrame.load_user_proj): Added a
	\n to stderr after the warnings. Thanks to Russell Nelson.

2004-12-20  Nina Hueffmeyer <nhueffme@intevation.de>

	* Extensions/ogr/ogrshapes.py: Fixed some issues from 
	Bernhard (coding guidelines etc.). Additionally it is now possible to 
	display shapefiles containing feature collections (e.g.polygons 
	with holes). Works with gdal 1.2.1 now.

	* Extensions/ogr/test/test_OGRShapestore.py: Fixed some issues
	from Bernhard (coding guidelines etc.). If ogr can't be imported,
	tests are skipped now.

	* Extensions/ogr/ogrstart.py: Fixed some typings.

2004-12-20  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/TODO: updated to add support for 
	raster layers and labels for 1.0.1.

	* Extensions/svgexport/svgmapwriter.py (draw_raster_layer):
	Issue a warning now.

2004-12-19  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/TODO: Added idea to support triggering
	the application down the pipe.

2004-12-19  Bernhard Reiter <bernhard@intevation.de>

	svgexport: Improved code quality, mainly by better naming.

	* Extensions/svgexport/svgmapwriter.py:
	DrawPath() renamed to DrawPolygonPath(),
	added documentation, improved comments and variable names.
	
	* Extensions/svgexport/svgmapwriter.py,
	  Extensions/svgexport/test/test_svgmapwriter.py:
	All using DrawPolygonPath() now, the default parameter closed=True
	omitted.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	renamed test_polygon_opened() to test_polyline()
	renamed test_transparent_polygon() to test_transparent_polyline()

2004-12-18  Jan-Oliver Wagner <jan@intevation.de>

	Some fixes of gns2shp extension.

	* Extensions/gns2shp/test/__init__.py: New. Make this directory a
	package.

	* Extensions/gns2shp/test/test_gns2shp.py: Add some import paths
	dynamically.

	* Extensions/gns2shp/test/README: Simplified description how to test.

	* Extensions/gns2shp/gns2shp.py (gns2shp): Fixed doc-string,
	fixed some dimensions of fields according to the GNS documentation
	which seems to change undocumented.
	Now killing trailing \n and/or \r from MODIFY_DATE.
	This fixes RT#2453.

2004-12-18  Bernhard Reiter <bernhard@intevation.de>

	svgexport 1.0.0: Treats holes and islands nicely. Documentation added.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	Added new tests: test_export_polygon_with_hole() 
	and test_polygon_with_hole().

	* Extensions/svgexport/svgmapwriter.py
	(draw_polygon_shape()): Uses DrawPath correctly now.

	* Doc/manual/thuban-manual.xml: Added documentation for stable
	extention svgexport.	
	* Doc/manual/thuban-manual-de.xml: Copied English section about
	svexport over.

	* Extensions/svgexport/__init__.py: Bumped version number to 1.0.0.

	* Extensions/svgexport/svgsaver.py,maplegend.py: 
	Moved from experimental to stable extension menu.

	* Extensions/svgexport/TODO: updated.


2004-12-18  Bernhard Reiter <bernhard@intevation.de>

	Added Extensions/svgexport/TODO

2004-12-18  Bernhard Reiter <bernhard@intevation.de>

	Refactored in svgexport:
	DrawPath replaces DrawPolygon; added newline in front of "M" in paths.

	* Extensions/svgexport/svgmapwriter.py
	Added verbosity level 3 to print out polygon points.
	(class Point): added __repr__
	(class Brush, __str__()): Added space after ,.
	(DrawPolygon): Renamed to DrawPath()
	(DrawPath): Takes list of polygons as input now, adds \n before "M"s.
	(DrawLines): Using DrawPath now.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	Replaced DrawPolygon() calls with DrawPath() and put the first argument
	inside another list. Adapted test data with a newline before "M".

2004-12-18  Bernhard Reiter <bernhard@intevation.de>
	
	Refactored svgexport tests: 9 double tests runs eliminated; 
	code size reduced by 8 lines.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	(class TestWithDC): Renamed to BaseTestWithDC, moved to top.
	(class BaseWithDCtools): New, subclass from BaseTestWithDC.
	(class TestDrawSplines): now subclass from BaseTestWithDCtools, 
	this fixed the double running of the nine tests of TestVirtualDC.
	(class TestVirtualDC): Using self.dc and self.file from setUp().

2004-12-17  Bernhard Herzog  <bh@intevation.de>

	Two windows specific fixes ported from thuban-1­0-branch:

	* Thuban/UI/about.py (unicodeToLocale): Use getdefaultlocale
	instead of getlocale because getlocale doesn't return a usable
	encoding name on a german windows 2000

	* setup.py: windows build: Removed the absolute path names and
	made all prfixes relative to the directory containing setup.py.
	Makes it a little easier to adapt to a different system.

2004-12-16  Bernhard Herzog  <bh@intevation.de>

	Add support for PostGIS tables with LINESTRING geometries.
	Fixes RT#2299

	* Thuban/Model/postgisdb.py (shapetype_map): Add LINESTRING

	* test/postgissupport.py
	(PostgreSQLServer.get_default_static_data_db): Rename the "roads"
	table to "roads-multi" because it now uses MULTILINESTRING
	geometries and introduce a new "roads" table that uses LINESTRING
	(coords_to_multilinestring): Make the doc string more precise
	(coords_to_linestring): New.  Create a LINESTRING WKT
	representatin
	(wkt_converter): Add coords_to_linestring
	(upload_shapefile): Rephrase the doc-string a bit.

	* test/test_postgis_db.py (TestPostGISShapestoreArc)
	(LineStringTests)
	(TestPostGISShapestoreLineString)
	(TestPostGISShapestoreMultiLineString): Split
	TestPostGISShapestoreArc into a base class LineStringTests and two
	derived classes TestPostGISShapestoreLineString for LINESTRING
	geometries and TestPostGISShapestoreMultiLineString for
	MULTILINESTRING geometries.  Most test methods are in the base
	class with the exception of tests that explicitly check the raw
	format.

2004-12-16  Bernhard Herzog  <bh@intevation.de>

	Make the test suite work with PostGIS 0.8.2 and PostgreSQL 7.4

	* test/postgissupport.py (find_postgis_sql): Different postgis
	versions put the postgis.sql file into slightly different places
	so we have to look in both.  The updated doc string describes this
	is more detail.

	* test/test_postgis_db.py
	(TestPostGISSpecialCases.test_column_name_quoting): The return
	value of UniqueValues is unsorted, so it has to be sorted for
	comparison.

2004-12-16  Bernhard Herzog  <bh@intevation.de>

	Fix for RT#2237

	* Thuban/UI/projdialog.py (ProjFrame._show_proj_panel): If the
	panel to be shown is the UnknownProjPanel disable the OK and Try
	buttons.  Otherwise enable them.
	(ProjFrame.__GetProjection): The UnknownProjPanel returns None for
	the parameters.  In that case __GetProjection also returns None
	now.

2004-12-15  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/classgen.py (GenQuantilesPanel.__init__): Set the
	minimum number of classes to 2.  The calculate_quantiles needs at
	least two and raises an exception otherwise.  
	Fixes RT#2549

2004-12-15  Bernhard Herzog  <bh@intevation.de>

	* test/postgissupport.py (PostgreSQLServer.execute_sql): Extend to
	so that it returns a result for select statements.
	(PostgreSQLServer.server_version): New.  Return the version of the
	server software.
	(PostgreSQLServer.require_authentication): The format of
	pg_hba.conf has changed between PostgrSQL 7.2 and 7.3.  Check the
	server version and generate the file in the correct format

2004-12-15  Bernhard Herzog  <bh@intevation.de>

	* test/postgissupport.py (PostgreSQLServer.is_running): Fix typo
	in the doc string and rephrase it a little.

2004-12-15  Frank Koormann <frank@intevation.de>

	* test/test_load.py (TestAltPath.checkSession): New, extended checks if
	session has been loaded successfully. The check is called by the relevant
	tests after executing load_session().

2004-12-13  Bernhard Herzog  <bh@intevation.de>

	Make sure the region used to determine which shapes are visible
	actually matches the region on the printed page.  If this isn't
	done properly some shapes might not be printed.  
	Fixes RT #2692

	* Thuban/UI/view.py (MapPrintout.draw_on_dc): The region for the
	renderer has to be at the same position as the mapregion

	* Thuban/UI/renderer.py (ExportRenderer.RenderMap): self.region
	has to be moved by (self.shiftx, self.shifty) too.

2004-12-13  Bernhard Herzog  <bh@intevation.de>

	* libraries/pyprojection/Projection.i: Work around a bug in the
	generated python code which leads to exception in the __del__
	method when the constructor fails.  See the comments in the code
	for more details.

	* libraries/pyprojection/Projection.py: Updated from Projection.i
	with SWIG.

2004-12-13  Bernhard Herzog  <bh@intevation.de>

	* test/test_load.py (TestAltPath.test_01_single_path_error_fix)
	(TestAltPath.test_02_path_error_fix_from_list)
	(TestAltPath.test_05_path_error_fix_from_list_changed)
	(TestAltPath.test_06_path_error_fix_from_list_fails): self.session
	is destroyed in tearDown, so there's no need to do it in a test
	case.

	* Thuban/Model/load.py (SessionLoader.open_shapefile): Remove a
	debug print

2004-12-13  Bernhard Herzog  <bh@intevation.de>

	* Extensions/svgexport/test/test_svgmapwriter.py
	(TestDrawSplines.setUp): Do not use super with the unittest
	classes because in Python 2.2 they're still old-style classes.

2004-12-13  Frank Koormann <frank@intevation.de>

    Alternative Path feature: When loading a (moved) session where 
	shapefiles cannot be found, ask the user. Use the specified path 
	if further shapefiles are missing. However, ask the usr for confirmation 
	in such cases.

	* test/test_load.py (TestAltPath): New, tests for alternative path feature
	in load_session()
	(Shapefile_CallBack): Helper, implements controllable callback.

	* Thuban/UI/application.py (ThubanApplication.OnInit): 
	Added "alt_path" to self.path
	(ThubanApplication.OpenSession): Added shapefile_callback as second 
	callback similar to db_connection_callback.
	(ThubanApplication.run_alt_path_dialog): New, implementaion of
	shapefile_callback. In addition to raising the dialog the control of
	self.path('alt_path') is implemented here.

	* Thuban/Model/load.py (SessionLoader.__init__): Added shapefile_callback.
	(SessionLoader.open_shapefile): Open shapefile, eventually with 
	alternative path. This wrapps the "theSession.OpenShapefile(filename)" 
	formerly used in start_fileshapesource()/start_layer().
	(SessionLoader.start_fileshapesource): Call open_shapefile().
	(SessionLoader.start_layer): Call open_shapefile().
	(load_session): Added shapefile_callback.

	* Thuban/UI/altpathdialog.py: New, implements dialogs for alternative path
	feature (search / check).
	
	* Doc/manual/thuban-manual.xml: Added documentation of new feature.

2004-12-11  Bernhard Reiter <bernhard@intevation.de>

	 svgexport 0.9.2: Point size supports for maps.

	* Extensions/svgexport/svgmapwriter.py: Added import of SHAPETYPE_POINT
	(def draw_point_shape): new parameter size defaults to 2 as before.
	(draw_shape_layer_incrementally): Moved draw_func log line higher.
	Added draw_func call with size when dealing with a point layer.

	* Extensions/svgexport/__init__.py: bumped version to 0.9.2.
	
2004-12-11  Bernhard Reiter <bernhard@intevation.de>

	Made sure that newlines are inserted in the svg path d attributes
	to raise the chance that the line length will be below 255 characters,
	as recommended by REC SVG 1.1 in section 8.3.1.

	* Extensions/svgexport/svgmapwriter.py(DrawPolygon):
	Adding \n before L's and changed whitespace handling.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	Adapted tests to new whitespace handling of DrawPolygon.

2004-12-11  Bernhard Reiter <bernhard@intevation.de>

	* Doc/technotes/coding_guidelines.txt: easy typo fixed. 

	* Extensions/svgexport/test/test_svgmapwriter.py:
	Removed test_drawbezier in favour of new test_drawspline3 and 
	test_drawspline4 within new class TestDrawSplines(TestVirtualDC).
	All only to test DrawSpline.

	* Extensions/svgexport/svgmapwriter.py(DrawSpline):
	New implementation now really using the strange algorithm of
	xfig 3.1's approximated splines and its conversion to postscript
	with one twist: SVG can do quadratic beziers, so skipped translation
	to cubic beziers.
	(TestWithDC): Typo in comment fixed.

2004-12-09  Martin Schulze  <joey@infodrom.org>

	* Thuban/Model/classgen.py: Added missing character encoding

	* Extensions/wms/properties.py (OpenWMSProperties): removed

	* Extensions/wms/parser.py (WMSCapabilitiesParser.error): Dropped
	support for get_srs_discrepancies() since there are no
	discrepancies anymore (was a thinko)

	* Extensions/wms/layer.py (WMSLayer.GetMapImg): Improved graphic
	format priority now that more formats are supported globally by
	the render engine. 

2004-12-08  Silke Reimer <silke@intevation.de>
	* Extensions/ogr/ogrshapes.py: Substituted ogr-method CloseRings
	because it is not available in all versions of ogr

2004-12-08  Bernhard Reiter <bernhard@intevation.de>
	* Extensions/ogr/__init__.py: Added empty __init__.py to heal 
	global tests until a real one is commited.

2004-12-07 Nina Hüffmeyer <nhueffme@intevation.de>

	* /Extensions/ogr/: Adding a new extension to read shapefiles with
	ogr. It is planned to add other vector formats.

	* /test/runtests.py: Adding tests from /Extensions/ogr/test/.

2004-12-07  Jan-Oliver Wagner <jan@intevation.de>

	* /Extensions/svgexport/test/test_svgmapwriter.py: Reverting
	part of a (non-)fix to renable that the tests are always
	executed.

2004-12-07  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/test/test_svgmapwriter.py:
	Added test_drawbezier() to test DrawSpline().

	* Extensions/svgexport/svgmapwriter.py(DrawSpline):
	Really implemented bezier drawing.

	* Extensions/svgexport/__init__.py: Bumped version of svgexport
	to 0.9.1 because now the legend examples lines styles 
	will be drawing with beziers.

2004-12-05  Martin Schulze  <joey@infodrom.org>

	* Thuban/UI/renderer.py (raster_format_map): Added PNG, TIFF and
	GIF as supported bitmap image formats (helpful for the WMS extension)

2004-11-30  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/test/test_ogclib.py (TestOGCLib.test_compareURLs):
	Improved the test for the internal compare method

2004-11-27  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/about.py (About.__init__): Added
	Norbert Solymosi for hungarian translation and Ole Rahn
	as contributor. Moved Bernhard Reiter from Contributor
	to Developer.

2004-11-27  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/test/test_svgmapwriter.py:
	Removed Jan from author list as he did not change enough significant
	lines yet.

	* Extensions/svgexport/__init__.py: Added Bernhard as author
	of the Extension.

2004-11-27  Jan-Oliver Wagner <jan@intevation.de>

	* po/hu.po: New. Hungarian translation. Contributed
	by Norbert Solymosi.

2004-11-26  Bernhard Herzog  <bh@intevation.de>

	* Extensions/svgexport/test/test_svgmapwriter.py
	(Testobjectexport.test_transparent_polygon): Commented out some
	debug prints

2004-11-24  Jan-Oliver Wagner <jan@intevation.de>

	Fix broken tests for svg extension and added svg legend
	to Experimental menu.

	* Extensions/svgexport/test/test_svgmapwriter.py: Fix to have
	the test run correctly even if the extension is a package.
	Also removed the "import Thuban" which makes no sense.

	* Extensions/svgexport/__init__.py: Fix to have the extensions'
	test module also be executed from the global test routine.
	This is done by looking for the absense of the DISPLAY variable.

	* Extensions/svgexport/maplegend.py: Moved the menu entry from Extensions
	to Experimental menu since this module has yet not reached a stable
	status (ie. 1.0).

2004-11-22  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/svgmapwriter.py:
	Added verbose variable and some logging depending on it.
	(class VirtualDC(XMLWriter)): Minor improvement in the polygon loop, 
	because counting i is not necessary.
	(class Pen, class Brush): Added simple __str__ methods.
	(SVGRenderer.draw_polygone_shape): Fix #2698 (transparent polygons are
	not exported to svg file) Note: holes still unhandled.

	* Extensions/svgexport/test/test_svgmapwriter.py:
	        Made a baseclass TestWithDC for test needed a DC.
		Added tests for bug #2698 (transparent polygons are not
		exported to svg file):
		Testobjectexport.test_transparent_polygon()

	* Thuban/Model/base.py (UnsetModified):
	Fixed some typos in docstring.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_polygon_shape()):
	Added hints on the used algorithm for handling holes.

2004-11-20  Jan-Oliver Wagner <jan@intevation.de>

	Some face lifting for the examples.

	* Examples/__init__.py: Make this directory a package.

	* Examples/simple_extensions/__init__.py: Make this directory a package.

	* Examples/simple_extensions/hello_world.py: Moved entry from Extensions
	menu to Examples menu.

	* Examples/simple_extensions/simple_command.py: Some more comments,
	minor changes.

	* Examples/simple_extensions/simple_tool.py: Minor changes.

2004-11-20  Jan-Oliver Wagner <jan@intevation.de>

	Changed way of extension registry for wms and added extension
	registry for umn_mapserver extension.

	* Extensions/wms/__init__.py: Added registry entry and the importing
	of the actual wms module. Included a test for the required PyOGCLib.

	* Extensions/wms/wms.py: Removed registry entry (moved to __init__.py).

	* Extensions/umn_mapserver/__init__.py: Added registry entry and the
	importing of the actual umn mapserver management modules.
	Included a test for the required Python MapScript.

2004-11-20  Jan-Oliver Wagner <jan@intevation.de>

	Changed way of extension registry for importAPR, bboxdump
	and added extension registry for svgexport.extension registry for
	svgexport.

	* Extensions/importAPR/__init__.py: Added registry entry and the importing
	of the actual importAPR module.

	* Extensions/importAPR/importAPR.py: Removed registry entry (moved to
	__init__.py).

	* Extensions/bboxdump/__init__.py: Added registry entry and the importing
	»···of the actual bboxdump module.

	* Extensions/bboxdump/bboxdump.py: Removed registry entry (moved to
	»···__init__.py).

	* Extensions/svgexport/__init__.py: Added registry entry and the importing
	of the svgsaver module.

	* Extensions/svgexport/svgsaver.py: Moved the menu entry from Extensions
	to Experimental menu since this module has yet not reached a stable
	status (ie. 1.0).

2004-11-18  Jan-Oliver Wagner <jan@intevation.de>

	Now the hit test considers the size of point symbols.

	* Thuban/UI/viewport.py (ViewPort._hit_point): Added optional parameter
	'size' defaulting to the previously fixed value 5.
	Extended doc-string.
	(Viewport._find_shape_in_layer): Resolved FIXME regarding flexibility
	for symbols.
	Now the size of the largest point symbol is determined to find out
	about whether the point has been hit.
	This fixes the problem that only clicks inside a fixed distance of
	5 where found.

2004-11-17  Jan-Oliver Wagner <jan@intevation.de>

	Another open issue fixed regarding sizeable symbols: correct rendering of
	selected symbols.

	* Thuban/UI/renderer.py (ScreenRenderer.draw_selection_incrementally):
	Added consideration of the specific size of point symbols.
	The property for each point symbol is retrieved and the size applied
	for the rendering method.
	Added doc-string.

2004-11-16  Jan-Oliver Wagner <jan@intevation.de>

	Changed way of Extension Registry for gns2shp and profiling.

	* Extensions/gns2shp/gns2shp.py: Removed registry entry (moved to
	__init__.py).

	* Extensions/gns2shp/__init__.py: Added registry entry and the importing
	of the actual gns2shp module.

	* Extensions/profiling/profiling.py: Removed registry entry (moved to
	__init__.py).

	* Extensions/profiling/__init__.py: Added registry entry and the importing
	of the actual profiling module.

2004-10-28  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/: Minor improvements to doc strings.

2004-10-07  Jan-Oliver Wagner <jan@intevation.de>

	Further elements for sizable point objects now
	making this feature usable though not yet complete.

	* Thuban/Model/save.py (SessionSaver.write_classification): Write
	attribute 'size' for cldata when the shape layer is of point type.
	This also now make the test_load.py tests happy.

	* Thuban/Model/classgen.py (CustomRamp.GetProperties): Added size
	gradient.

	* Thuban/UI/classifier.py (ID_SELPROP_SPINCTRL): Renamed to
	ID_SELPROP_SPINCTRL_LINEWIDTH.
	(ID_SELPROP_SPINCTRL_LINEWIDTH): New Id replaces ID_SELPROP_SPINCTRL.
	(ID_SELPROP_SPINCTRL_SIZE): New Id.
	(SelectPropertiesDialog.__init__): Added a second spin control
	for the size in case the corresponding layer is of point type.
	(SelectPropertiesDialog._OnSpin): Renamed to _OnSpinLineWidth.
	(SelectPropertiesDialog._OnSpinLineWidth): New. Former _OnSpin.
	(SelectPropertiesDialog._OnSpinSize): New. Set size of property
	and refresh preview.



2004-10-04  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/test/test_parser.py
	(TestWMSCapabilitiesParser.test_compareLists): Added missing
	self-test for compareLists()
	(TestWMSCapabilitiesParser.test_compareDicts): Added missing
	self-test for compareDicts()
	(TestWMSCapabilitiesParser.test_compareLists): Adding more tests
	to verify the test routine fails with non-equal arguments 
	(TestWMSCapabilitiesParser.test_compareDicts): Adding more tests
	to verify the test routine fails with non-equal arguments 

2004-10-03  Jan-Oliver Wagner <jan@intevation.de>

	First elements for sizeable point objects.

	* Resources/XML/thuban-1.1.dtd: Added size attribute to cldata.

	* Data/iceland_sample_size.thuban: New. Sample for sized point objects.

	* test/test_load.py (ClassificationTest.TestLayers): Added SetSize in case
	of a corresponding argument is given.
	(TestSymbolSize): New. Test the size attribute of cldata.

	* Thuban/Model/classification.py: Removed some trailing whitespaces.
	(ClassGroupProperties.__init__): Set default size.
	(ClassGroupProperties.SetProperties): Set the size.
	(ClassGroupProperties.GetSize): New. Return the size.
	(ClassGroupProperties.SetSize): New. Set the size.
	(ClassGroupProperties__eq__): Compare also size.
	(ClassGroupProperties__repr__): Print also size.

	* Thuban/Model/load.py (SessionLoader.start_cldata): Also parse
	the size attribute.

	* Thuban/UI/classifier.py (ClassDataPreviewer.Draw): Added doc-string.
	Also, now there is a return value that indicates whether the drawing
	size exceeded the given rect extent and if so the new extent.
	Finally, point objects are drawn depending on the size. If either
	the width or height is exceeded, the new extent is returned.
	(ClassRenderer.Draw): Now when calling the previewer drawing function,
	evaluate the return value and, if not None, adapt the grid widget size
	accordingly and redraw again.

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_shape_layer_incrementally):
	If the draw function is for points, call it with the size as additional
	parameter.
	(BaseRenderer.draw_point_shape): Added additional, optional parameter for
	the size. Compute the radius using the size.

	* Extensions/importAPR/apr.py (APR_BMkSym.GetThubanProp): Now
	that Thuban supports size, apply this correctly.

	* Extensions/importAPR/importAPR.py: Bumped version to 0.1.1.

2004-10-03  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml: Started translation of
	Map chapter.

2004-10-01  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/properties.py (wmsProperties.__init__): Extended
	argument for general use through properties-dialog selector
	
	* Thuban/UI/classifier.py: Register properties dialog classes for
	both provided layer classes/types.

	* Thuban/UI/mainwindow.py (MainWindow.OpenLayerProperties): The
	map can be retrieved through the parent which is passed to the
	constructor anyway and doesn't require an argument of its own,
	required for the unification of arguments for general use through
	properties-dialog selector.
	(MainWindow.OpenOrRaiseDialog): Move the logic for checking
	whether a dialog is already opened (and raising it to the users
	attention) and creating a new dialog into a function of its own
	(MainWindow.OpenLayerProperties): Use the new OpenOrRaiseDialog()
	method
	(MainWindow.OpenLayerProperties): Utilise the new ClassMapper for
	global registration of properties dialog classes (which are indeed
	layer-specific).

	* Thuban/UI/classifier.py (Classifier.__init__): Unify arguments
	for general use through properties-dialog selector, the map can be
	retrieved through the parent and doesn't require an argument of
	its own.

	* Extensions/wms/wms.py: Register the properties dialog class for
	the provided WMS layer

2004-09-28  Jan-Oliver Wagner <jan@intevation.de>

	New feature: Registry for Extensions.

	* Thuban/UI/extensionregistry.py: This module defines a registry for
	Extensions.

	* Thuban/UI/about.py (About.__init__): Added description
	of the registered extensions with all of the information.

	* Thuban/Model/extension.py (Extension): Improved doc-string.

	* Extensions/gns2shp/gns2shp.py, Extensions/importAPR/importAPR.py,
	Extensions/bboxdump/bboxdump.py, Extensions/profiling/profiling.py,
	Extensions/wms/wms.py: Added registration of the extension.

2004-09-27  Bernhard Reiter <bernhard@intevation.de>

	More fixes to svgexport to make used ids unique and
	conforming to XML's Name production. 

	* Extensions/svgexport/test/test_svgmapwriter.py: Added new tests
	test_xml_id_constraints(), test_make_ide_nosetbaseid() and
	test_make_id_nonintegersetid().  Switched SetID and SetBaseID.
	Added Bernhard R. as author.
	* Extensions/svgexport/svgmapwriter.py (make_id): Using "_" as
	concatenation char now (makes test_make_ide_nosetbaseid() valid).
	Also transform second id part with "%d" and catch the TypeError
	to raise SVGMapWriterError (making test_make_id_nonintegersetid() ok).
	Corrected typo inBernhard's author line.
	(SetBaseID): Return the transformed base id. Transform characters
	which are not alnum() or in ".-_" to binascii.b2a_hex(). Added
	import binascii. If to be set string starts with "xml" or so, add "t".
	(draw_shape_layer_incrementally): use the returned value of SetBaseID
	for used_baseids checks.

2004-09-25  Bernhard Herzog  <bh@intevation.de>

	* test/test_layer.py (TestLayer.test_arc_layer_with_projection):
	Remove a debug print and some tab characters.

2004-09-25  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/svgmapwriter.py: Added Bernhard R. as Author.
	(SetBaseID, SetID, make_id): Improved docstring comments to explain
	the interaction of the three functions and the XML id contrains.


2004-09-23  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/ThubanModel.xmi: New. UML file for Thuban Model
	Module.

	* Doc/README: Added info on ThubanModel.xmi.

2004-09-23  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/README: New. Some info about how to generate technical
	documentation from the source code.
	This text was send to the Thuban developer mailing list on
	September 21st 2004 by Bernhard Reiter.

2004-09-21  Bernhard Reiter <bernhard@intevation.de>

	Improved the svgexport to only use unique ids. Will issues 
	an error message dialoge when two layer names are the same.
	ShapeIDs are now added with a dash within the svg ids.

	* Extensions/svgexport/svgmapwriter.py (SVGMapWriterError): New.
	* Extensions/svgexport/test/test_svgmapwriter.py: Added imports
	(TestSVGRenderer): New test class with test_make_in() and
	test_check_for_layer_name_clash()
	* Extensions/svgexport/svgmapwriter.py (SVGRenderer): Fixed __init__()
	and draw_shape_layer_incrementally() to not use a baseid twice, 
	satisfying test_check_for_layer_name_clash()
	(VirtualDC.make_id): Use a dash between baseit and id, satisfies
	test_make_in().
	* Extensions/svexport/svgsaver.py: Import SVGMapWriterError, wxOK
	and wxICON_HAND. 
	(write_to_svg): Put dc and rendering in a try statement and on
	catching SVGmapWriterError notify the user and delete the target file.

2004-09-20  Bernhard Reiter <bernhard@intevation.de>

	* Model/base.by, Model/layer.py: Fixed typos in docstrings.

2004-09-03  Jan Schüngel  <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile(MF_Class.add_thubanstyle): Fix a
	small bug with the line color. Now the line color will now only set
	if it is set in Thuban an not Transparent. 
	
	* Extensions/umn_mapserver/mf_export(tblayer_to_map): Fixed a bug with
	deleting the layers from mapfile. Now all layers will delete backwards 
	from the last.

2004-08-20  Silke Reimer <silke@intevation.de>

	* Thuban/Model/layer.py:
	Fixes bug in projection handling: Otherwise very large region might not
	have valid values in the layer's projection.

2004-08-20  Silke Reimer <silke@intevation.de>

	* Thuban/UI/about.py:
 	small changes to be consistent with coding style.
	  
2004-08-13  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/test/test_ogclib.py (TestOGCLib.compare_URLs):
	Adjusted a comment

2004-08-11  Silke Reimer <silke@intevation.de>

	* Thuban/UI/about.py: Small changes to encoding related stuff to avoid
		too many and too enhanced imports of locale

2004-08-10  Silke Reimer <silke@intevation.de>

	* Thuban/UI/about.py: Fixed encoding problem of about dialog: Added
		function unicodeToLocale() to convert special characters to users
		locale encoding

2004-08-10  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/technotes/coding_guidelines.txt: Added rule 'Method names start with
	lower case letter'

2004-08-09  Jan Schüngel  <jschuengel@intevation.de>

	* ChangeLog: Rewrite the last ChangeLog entry to follow 
	the standard way.

	* Extensions/umn_mapserver/mapfile: Moved the import AnnotationLayer to
	the function where it is needed, because it don't works if it stands
	at the beginning.
	(MF_Layer.__init__): Removed the extra numclassed variable. Now
	numclasses from the mapscript will be used.
	(MF_Layer.get_index): New. Return the index of the layer in mapfile.
	(MF_Layer.set_classes): New. A Classlist will be set to the layer.
	(MF_Layer.set_metadata): New. A Metadata mapscript object will set.
	(MF_Layer.remove_allclasses): New. All class of the layer will remove.
	(MF_Map.create_new_layer): New. A new Layer is created and associated
	with the mapscript object.
	(MF_Map.set_layerorder): New. The Layer order like in thuban is set in
	the mapscript.
	(MF_Map.add_thubanlayer): Now a new layerobj is created if no one is
	linked to the layer in thuban, else the layerobject linked to the
	thubanlayer will be used.
	AnnotationLayer will now store the filename of the shapefile.
	(MF_Map.remove_layer): If a layer is removed the associated object
	must be set new.
	
	* Extensions/umn_mapserver/mf_export.py(tb_layer_to_map): Add all
	layers which are exists in thuban to the mapobj. All removed Layers
	will be removed from the mapobj. 
	Added comments to all functions.
	(thuban_to_map): No layer will be removed here.
	
	* Extensions/umn_mapserver/mf_handle.py
	(_has_umn_mapobj_and_selectedlayer): Activating the layer menu. Now
	Layersettings for the mapserver kann be edited.

	* Extensions/umn_mapserver/mf_import.py: Now all layers which are
	imported, will be linked with the associated MF_Layer.
	(import_mapfile): All layers, which are not selected, will be removed.
	Disable the "import layer from mapfile" menu option.

	* Extensions/umn_mapserver/sample/iceland.map: Set the status of the
	Annotation Layer from DEFAULT to OFF. The DEFAULT setting turns the
	layer on permanently.

2004-08-03  Jan Schüngel  <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile.py(MF_Metadata.remove_allmetadata):
	New. This function removes all metadata
	(MF_Layer.set_group): New. Set the group setting.
	(MF_Layer.get_group): New. Get the group setting.
	(MF_Map): Removed the extra numlayers variable, used the mapscript 
	parameter instead.
	(MF_Map.get_numlayers): New. This get numlayers.
	(MF_Map.remove_all_layers): New. Removes all layers from the mapobj.
	(MF_Map.add_thubanlayer): Replaced the exception handling by a check
	if the object is an instance. Also added the annotation layer here to
	export, but only the layer is created in the mapfile.

	* Extensions/umn_mapserver/mf_export.py(export_mapfile): Removed 
	the check if a mapobj exist, because its not needed anymore. The 
	export function is only available if a mapobj exist. 
	Use the new function to remove all layers.
	
	* Extensions/umn_mapserver/mf_handle.py(Layer_Dialog): Added a group
	option and the metadata button.	The layer dialog is temporary disabled.
	(Metadata_CustomDataTable): Added some functions to show the grid
	correct.

	* Extensions/umn_mapserver/mf_import.py: Moved the code for showing 
	the number of layer from import_mapfile to this function.
	(AnnotationLayer): New. This Class shows the Annotation layer in
	thuban. The layer don't do anything. It's only to show the layer
	and to save the layer order.
	(add_annotationlayer): New. Import an annotation layer to thuban.
	(select_layer2import): New. Import only layers to thuban and not 
	the other settings like projection or scalebar.
	(create_new_mapfile): Moved the _has_umn_mapobj function and the 
	create_new_mapfile functions from mf_handle.py to mf_import.py.
	
	* Extensions/umn_mapserver/sample/iceland.map: Added the group
	parameter to the roads and cultural layers. Also added a new
	Annotation Layer for the cultural points.

	* Extensions/umn_mapserver/sample/iceland.html: Added the select
	option for the annotation layer.

	* Extensions/umn_mapserver/sample/index.html: Added the start
	parameter for the annotation layer.

2004-08-01  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual-de.xml (Chapter Session Management):
	translation completed.

	* Doc/manual/thuban-manual.xml (Chapter Session Management):
	Fixed unprecise description for Save Session.

2004-07-31  Jan-Oliver Wagner <jan@intevation.de>

	Started translation of Users Manual into german.

	* Doc/manual/thuban-manual-de.xml: New. German Users Manual.

	* Doc/manual/Makefile: Added build instructions for german
	users manual.

	* Doc/manual/thuban-manual.xml: Minor corrections in Introduction.

2004-07-28  Jan Schüngel  <jschuengely@intevation.de>

	* Extensions/umn_mapserver/mapfile.py(MF_Metadata): Changed all class
	functions. Now all metadata will handle by the function and its not
	needed to initialize it from outside. Therefor the associated mapobj 
	will be stored in the Metadata Object. So we can use the special
	functions from the associated mapobj to get the Metadata.
	Therefor all initialization code for the metadata is removed from the
	other classes.
	(MF_Layer): Added a function to get the metadata object. 
	(MF_Map): Added a function to set the mappath, the path where
	the mapfile ist stored.

	* Extensions/umn_mapserver/mf_export.py(thuban_to_map): Changed the code
	to set the extent in the mapfile. Now the code is set by the displayed
	data in the Thuban-view.
	(export_mapfile): The shapepath is now set empty, until relative
	pathnames are supported.

	* Extension/umn_mapserver/mf_handle.py: Added a dialog to handle
	metadata. Yet only mapfile metadata are supported. Layer and class
	supported are not implemented.
	Added a dialog to handle layer informations. The dialog only shows the
	selected layer at the moment.

	* Extensions/umn_mapserver/mf_import.py(import_mapfile): Changed the
	code for setting the extent in thuban. Now the extent is set to the
	given extent from the mapfile. 
	Fixed a logical mistake. Now the extent is set when realy a layer is
	loaded, and not if one is selected to load.

	* Extensions/umn_mapserver/sample/iceland.html: Added code to zoom and
	move the shown map in the browser.

	* Extensions/umn_mapserver/sample/iceland.map: Added a new metadata
	line to the mapobj and added metadata to the political layer.

	* Extensions/umn_mapserver/test/test_mapserver.py: Changed the test
	for Metadata.

2004-07-26  Martin Schulze  <joey@infodrom.org>

	* Thuban/Lib/classmapper.py (ClassMapper.has): Added the new
	ClassMapper

	* test/test_classmapper.py (TestMapping.test_mapper): Added a Test
	case for the new ClassMapper


2004-07-22  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/viewport.py (ViewPort.VisibleExtent): New.  Return the
	visible extent of the map in projected coordinates

	* test/test_viewport.py (SimpleViewPortTest.test_default_size)
	(SimpleViewPortTest.test_init_with_size): Add some VisibleExtent()
	tests.
	(SimpleViewPortTest.test_visible_extent): New. The real test for
	VisibleExtent()

2004-07-22  Bernhard Herzog  <bh@intevation.de>

	* test/test_viewport.py: Use support.run_tests as the main
	function when running asa script.

2004-07-22  Jan Schüngel <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mf_export.py: Added "import os"
	Removed the old "import Thuban.UI.mainwindow" code.
	(tbextent_to_map): Removed the extra function and at the code direct
	to "thuban_to_map" function.
	(write_creatorcomment): Added. Now a short comment is added to the
	beginning of an generated mapfile.
	(export_mapfile): Now the Path and filename are saved in to variables,
	and not together in one variable. This is needed for the new
	write_creatorcomment function.
		
	* Extensions/umn_mapserver/mf_import.py (import_mapfile): Added the
	import module "re". Also added Range and the ClassGroupRange import 
	from Thuban. Both are needed for the new range expression import.
	(create_rangeexpression): Added. Creates a Range Expression in Thuban
	style from a given mapfile expression.
	(added_rasterlayer): Make some small code changes. The shapepath is
	now stored in an extra variable and the clazz_name is set empty if no
	class name set in the mapfile.
	Changed the Error message for Range Expressions, becaus the new
	function create a error string which will be shown in the dialog.

	* Extensions/umn_mapserver/test/test_mapserver.py: Added a test for the
	range expression import.

2004-07-21  Jan-Oliver Wagner <jan@intevation.de>

	* Extensions/umn_mapserver/README: Added hint that
	installation as root can be avoided. Removed all tabs.

2004-07-16  Bernhard Herzog  <bh@intevation.de>

	* test/test_viewport.py
	(ViewPortTest.test_changing_map_projection): Check that changing
	the projection of an empty map shown in a viewport doesn't lead to
	exceptions in the viewport's handler for the
	MAP_PROJECTION_CHANGED messages

	* Thuban/UI/viewport.py (ViewPort.map_projection_changed): Only
	try to keep the same region visible when the map actually contains
	something

2004-07-15  Jan Schüngel <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile.py: Added a function to get the
	mappath directly from the mapobj. Is needed because of the changes 
	in mf_import.py.
	(MF_Layer.add_thubanclass): Added a new comment.
	(MF_Map.set_extent): Fixed a bug with exporting empty mapobj. If the
	mapobj is empty there is no extent get from thuban an so no one can
	set to th mapobj.
	
	* Extensions/umn_mapserver/mf_import.py (import_mapfile): Updated
	the discription. 
	Split the funktion in to three smaller ones. The new functions are 
	add_rasterlayer, add_polygonlayer and select_layer2import.
	Removed the mapfilepath and filepath initialisation, because its know
	include in the new functions.
	Now nothing will be imported if cancel is pressed in the
	layer choice dialog.

2004-07-14  Jan Schüngel <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile.py: Added ClassGroupDefault to
	import.
	(MF_Symbolset): Removed the extra variable for numsymbols.
	(MF_Class.__init__): Added a comment to the exception clause.
	Removed the extent init, because it was not needed anymore.
	(MF_Layer.add_thubanclass): Added the code to set the class name to
	the expression value from thuban if no label is defined. 
	Added the code to export Range expressions from thuban to the mapfile.
	(MF_Map.set_extent): Removed the exception and replace it by some if
	code. If the size of a map is not defined the size will be set to 1,1.
	This is necessary because if the extent is set, mapscript checks if
	the size is greater than zero.
	(MF_Web): Added the get and set function for the template.

	* Extensions/umn_mapserver/mf_export.py: Added the function to check
	if a mapobject exists and used it to set the status of the menu items.
	If no mapfile exists the settings could not be edditied. 
	Define after which menuitem the exportitem will include.
	
	* Extensions/umn_mapserver/mf_handle.py: Removed the import 
	Thuban.UI.mainwindow clause, because it is not needed.
	Added the command Refresh() to all "OnChangeColor()" functions,
	because the color preview window was not updated on a color change.
	Added the function to check if a mapobject exists and used it to set the
	status of the menu items. If no mapobject exists the settings could not
	be edditied.
	(Map_Dialog): Moved the imagetype selector from the
	Outputformat_Dialog to Map_Dialog and removed Outputformat_Dialog.
	(Web_Dialog): Removed the name label and added the template textbox.

	* Extensions/umn_mapserver/mf_import.py (import_mapfile): Replace
	the exception handling on loading the layers by an if statement. It
	is not necessary to us the exception there.
	The Filepath creation now use os.path.join to build the path.

	* Extensions/umn_mapserver/test/test_mapserver.py: Moved the testMap
	definition from global to the setUp function. Now the testMap will
	initialize new on each test.

	* Extensions/umn_mapserver/sample/iceland.map: Include three new
	classes in the Line Layer, to test logical Expressions.
	Set the status of the class "Point9" in the Point Layer to off
	
2004-07-13  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/baserenderer.py
	(BaseRenderer.render_map_incrementally): Fix a logic bug in the
	optimization that tries not to draw layers under a raster layer.
	The bug was harmless.  All it effectively did was to produce The a
	strange messages about not being able to draw Layer instances for
	all vector layers below a raster layer which would be invisible
	anyway because the raster layer currently always covers the entire
	window

2004-07-08  Jan Schüngel <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile.py: Added code to generade and get
	a list of supported outputformats. This formats are not alle supported
	because there is no possibility to get the outputformat without the
	name known. Make some formal changes to the code.
	(MF_Map.set_name()): Fixed a bug if the name is None.

	* Extensions/umn_mapserver/mf_handle.py: Removed the image_type import
	statement, because its not needed anymore. The Outputformat is now
	given as string from the object. Make some formal changes to the code.

	* Extensions/umn_mapserver/test/test_mapserver.py: Added new test for
	most of the new setting which were added during the last changes.
	Removed the MF_Size Test.
	
	* Extensions/umn_mapserver/test/test.map: Added a new class to the
	cultural Layer to test expressions and the the status of that layer
	from on to default.
	Changed the data path the the correct Thuban Data
	Added the Outputformat Object and Symbol Object
	
2004-07-07  Jan Schüngel <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile.py: Added some new
	settings to edit (outputformat, label, imagetype)

	* Extensions/umn_mapserver/mf_handle.py: Added some setting to
	the Label Dialog and add the OutputDialog.
	Make some changes to the code order.

2004-07-06  Jan Schüngel <jschuengel@intevation.de>

	* Extensions/umn_mapserver/mapfile.py: Added the symbolObj, pointObj
	and line Obj and add the scalebar_status_type, scalebar_style_type and
	scalebar_position_type.
	Added the symbol- and symbolsetObject (MF_Symbol,MF_Symbolset). The
	are only used to create a Symbol like the circle in Thuban.
	Added the scalebarObject (MF_Scalebar)
	(MF_Class): Added set_status and get_status.
	(MF_Layer.add_thubanclass): Added code to set the class status
	(MF_Map): Added code to handle the symbols and scalebar 
	(MF_Label): Added the set_partials and get_partials functions
	
	* Extensions/umn_mapserver/mf_export.py: Added MF_Symbol to import
	from mapfile. Added a function to create a circle object like the one
	from thuban if no one exists.
	
	* Extensions/umn_mapserver/mf_handle.py: All colors are now set when
	press ok in the assosiated dialog and not at the end of the
	colordialog.
	Added the Dialog for the Scalebar.
	(Label_Dialog): Added the offset option

	* Extensions/umn_mapserver/mf_import.py: Added code to import the
	status of the Classes.
	Fixed a bug with the projection. Now the to_meter parameter will be
	added to the Projection only if it doesn't exists. 

2004-07-01  Jan Schüngel <jschuengel@intevation.de>

	Added the functionality to handle the content thuban is not
	able to handle directly.

	* Extensions/umn_mapserver/mf_handle.py: New. This module extents
	Thuban with the possibility to edit the mapfile content.	
	
	* Extensions/umn_mapserver/mf_import.py: Added the possibility
	to import mapfiles without any layer selected. So it is possible 
	to edit the other settings in a mapfile.
	(import_mapfile): Added code to use the editing functions.
	Added the possibility to import the projection to a layer if one
	is defined.
	Status settings (On,Off) will now set in thuban (visible, invisible).
	fixed a bug with with classnames. If no classname is set in mapfile
	the value in Thuban will set to the expression.
	
	* Extensions/umn_mapserver/mf_export.py(export_mapfile): Added the
	possibility to save a new mapfile or use the old one which is 
	imported or new created.
	Added code to use the editing functions.
	Remove some not needed import statements

	* Extensions/umn_mapserver/mapfile.py: Added new types which are
	need for the editing functions.
	Added needed set-functions for the editing functions.
	Added the possibility to export rasterimages.
	Added new classes (MF_Web, MF_Label, MF_Legend, MF_Symbol,
	MF_SymbolSet). MF_Symbol and MF_SymbolSet are not needed at the
	moment.
	(MF_Class.set_thubanstyle): Now point layers will set to a default
	symbol to show a circle in mapserver and not only a 1px dot.
	(MF_Style.__init__): Fixed a bug with the color. Color was not set
	correct before.
	(MF_Size): Removed, because it is not needed.
	
	* Extensions/umn_mapserver/README: Added the hints to use the
	export and editing functions, too.

	* Extensions/umn_mapserver/sample/iceland.map: Added the
	new parameter "UNITS METERS".
	Change the political layer to status OFF.

	* Extensions/umn_mapserver/sample/README: Added some
	more details to setup the sample in the MapServer.
	
2004-06-26  Bernhard Reiter <bernhard@intevation.de>

	* Extensions/svgexport/test/test_svgmapwriter.py: 
	Removed class VFile and used standard StringIO instead.

2004-06-23  Jan Schüngel  <jschuengel@intevation.de>

	Add the export function to the umn_mapserver extension.

	* Extension/umn_mapserver/mf_export.py: New. This module extents
	Thuban with the possibility to export the Thuban content.

	* Extensions/umn_mapserver/mapfile.py: Expand the classes to use
	with the export module. Especially added the possibility to
	add thuban objects directly to the map objects.

	* Extensions/umn_mapserver/mf_import.py: Removed the wxCHANGE_DIR,
	because of the hint from Bernhard Herzog.
	Corrected the handling of absolute pathnames.
	Changed the Text of the Menu-Item, now the beginning is upper case.

	* Extensions/umn_mapserver/README: Added the --with-tiff statement.

2004-06-16  Jan Schüngel  <jschuengel@intevation.de>

	Add a sample and make some changes.

	* Extension/umn_mapserver/mf_import.py: Changed the wxPython.wx
	import from * to explicit used statements. Changed the 
	Thuban.UI.mainwindow import phrase, too.
	(import_mapfile):Corrected a clerical mistake.
	Added wxCHANGE_DIR in OpenFile Dialog.
	Added a MultipleChoiceDialog, to select the layers to load from
	mapfile into thuban. Thereby the projection is only set if one layer
	is selected.
	Added the possibility to handle relative pathnames which uses 
	up-level references.
	Removed some doubled code.
	Corrected an error with integer values used as label in thuban
	ClassGroup.
	
	* Extensions/umn_mapserver/sample: New.

	* Extensions/umn_mapserver/sample/README: New. Describes the
	usage of the sample files.

	* Extensions/umn_mapserver/sample/iceland.map: New. This is
	a suitable .map-file for the iceland data. 

	* Extensions/umn_mapserver/sample/index.html: New. The template
	for the mapfile.  

	* Extensions/umn_mapserver/sample/iceland.html: New. Initialisation
	file for the Iceland Application on web.

	* Extensions/umn_mapserver/README: Corrected a inaccuracy and added
	some details.

	* Extensions/umn_mapserver/test/test_mapserver
	(mapserver_import_Test_generalClasses.test_MF_Color):
	Corrected the thubancolor test.

2004-06-15  Jan Schüngel  <jschuengel@intevation.de>

	* Extensions/umn_mapserver/README: New. Install instruction.

2004-06-14  Bernhard Reiter <bernhard@intevation.de>

	* libraries/thuban/cpl_mfile.h: Added copyright header.

	* libraries/thuban/ cpl_mfile.cpp, cpl_mfile.h: Added non-protecting
	Free Software License so that it is most useful with gdalwarp 
	and bmpdataset.

2004-06-14  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/multiplechoicedialog.py (__version__): Add missing
	import of wxPython.wx itself (as opposed to the contents of
	wxPython.wx).  For some reason wxPython.wx is available as
	wxPython.wx.wx in at least some 2.4 releases.  Fixes RT#2482
	wrt. wxPython 2.4.

2004-06-10  Jan Schüngel  <jschuengel@intevation.de>

	Initial version of new extension "umn_mapserver".  This extension aims
	to manage configuration for the UMN MapServer application.  This
	inital version just imports the .map-files and displays all, Thuban is
	capable of.

	* Extensions/umn_mapserver, Extensions/umn_mapserver/test: New.

	* Extensions/umn_mapserver/test/README: New. Describes how to run the
	tests.

	* Extensions/umn_mapserver/test/test.map: New. This is a test
	.map-file for automated tests of the umn_mapserver extension of
	Thuban.

	* Extensions/umn_mapserver/test/test_mapserver.py: New. Tests for
	UMN Mapserver classes.

	* Extensions/umn_mapserver/__init__.py: New. Init to make this
	directory a package.

	* Extensions/umn_mapserver/mapfile.py: New. Classes to represent
	'.map'-file objects.

	* Extensions/umn_mapserver/mf_import.py: New. This module extends
	Thuban with the possibility to handle UMN MapServer mapfiles.

2004-06-03  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/layer.py (Layer.TreeInfo): Convert the bounding box
	to a tuple before using it as arguments to the % operator.  This
	fixes the formatting issue filed in RT#2239 on 2004-01-13 and
	reported today on thuban-list by Jan Schüngel

	* test/test_layer.py (TestLayerModification.setUp): Save the
	filename as an instance variable so we can refer to it in tests
	(TestLayerModification.test_tree_info): Uncomment this method
	again and make it work.  This tests for the formatting issue
	filed in RT#2239 on 2004-01-13

2004-05-28  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/baserenderer.py: Fix some typos.

2004-05-18  Jan-Oliver Wagner <jan@intevation.de>

	* Extensions/gns2shp/gns2shp.py (gns2shp): Fixed a bug
	by increasing a field size.

2004-05-17  Bernhard Herzog  <bh@intevation.de>

	Update to newest shapelib and get rid of Thuban specific
	extensions, i.e. use the new DBFUpdateHeader instead of our
	DBFCommit kludge

	* libraries/shapelib/shpopen.c: Update to version from current
	shapelib CVS.

	* libraries/shapelib/shapefil.h: Update to version from current
	shapelib CVS.

	* libraries/shapelib/dbfopen.c: Update to version from current
	shapelib CVS.
	(DBFCommit): Effectively removed since shapelib itself has
	DBFUpdateHeader now which is better for what DBFCommit wanted to
	achieve.  
	We're now using an unmodified version of dbfopen.

	* setup.py (extensions): Add the HAVE_UPDATE_HEADER macro with
	value '1' to the Lib.dbflibc extension.  This simply reflects the
	shapelib and pyshapelib updates

2004-05-16  Jan-Oliver Wagner <jan@intevation.de>

	Finished introduction of Menu.FindOrInsertMenu.

	* Extensions/drawshape/drawshape.py: Add the command
	to the experimental menu additionally to the toolbar.

	* Extensions/svgexport/svgsaver.py: Use FindOrInsertMenu() instead of
	finding menu on its own.

	* Doc/manual/thuban-manual.xml: updated sample file
	to use FindOrInsertMenu().

	* Examples/simple_extensions/hello_world.py: Use FindOrInsertMenu()
	instead of finding menu on its own.

2004-05-11  Jan-Oliver Wagner <jan@intevation.de>

	* test/test_menu.py (MenuTest.test): Added testing
	of method Menu.FindOrInsertMenu.

2004-05-10  Jan-Oliver Wagner <jan@intevation.de>

	Introduce and use Menu.FindOrInsertMenu.

	* Thuban/UI/menu.py (Menu.FindOrInsertMenu): New. Find a
	  given menu or, if not found, insert it.

	* Extensions/bboxdump/bboxdump.py, /Extensions/gns2shp/gns2shp.py,
	/Extensions/importAPR/importAPR.py, Extensions/profiling/profiling.py,
	/Extensions/wms/wms.py: Use FindOrInsertMenu() instead of finding
	menu on its own.

2004-05-06  Jan-Oliver Wagner <jan@intevation.de>

	Introduce a abstract ColorDialog class and remove
	and outdated file.

	* Thuban/UI/proj4dialog.py: Removed. It is has been
	replaced by projdialog for quite a while and is not used
	anymore.

	* Thuban/UI/colordialog.py: New. Abstraction for color selection
	dialog(s).

	* Thuban/UI/classifier.py (SelectPropertiesDialog.__GetColor):
	Now calls the abstract ColorDialog instead of wxColourDialog.
	This also removed the dependency to Color class conversion
	from this function.

2004-05-04  Frank Koormann  <frank@intevation.de>

	* Extensions/bboxdump/__init__.py: Fixed string left over from 
	copying.

	* Extensions/bboxdump/bboxdump.py (bboxdump): 
	Use layer.ShapeStore().AllShapes() to loop over shapes instead of 
	xrange(layer.NumShapes()). Compile the bboxmessage from a list 
	of formatted outputs (string.join) instead of appending to the
	message. Two progress bar dialogs to report progress on the sometimes
	lenghty processing.

2004-04-22  Frank Koormann  <frank@intevation.de>

	New Extension to dump bounding boxes of all shapes of the selected 
	layer. An optional column can be specified to group the objects, 
	in this case the bounding box is a union of the separate boxes.
	Dump can be displayed in a ScrolledMessageDialog or written to file. 
	The Extension is simply a combination of available and well tested
	Thuban functionality.

	* Extensions/bboxdump/__init__.py: New: Init to make this
	directory a package.

	* Extensions/bboxdump/bboxdump.py: New: Dump bounding boxes of 
	all shapes of the selected layer.

2004-04-22  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/classgen.py (GenUniquePanel.__init__): Fixed two
	strings to be i18n now.

2004-04-18  Jan-Oliver Wagner <jan@intevation.de>

	Changing popup menu of legend from direct building
	to using the Menu construction as used for the mainwindow.

	* Thuban/UI/mainwindow.py: New method commands: layer_to_top,
	layer_to_bottom, layer_visibility
	(MainWindow.LayerToTop): New. Put current layer to the top.
	(MainWindow.LayerToBottom): New. Put current layer to bottom.
	(MainWindow.HideLayer, MainWindow.ShowLayer, _has_visible_map):
	Replace 1,0 by True, False.
	(MainWindow.ToggleLayerVisibility): New. Toggle visibility of
	current layer.
	(MainWindow.LayerShowTable): Removed raising of dialog.
	(_has_selected_layer_visible): New. Support function.

	* Thuban/UI/legend.py: ID_POP_xxx: removed.
	(LegendPanel.__init__): Removed EVT_MENU bindings.
	(LegendTree._OnRightClick): Replace direct creation of
	menu via wx Classes by applying the menu definition
	as of Menu class of menu.py.
	
2004-04-16  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/exceptiondialog.py (ExceptionDialog.dialog_layout): Improved
    button string to stronger clearify that Thuban will be closed when hitting
	the button.

	* Thuban/UI/mainwindow.py (MainWindow.LayerShowTable): Added docstring.
	Now for layers without a ShapeStore a corresponding message is given
	to the user, that this layer has no table to show.

2004-04-15  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/layer.py (WMSLayer.setWMSFormat): Need to
	recalculate the format for the internal render engine as well.

	* Extensions/wms/properties.py (wmsProperties): First start for a
	properties dialog.  It's functional for a first selection of
	layers, but still has some weired wxWidgets/GTK problems but
	beautification can be done later.

	* Extensions/wms/layer.py: Added more documentation
	(WMSLayer.getFormats): New: Return list of supported image formats
	by the WMS server
	(WMSLayer.getLayers): New: Return the list of layer names
	supported by the WMS server
	(WMSLayer.getLayerTitle): New: Return the title of the named layer
	(WMSLayer.getWMSFormat): New: Return the image format that is used
	for WMS GetMap requests
	(WMSLayer.setWMSFormat): New: Set the image format that is used
	for WMS GetMap requests
	(WMSLayer.__init__): Move away from using only one layer to using
	a list of layers (unsorted at the moment, though).
	(WMSLayer.getVisibleLayers): New: Return the list of names for all
	visible layers
	(WMSLayer.setVisibleLayers): New: Set the list of names for all
	visible layers

	* Extensions/wms/wms.py: Moved the WMS layer into layer.py in
	order to establish a clean structure.

	* Extensions/wms/layer.py: Moved the WMS layer into a file on its
	own in order to establish a clean structure.

2004-04-13  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/parser.py (WMSCapabilitiesParser.grok): Added
	support for oldstyle (WMS 1.0 apparently) image format
	specification.

	* Extensions/wms/wms.py (WMSLayer.calcFormat): Reduce the list of
	supported graphic formats back to JPEG and BMP, PNG and others are
	too *cough* experimental...  Sorry, I meant to filter this out
	before I committed this part.  This should make the WMS extension
	run from CVS again.
	(wms_dialog): Reset an empty URL to None so that the subsequent
	program can depend on this, since the dialog will indeed return an
	empty URL, causing another declaration of love by Python.

	* Extensions/wms/parser.py (WMSCapabilitiesParser.getLayerBBox):
	Whenever a native BoundingBox request cannot be fulfilled, check
	whether the requested SRS is EPSG:3426, in which case return the
	LatLonBoundingBox values.

	* Extensions/wms/test/test_parser.py
	(TestWMSCapabilitiesParser.test_LayerSRS): Added a test for
	ignoring AUTO:* SRS.
	(TestWMSCapabilitiesParser.test_LatLonBoundingBoxes_as_bboxes):
	Added another test method to test whether the LatLonBoundingBox
	values will be returned if BoundingBox values are requested with
	SRS set to EPSG:3426.

	* Extensions/wms/parser.py (WMSCapabilitiesParser.peekLayers):
	Added rudimentary support for non-EPSG SRS, i.e. ignore them for
	the moment by placing them into a variable which is currently
	unused.  Also test whether the EPSG SRS is numerical as it should
	be and add an error message if it is not.

	* Extensions/wms/test/sample.xml: Added AUTO:* SRS since they
	appear in the real world as well.  Since we cannot handle them yet
	(OGCLib can't either), we will ignore them for the moment.

	* Extensions/wms/parser.py: Use a variable for denoting the sample
	filename
	(WMSCapabilitiesParser.peekLayers): Added support for error
	messages during grok().  They will be aggregated in an array and
	may be displayed later.  We may have to add a classification
	"Warning" and "Error" to this.  That requires more experience,
	though, since not every error may be lethal.

	* Thuban/UI/mainwindow.py (MainWindow.LayerShowTable): Raise the
	ShowTable() dialog/frame when the user attempts to display it
	while it has been opened before already and not closed again.

2004-04-11  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/infodialog.py: Adjusted the class documentation

	* Extensions/wms/wms.py (WMSLayer.__init__, WMSLayer.GetMapImg):
	Switch to using Thuban{Begin,End}BusyCursor instead of the pure
	wxWidgets variants.
	(WMSLayer.__init__): The epsg_id variable is named top_srs now.

	* Extensions/wms/infodialog.py: Added an information dialog that
	will display various information about the WMS current resource,
	so that additional information such as the title, the abstract,
	fees and access constraints can be displayed for the user if they
	are documented in the WMS XML.

2004-04-10  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/parser.py (WMSCapabilitiesParser.grok): Adjusted
	string handling.  It's "foo".lower() and not lower(foo) without
	lower imported from strings or something.

	* Extensions/wms/wms.py (WMSLayer): Incorporated WMSCapabilities
	from capabilities.py and parser.py.  Implement priority list for
	supported graphics formats, take care of wbmp != bmp.  PNG, TIFF
	and GIF are supported here, but not yet by main Thuban.  Hence,
	support for them may be removed later.  Special contribution to
	usability: get wxWidgets to change the cursor when we're waiting
	for data from the network so the user won't start to worry.  This
	causes a redrawing error/warning, though.

	* Extensions/wms/parser.py (WMSCapabilitiesParser.grok): Unlink
	the DOM object.

2004-04-01  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/capabilities.py: Adjusted documentation
	(WMSCapabilities.__init__): Improved documentation, fixed syntax
	(WMSCapabilities.saveCapabilities): Only catch IOError when
	handling files
	(WMSCapabilities.loadCapabilities): Only catch IOError when
	handling files
	__main__: corrected variable naming
	(WMSCapabilities.fetchCapabilities,loadCapabilities): Make this
	class a specialisation of WMSCapabilitiesParser as well.  Also
	execute grok() after loading or fetching capabilities, if that
	went well, so that subsequent calls can already access the data.
	(WMSCapabilities.getVersion): Export the used version of the
	GetCapabilities request, so we can use it for subsequent calls,
	i.e. for GetMap requests.
	(WMSCapabilities.fetchCapabilities): Added proper error handling
	when the GetCapabilities request failed, so that the surrounding
	program can act accordingly.

2004-03-30  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/parser.py (WMSCapabilitiesParser.getLayerSRS):
	Adjusted the getLayerSRS method to return the list of SRSes
	extracted from <SRS> elements instead of <BoundingBox> elements.
	Added a bit of documentation as well.
	(WMSCapabilitiesParser.checkLayerSRS): Removed integrity test
	since it was only implemented due to a misunderstanding.

	* Extensions/wms/test/test_parser.py
	(TestWMSCapabilitiesParser.test_LayerSRS): Adjust the tests to
	reflect the corrected interpretation of the standard: i.e. a layer
	does not have to define a BoundingBox for all SRSes it supports.
	Hence the <SRS></SRS> specification is authoritative, not the list
	of BoundingBoxes.
	(TestWMSCapabilitiesParser.test_BoundingBoxes): Added a new test
	to ensure None is returned for a non-existing SRS.
	(TestWMSCapabilitiesParser.test_grok): Removed test_grok method
	since it is not applicable anymore.  Listing more SRSes in <SRS>
	elements is valid according to the specs.

2004-03-26  Bernhard Reiter <bernhard@intevation.de>

	* README: Nicer formatting of text. Improved descriptions.
	Reflected wxWidgets name change.
	
	* Thuban/UI/about.py: Extended copyright to 2004 and added
	information about the thuban-devel mailinglist.

2004-03-24  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/capabilities.py: Renamed the class to contain
	'WMS', also added a linebreak where required

	* Extensions/wms/parser.py: Finally added the XML parser for the
	GetCapabilities response.

	* Extensions/wms/test/sample.xml: Adjusted the sample file so that
	<SRS> elements match the <BoundingBox> elements, except for the
	layer 'beschriftung'.

	* Extensions/wms/test/test_parser.py: Encode non-ascii strings
	since Python uses unicode strings internally, otherwise
	comparisons will fail.  Removed tests for getLayerBBoxSRS() since
	the SRS will be calculated anyway and this method is obsoleted by
	getLayerSRS().  Denote SRS as strings and not as cardinal numbers.
	Move loading the sample file into the setUp method.  Added a test
	for finding the integrity problem in the sample response.
	Improved formatting.

	* Extensions/wms/domutils.py: Added convenience routines for
	handling of Document Object Model (DOM) nodes.

	* Extensions/wms/test/test_domutils.py: Added a test for the
	domutils module

2004-03-19  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/test/test_parser.py (TestWMSCapabilitiesParser):
	Moved path detection and adding into a module of its own,
	adjustpath, which exports thubandir as main Thuban directory.

	* Extensions/wms/test/test_ogclib.py (TestWMSLib): Moved path
	detection and adding into a module of its own, adjustpath, which
	exports thubandir as main Thuban directory.  Reorganised the
	module in order to support the SkipTest feature for Thuban test
	cases.

	* Extensions/wms/test/adjustpath.py: Moved path detection and
	adding into a module of its own.

2004-03-18  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/test/test_parser.py: Added another test for
	checking whether the WMS XML parser (to be implemented) returns
	the information we expect.  This requires a sample WMS WML file
	(sample.xml) which has been extracted from the frida server and
	"improved" manually.

	* Extensions/wms/test/test_ogclib.py: Added legacy code to add the
	main Thuban directory to the path in order to be able to import
	random modules.  Adjusted the PyOGCLib detection to reuse the
	information gathered.  Also added a note about the PYTHONPATH
	environment variable.

	* Extensions/wms/test/test_ogclib.py: The format specification is
	a mime-type, not a graphic format, hence image/jpeg wou ld be the
	proper format and not JPEG.  We'll also have to take care of the
	encoding of / as %2F.

2004-03-16  Martin Schulze  <joey@infodrom.org>

	* Extensions/wms/test/test_ogclib.py: Added a (hopefully)
	comprehensive test for the getMapURL method, built compare URLs
	according to the documentation in OGC 01-068r3

	* Extensions/wms/capabilities.py (WMSCapabilities): Added the
	class WMSCapabilities to manage capabilites, will incorporate
	parsing the capabilities response and provide details for other
	classes.

2004-03-12  Bernhard Herzog  <bh@intevation.de>

	Support views in addition to normal tables in the postgis
	shapestore

	* Thuban/Model/postgisdb.py
	(PostGISShapeStore._fetch_table_information): Add a fallback for
	the case where the table name is not in the geometry_columns
	table.  This is usually the case for views.  Also, set
	self.shapestore here.
	(PostGISShapeStore.ShapeType): No need to query the database all
	the time.  The shape type is now determined in
	_fetch_table_information

	* test/postgissupport.py (PostgreSQLServer.new_postgis_db)
	(PostgreSQLServer.get_static_data_db, PostGISDatabase.__init__):
	New parameter to specify views.
	(PostGISDatabase.has_data): Also compare the views.  New views
	parameter
	(PostGISDatabase.initdb): Create the views.
	(PostgreSQLServer.get_default_static_data_db): Add the v_landmarks
	view

	* test/test_postgis_db.py
	(TestPostGISShapestorePointFromViews): New.  Test a
	PostGISShapeStore with a view
	(TestPostGISShapestorePointOIDAsGIDColumn.setUp): Pass the name of
	the geometry_column explicitly to test whether that works

2004-03-12  Bernhard Herzog  <bh@intevation.de>

	Final step for explicit id/geometry columns: Loading and saving

	* Resources/XML/thuban-1.1.dtd: New.  Derived from thuban-1.0.dtd
	with the following changes:
	(dbshapesource): Two new attributes id_column and geometry_column

	* Thuban/Model/save.py (SessionSaver.write): Use the new dtd
	(SessionSaver.write_session): Use the new namespace
	(SessionSaver.write_data_containers): Write the new dbshapesource
	parameters

	* Thuban/Model/load.py (SessionLoader.__init__): New namespace for
	the new file format version
	(SessionLoader.start_dbshapesource): Handle the new db parameters

	* test/test_save.py: Update to the new dtd and namespace
	(SaveSessionTest.test_save_postgis): Update the NonConnectionStore
	mock object to provide a working IDColumn method.

	* test/test_load_1_0.py: New.  Copy of the test_load.py before
	today's changes but with the round-trip tests removed.

	* test/test_load_0_9.py: Update doc-string.

	* test/test_load.py: Update all .thuban files to the new dtd and
	namespace.
	(TestPostGISLayer.file_contents): Add the new dbshapesource
	paramters

2004-03-11  Bernhard Herzog  <bh@intevation.de>

	Next step for explicit id/geometry columns: User interaction

	* Thuban/UI/dbdialog.py (ChooseDBTableDialog.__init__): Rework how
	the dialog is constructed. Add combo boxes to select id and
	geometry column.  Rename some instance variables.
	(ChooseDBTableDialog.GetTable): Return id and geometry column
	names
	(ChooseDBTableDialog.OnTableSelect): New. Event handler for
	selections in the table list

	* Thuban/UI/mainwindow.py (MainWindow.AddDBLayer): Use id_column
	and geometry_column

	* Thuban/Model/session.py (Session.OpenDBShapeStore): Add the new
	parameters for id_column and geometry column of PostGISShapeStore
	here as well.

	* Thuban/Model/postgisdb.py (type_map): Add ROWID psycog type.
	(_raw_type_map): New. Map raw PostgreSQL type ints to thuban types
	(PostGISConnection.GeometryTables): Use a better query to
	determine which relations in the database might be usable for
	shapestores.  Now supports views as well but is more PostgreSQL
	specific
	(PostGISConnection.table_columns): New. Somewhat experimental
	method to let the db dialogs provide lists of columns to users so
	that they can select id and geometry columns.
	(PostGISTable.__init__): The default value of the id_column
	parameter is now None it still means "gid" effectively, though.
	(PostGISTable.IDColumn): New introspection method to return a
	column object for the id column
	(PostGISShapeStore.GeometryColumn): New introspection method to
	return a column object for the geometry column

	* test/test_postgis_db.py
	(TestPostGISConnection.test_gis_tables_non_empty):
	Removed. Subsumed by the new:
	(TestPostGISConnection.test_gis_tables_with_views_and_tables):
	New. Tes the GeometryTables and table_columns methods with actual
	tables and views.
	(PointTests.test_id_column, PointTests.test_geometry_column):
	New. tests for the new methods.
	(TestPostGISShapestorePoint.setUp)
	(TestPostGISShapestorePointSRID.setUp)
	(TestPostGISShapestorePointExplicitGIDColumn.setUp): Fill the
	instance variables needed by the new tests

2004-03-11  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/classgen.py (GenQuantilesPanel.GetList): The row
	numbers given to ReadValue are ordinals.

2004-03-11  Bernhard Herzog  <bh@intevation.de>

	Elimiate the requirement for PostGIS tables to have a column
	called "gid".

	* Thuban/Model/postgisdb.py (PostGISTable.__init__): New parameter
	id_column to specify which column to use to identify rows.  Also
	new instance variables id_column and quoted_id_column
	(PostGISTable.RowIdToOrdinal, PostGISTable.RowOrdinalToId)
	(PostGISTable.ReadRowAsDict, PostGISTable.ReadValue)
	(PostGISTable.SimpleQuery): Use the id column name provided to the
	constructor instead of "gid"
	(PostGISShapeStore.__init__): New parameter id_column analogously
	to PostGISTable.__init__.  This parameter is simply passed through
	to the base class constructor
	(PostGISShapeStore._create_col_from_description): Fix typo in
	doc-string
	(PostGISShapeStore.Shape, PostGISShapeStore.AllShapes)
	(PostGISShapeStore.ShapesInRegion): Use the id column name
	provided to the constructor instead of "gid"

	* test/postgissupport.py
	(PostgreSQLServer.get_default_static_data_db): New static table
	landmarks_point_id with an id column != "gid.  Update the comments
	a bit.
	(skip_if_addgeometrycolumn_does_not_use_quote_ident): Fix typo in
	doc-
	(upload_shapefile): New parameter gid_column to use a name other
	than "gid" for the column to store the shape ids

	* test/test_postgis_db.py (TableTests): New.  Mixin-class
	containing all tests previously in TestPostGISTable.  The actual
	tests are the same but the code is a bit more configurable to
	allow for different id columns etc.
	(TestPostGISTable): Derive from TableTests now for the actual
	tests.
	(TestPostGISTableExplicitGIDColumn): New. Like TestPostGISTable
	except that it the landmarks_point_id table to test the id_column
	parameter
	(PointTests): Extend the doc-string
	(TestPostGISShapestorePointExplicitGIDColumn)
	(TestPostGISShapestorePointOIDAsGIDColumn): New classes derived
	from PointTests to test the explicit id_column parameter.  One
	tests with the name of the column holding the shape ids, the other
	uses PostgreSQL's OID column.  For the latter a number of methods
	have to be overwritten to make them independent of the actual id
	values.

2004-03-08  Silke Reimer  <silke@intevation.de>

	Update debian directory:

	* debian/changelog: Added new version.
	* deiban/rules: Updated management of patches (with cbds)
	* debian/control: Added cbds to dependencies
	* debian/patches/*: New. Adds better support for patches of thuban in
	 		debian
	* debian/menu: Syntax of menu changed slightly
	* debian/setup.py.patch: removed because it has been moved to
	  		debian/patechs/setup.py.patch
	

2004-02-26  Bernhard Herzog  <bh@intevation.de>

	Create the Doc/technotes directory for text files with information
	for developers

	* Doc/technotes/README: New. README for the technotes

	* Doc/technotes/coding_guidelines.txt: New. Coding guidelines for
	Thuban

	* Doc/technotes/release_process.txt: New. Used to be
	HOWTO-Release.  Now slightly adapted to technote formatting style.

	* HOWTO-Release: Removed.  It's contents are now in
	Doc/technotes/release_process.txt

2004-02-25  Bernhard Herzog  <bh@intevation.de>

	* libraries/thuban/wxproj.cpp (get_wx_version): New.  Return the
	version of wxWindows the module was compiled with so we can check
	that against the wxPython version.

	* Thuban/version.py (thuban_branch, thuban_release): New variables
	controlling which and how Thuban versions are shown.  See the
	comments for details.
	(verify_versions): Also check that the wx version that wxproj is
	compiled against matches that of the wxPython we use at runtime

2004-02-20  Bernhard Herzog  <bh@intevation.de>

	* Extensions/wms/wms.py (epsg_code_to_projection): Use
	get_system_proj_file to read the epsg projections.  The old way
	depended on the current directory being the top Thuban directory.

2004-02-20  Bernhard Herzog  <bh@intevation.de>

	* Extensions/svgexport/test/test_svgmapwriter.py
	(TestVirtualDC.test_clippath): Remove a debug print

2004-02-20  Bernhard Herzog  <bh@intevation.de>

	* Extensions/svgexport/__init__.py: New.  Turn
	Extensions/svgexport into a package.

	* Extensions/svgexport/svgmapwriter.py: Reorder the imports and
	doc-string a bit.  The doc-string must come first, otherwise it's
	not a doc-string.  The __future__ import must be the first thing
	after the doc-string.  Use only double quotes in doc-strings.
	Single quotes trip up emacs syntax highlighting if the text
	contains apostrophes.

2004-02-20  Bernhard Herzog  <bh@intevation.de>

	* Extensions/svgexport/test/__init__.py,
	Extensions/svgexport/test/test_svgmapwriter.py: New. Initial test
	suite for svgexport

	* test/runtests.py (find_test_modules): New. Function with the
	module finding code from main.
	(main): Use find_test_modules to figure out the default test
	modules and take modules from Extensions.svgexport.test too.

2004-02-19  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/application.py (ThubanApplication.OnInit): Make sure
	the mainwindow has a reference to the map of the initial session.
	This fixes a bug introduced with the fix for RT#2245

2004-02-19  Bernhard Herzog  <bh@intevation.de>

	* Extensions/svgexport/svgsaver.py,
	Extensions/svgexport/svgmapwriter.py,
	Extensions/svgexport/maplegend.py: Added again.  This time in the
	correct place.

2004-02-17  Bernhard Herzog  <bh@intevation.de>

	Fix for RT#2245

	* Thuban/UI/application.py (ThubanApplication.OnInit): Initialize
	instance variables before trying to create any windows.  Creating
	windows can start an event loop if e.g. message boxes are popped
	up for some reason, and event handlers, especially EVT_UPDATE_UI
	may want to access things from the application.
	(ThubanApplication.maps_changed): The mainwindow may not have been
	created yet, so check whether it has been created before calling
	its methods

	* Thuban/UI/view.py (MapCanvas.OnIdle): Only try to redraw if we
	have a map

2004-02-17  Bernhard Herzog  <bh@intevation.de>

	* test/test_svgmapwriter.py, Extensions/svgsaver.py,
	Extensions/svgmapwriter.py, Extensions/maplegend.py,
	extensions/svgexport/svgsaver.py,
	extensions/svgexport/svgmapwriter.py,
	extensions/svgexport/maplegend.py: Removed.  These files were in
	the wrong places or didn't work at all.

2004-02-16  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/view.py (MapCanvas.Export): Remove accidentally added
	line

2004-02-16  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/view.py (MapCanvas.Export): Avoid UnboundLocalError.

2004-02-15  Markus Rechtien  <markus@intevation.de>
	
	* Extensions/svgexport/svgmapwriter.py: New. Adds the capability
	to write a session to a file in SVG format.
	* Extensions/svgexport/svgsaver.py: New. Uses svgmapwriter.py
	to write a SVG map of a session.
	* Extensions/svgexport/maplegend: New. Writes a basic maplegend
	in SVG format for the current session.

2004-02-13  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.AddDBLayer): When the layer
	can't be created, return immediately after displaying the error
	message.

2004-02-11  Bernhard Herzog  <bh@intevation.de>

	Handle postgis tables with more than one geometry column.

	* Thuban/Model/postgisdb.py
	(PostGISTable._fetch_table_information): Delegate the creation of
	column objects to a different method so that we can extend that in
	derived classes
	(PostGISTable._create_col_from_description): New. Column object
	creation part of _fetch_table_information
	(PostGISShapeStore._create_col_from_description): New. Extend
	inherited method to handle geometry columns
	(PostGISShapeStore.__init__): New parameter geometry_column to
	specify which geometry column to use.  Optional but mandatory for
	tables with more than one geometry column
	(PostGISShapeStore._fetch_table_information): Also use the name of
	the geometry column when looking for the srid
	(PostGISShapeStore.ShapeType): Also use the name of the geometry
	column when looking for the shape type

	* test/test_save.py (SaveSessionTest.test_save_postgis): Adapt
	NonConnectionStore to changes in the PostGISShapeStore

	* test/test_postgis_db.py
	(TestPostGISSpecialCases.test_shapestore_two_geom_cols): Test
	PostGISShapeStore with tables having two geometry columns.

2004-02-10  Bernhard Herzog  <bh@intevation.de>

	Fix some postgis problems.  What remains to be done is real
	handling of SRIDs as they affect how reprojection is done

	* Thuban/Model/postgisdb.py (quote_identifier): Fix typo in
	doc-string
	(PostGISShapeStore._fetch_table_information): New. Extend
	inherited method to retrieve srid
	(PostGISShapeStore.BoundingBox): Handle tables without data.
	extent yields NULL for those
	(PostGISShapeStore.ShapesInRegion): Use the srid of the table.

	* test/test_postgis_db.py
	(TestPostGISSpecialCases.test_shapestore_empty_table): New test
	for the special case of a table without any data
	(TestPostGISShapestorePointSRID): New class with tests for a table
	that uses srids
	(PolygonTests): Fix a doc-string typo

	* test/postgissupport.py (PostGISDatabase.__init__): New parameter
	reference_systems with a specification of spacial reference
	systems to create in the new db.
	(PostgreSQLServer.new_postgis_db)
	(PostgreSQLServer.get_static_data_db): New parameter
	reference_systems to be passed through ultimately to
	PostGISDatabase.  In new_postgis_db also check whether an existing
	db already has the right srids
	(PostgreSQLServer.get_default_static_data_db): Add srids and a
	table that uses srids
	(PostGISDatabase.initdb): Create the entries for the reference
	systems
	(PostGISDatabase.has_data): Add reference_systems parameter to
	check for those too
	(upload_shapefile): New parameter srid to create tables with a
	specific srid

2004-02-06  Frank Koormann  <frank@intevation.de>

	* po/pt_BR.po: Fixed charset

2004-02-05  Frank Koormann  <frank@intevation.de>

	* po/pt_BR.po: Fixed format string for error message, missing %s
	added (Thuban/UI/application.py:273)

2004-02-03  Frank Koormann  <frank@intevation.de>
	
	First version of Portuguese (Brazilian) translation

	* po/pt_BR.po: New, translation of pot (2004-01-15 16:07+0300) for
	Brazilian Portuguese by Eduardo Patto Kanegae.

	* Thuban/UI/about.py (About.__init.py__): Added Eduardo to the list of
	translators.


2004-01-22  Frank Koormann  <frank@intevation.de>

	* Doc/manual/thuban-manual.xml: Added section on installation of
	Thuban under Win32 systems. Fixed image path references in the postgis
        section. Some minor source formattings.

2004-01-21  Frank Koormann  <frank@intevation.de>

	Make Thuban remember path selections (at least for one application run).

	* Thuban/UI/application.py (Application.OnInit): Initialize path as a 
	attribute of application object. Path is a dictionary of
	strings, currently with the items "data" and "projection".  
	(Application.SetPath): New, stores path for the specified item.
	(Application.Path): New, return path for the specified item.

	* Thuban/UI/mainwindow.py 
	(MainWindow.OpenSession, MainWindow.SaveSessionAs, 
	MainWindow.AddLayer, MainWindow.AddRasterLayer,
	MainWindow.TableOpen): Access "data" path information of the
	application.
	
	* Thuban/UI/projdialog.py (ProjFrame._OnImport, ProjFrame._OnExport):
	Access "projection" path information of the application.

2004-01-05  Bernhard Herzog  <bh@intevation.de>

	* po/ru.po: Updated translations from Alex Shevlakov

2004-01-05  Bernhard Herzog  <bh@intevation.de>

	* po/Makefile, po/README: Move the description of how to generate
	the translation statistics to the README.

2003-12-23  Bernhard Herzog  <bh@intevation.de>

	* NEWS: Update for 1.0.0

	* po/it.po: Another update from Maurizio Napolitano

2003-12-23  Bernhard Herzog  <bh@intevation.de>

	* po/it.po: Updated translation from Maurizio Napolitano

2003-12-23  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/join.py (JoinDialog.__init__): Mark one more string
	for translation

	* Thuban/UI/mainwindow.py (MainWindow.TableRename)
	(MainWindow.RenameMap, MainWindow.RenameLayer): Mark some more
	strings for translation

	* po/de.po: Update with the newly marked strings.

2003-12-22  Bernhard Herzog  <bh@intevation.de>

	* HOWTO-Release: Fix the places where version numbers have to be
	updated

2003-12-22  Bernhard Herzog  <bh@intevation.de>

	* setup.py (setup call): 1.0.0, yeah!

	* Thuban/version.py (longversion): 1.0.0, yeah!

	* Thuban/Model/load.py (SessionLoader.__init__): Accept the
	1.0.0 namespace too

	* Thuban/Model/save.py (SessionSaver.write_session): Save with
	1.0.0 namespace

	* test/test_load.py (LoadSessionTest.dtd)
	(TestSingleLayer.file_contents)
	(TestNonAsciiColumnName.file_contents)
	(TestLayerVisibility.file_contents)
	(TestClassification.file_contents, TestLabels.file_contents)
	(TestLayerProjection.file_contents)
	(TestRasterLayer.file_contents, TestJoinedTable.file_contents)
	(TestLabelLayer.file_contents, TestPostGISLayer.file_contents)
	(TestPostGISLayerPassword.file_contents)
	(TestLoadError.file_contents, TestLoadError.test): Update for
	1.0.0 namespace

	* test/test_save.py (SaveSessionTest.dtd)
	(SaveSessionTest.testEmptySession)
	(SaveSessionTest.testSingleLayer)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table)
	(SaveSessionTest.test_save_postgis): Update for 1.0.0 namespace

2003-12-22  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/load.py (SessionLoader.start_label): Make sure the
	alignment flags are byte strings not unicode and that they have
	valid values

	* test/test_load.py (TestLabelLayer): New. Test loading (and
	indirectly saving) of maps with labels.

2003-12-22  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/tableview.py (TableGrid.OnDestroy)
	(TableGrid.__init__): Handle EVT_WINDOW_DESTROY in the grid to
	unsubscribe all subscribers.
	(LayerTableFrame.OnDestroy): Do not unsubscribe any messages from
	self.grid since it may already have been destroyed.
	Fixes RT #2256

2003-12-19  Bernhard Herzog  <bh@intevation.de>

	* po/fr.po, po/es.po: Updated translations from Daniel Calvelo

2003-12-16  Bernhard Herzog  <bh@intevation.de>
	
	* debian/bitmappath.patch, debian/setup.py.patch:
		added to ensure compliance with FHS for debian
	* debian/rules, debian/changelog:
	    added patches in rules to ensure compliance with FHS for debian

2003-12-16  Bernhard Herzog  <bh@intevation.de>

	* po/Makefile (mo): Make the output a bit nicer so that it prints
	statistics about the translations. Add a comment how produce even
	nicer statistics with sed.

2003-12-09  Frank Koormann   <frank@intevation.de>

	* Resources/Projections/defaults.proj:
	French projection sample with correct accents (UNICODE).

2003-12-05  Bernhard Herzog  <bh@intevation.de>

	* MANIFEST.in: Add the devtools directory

	* setup.py (setup call): Use license instead of licence. This
	silences a deprecation warning on Python 2.3

2003-12-05  Frank Koormann   <frank@intevation.de>

	Documentation synced with 1.0rc1

	* Doc/manual/thuban-manual.xml: 
	Minor formatting changes and references to database layers .
	Introduction.Internationalization: New section on i18n.
	MapManagement.AddingandRemovingLayers: Added item on database layers.	
	MapManagement.TheLegend: Added section and screenshot on popup menu.
	ProjectionManagement: Updated screenshot and sentence on EPSG.
	Appendix.SupportedDataSources: Added PostGIS.
	Appendix.WorkingwithPostGIS: New section.

	* Doc/manual/images/6_projection.png: Updated screenshot including 
	EPSG checkboxes.

	* Doc/manual/images/3_5_popup_menu.png: New, popup menu screenshot.

	* Doc/manual/images/app_postgis_add_layer.png,
	Doc/manual/images/app_postgis_db_add.png, 
	Doc/manual/images/app_postgis_db_management.png:
	New screenshots focussing on database layers

2003-12-05  Frank Koormann   <frank@intevation.de>

	* Thuban/UI/projdialog.py (load_user_proj): If user.proj is missing
	write warning to stderr instead of rising a warning dialog

2003-12-03  Bernhard Herzog  <bh@intevation.de>

	Fix for RT #2243

	* Thuban/UI/mainwindow.py (MainWindow.has_selected_shape_layer):
	New. Like has_selected_layer but for shape layers only
	(_has_selected_shape_layer): New. Like _has_selected_layer but for
	shape layers only
	(layer_show_table command, layer_jointable command): Use these
	commands should only be available for shape layers

2003-12-03  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.Unsubscribe): Deal with
	publishers that are wx objects and may have been destroyed by wx
	already. Fixes RT #2242.

2003-12-03  Bernhard Herzog  <bh@intevation.de>

	* po/ru.po: Updates from Alex Shevlakov

2003-12-03  Silke Reimer <silkeintevation.de>

	* debian/control, debian/changelog: Added gdal-support to
		debian package, updated to new thuban version


2003-12-03  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Lib/version.py: New. Module for version number
	manipulations. The version of make_tuple here also deals better
	with more unusual version number strings, such as e.g.
	"1.2+cvs20031111"

	* Thuban/version.py (make_tuple): Removed. It's now in
	Thuban.Lib.version. Use that implementation instead.

	* test/test_lib_version.py: New. Tests for Thuban/Lib/version.py

2003-12-02  Bernhard Herzog  <bh@intevation.de>

	* MANIFEST.in: Add debian files

	* setup.py (setup call): Add packages for the Extensions so that
	they're installed too
	(data_files): Add READMEs and sample data from some Extensions

	* NEWS: Add note about the extensions in binary packages

2003-12-02  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/save.py (SessionSaver.write_session): Save files
	with the thuban-1.0rc1

	* Thuban/Model/load.py (SessionLoader.__init__): Recognize the
	thuban-1.0rc1 namespace too

	* test/test_save.py (SaveSessionTest.dtd)
	(SaveSessionTest.testEmptySession)
	(SaveSessionTest.testSingleLayer)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table)
	(SaveSessionTest.test_save_postgis): Update to thuban-1.0rc1
	namespace

	* test/test_load.py (LoadSessionTest.dtd): Update to thuban-1.0rc1
	namespace
	(TestSingleLayer.file_contents)
	(TestNonAsciiColumnName.file_contents)
	(TestLayerVisibility.file_contents)
	(TestClassification.file_contents, TestLabels.file_contents)
	(TestLayerProjection.file_contents)
	(TestRasterLayer.file_contents, TestJoinedTable.file_contents)
	(TestPostGISLayer.file_contents)
	(TestPostGISLayerPassword.file_contents)
	(TestLoadError.file_contents, TestLoadError.test): Update to
	thuban-1.0rc1 namespace

2003-12-01  Bernhard Herzog  <bh@intevation.de>

	* setup.py (proj4_prefix, wx_prefix, gdal_prefix): Fix these for
	nt to better match Intevation's current w32 setup

	* HOWTO-Release: Add note about updating MANIFEST.in

	* MANIFEST.in: Add the Extensions

	* NEWS: Update for 1.0rc1

2003-12-01  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.AddLayer): Change the wild
	cards for the dialog so that shapefiles ending in all uppercase
	SHP are listed too

2003-11-28  Bernhard Herzog  <bh@intevation.de>

	* Thuban/version.py (longversion): Update to 1.0rc1

	* setup.py (setup call): Update version to 1.0rc1. Use the
	thuban@intevation.de email address as author email instead of my
	personal one.

2003-11-28  Bernhard Herzog  <bh@intevation.de>

	* po/de.po: Update german translation.

2003-11-28  Bernhard Herzog  <bh@intevation.de>

	Unify the filenames stored in .thuban files so that the .thuban
	files are more platform independend

	* Thuban/Model/save.py (unify_filename): New. Unify filenames so
	that they can be used on both windows and unix
	(SessionSaver.prepare_filename): New. Handle all filename
	transformations for filenames stored in the thuban file
	(SessionSaver.write_data_containers, SessionSaver.write_layer):
	Use prepare_filename

	* test/test_save.py (SaveSessionTest.testSingleLayer)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table): Filenames are always stored
	with slashes on all currently supported platforms so adapt all
	tests to this

	* test/test_load.py (LoadSessionTest.filenames): With the new
	filename scheme the filenames in the tests should be
	understandable on all currently supported platforms so we turn
	this into an empty list because we don't have to normalize them
	anymore

2003-11-28  Bernhard Herzog  <bh@intevation.de>

	* test/test_layer.py (TestLayer.test_arc_layer_with_projection):
	Add the ellipsoid to the projection since some Proj versions
	complain if it's missing.

2003-11-27  Bernhard Herzog  <bh@intevation.de>

	Corect some bounding box projection problems

	* Thuban/Model/proj.py (Projection.InverseBBox): New. Inverse
	version of ForwardBBox
	(Projection._transform_bbox): New. common implementation of
	ForwardBBox and InverseBBox
	(Projection.ForwardBBox): Use _transform_bbox.

	* test/test_proj.py (TestProjection.test): Add test for
	InverseBBox

	* Thuban/Model/layer.py (Layer.LatLongBoundingBox)
	(Layer.ShapesBoundingBox, RasterLayer.LatLongBoundingBox): Use the
	new InverseBBox method to determine the unprojected bounding box
	(Layer.ShapesInRegion): Use the ForwardBBox method to project the
	bbox.

	* test/test_layer.py (TestLayer.test_point_layer_with_projection):
	Removed.
	(TestLayer.test_arc_layer_with_projection): New. This test is
	better able to test whether bounding boxes are projected correctly
	than test_point_layer_with_projection

	* Thuban/UI/viewport.py (ViewPort.map_projection_changed): Use
	InverseBBox to unproject bboxes

2003-11-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/about.py (About.__init__): Make sure we have ASCII
	source code.

2003-11-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/layer.py (Layer.__getattr__): Removed. It was only
	there for backwards compatibility and all code relying on that
	should have been updated by now.

2003-11-25  Bernhard Herzog  <bh@intevation.de>

	* test/test_load.py (TestClassification.test): Add the missing
	round trip test.
	(TestClassification.file_contents): Update to the newest file
	format

2003-11-25  Bernhard Herzog  <bh@intevation.de>

	Add very experimental (and possibly dangerous) extension to draw
	polygons:

	* Extensions/drawshape/README: New. Brief installation
	instructions

	* Extensions/drawshape/drawshape.py: New. Implementation of the
	drawshape extensions

	* Extensions/drawshape/patch.diff: Patch to apply before the
	extension can be used.

2003-11-24  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/data.py (ShapefileStore._open_shapefile)
	(ShapefileStore.__init__): Factor opening the shapefile into a
	separate method (the new _open_shapefile). This makes the code a
	bit more readable but the real reason is that it makes some evil
	hacks easier. :-)

2003-11-24  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/load.py (SessionLoader.check_attrs): If no
	converter is specified for an attribute assume it's a string
	containing only Latin1 characters. Update doc-string accordingly.
	This change should fix many places where unicode objects might
	accidentally enter Thuban.

	* test/test_load.py (TestNonAsciiColumnName): New test to check
	what happens with column names in DBF files that contain non-ascii
	characters

2003-11-21  Bernhard Herzog  <bh@intevation.de>

	Enable the experimental attribute editing again and introduce a
	command line switch to actually activate it

	* Thuban/UI/main.py (options): New. Container for options set on
	the commmand line
	(main): Add the --enable-attribute-editing flag.

	* Thuban/UI/identifyview.py (IdentifyView.__init__): If attribute
	editing is enabled use the grid ctrl which allows editing of the
	values

	* Thuban/Model/transientdb.py (AutoTransientTable.write_record):
	New. Just delegate this to the underlying table.

2003-11-20  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py (ProjFileReadTests.test_read_unreadable_file):
	Skip this test if run under non-posix systems since it only works
	there

2003-11-19  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/resource.py: Rework the way gdal support is
	determined so that we can give a reason in the about why gdal is
	not supported.
	(gdal_support_status): New. Variable holding a string with the
	reason for no gdal support

	* Thuban/UI/about.py (About.__init__): Add the reason why gdal is
	not supported to the message

2003-11-19  Bernhard Herzog  <bh@intevation.de>

	Remove the old table interface and its test cases

	* Thuban/Model/table.py (OldTableInterfaceMixin): Removed.
	(DBFTable, MemoryTable): Do not derive from OldTableInterfaceMixin
	anymore

	* Thuban/Model/transientdb.py (TransientTableBase)
	(AutoTransientTable): Do not derive from OldTableInterfaceMixin
	anymore

	* test/test_table.py: Removed since the old interface it tests is
	gone.

	* test/runtests.py (main): The old table interface is gone and
	with it the deprecation warnings so remove the code that turns
	these warnings into errors

2003-11-19  Bernhard Herzog  <bh@intevation.de>

	* test/test_table.py: Revert to revision 1.5 again. Changing the
	tests to use the new table interface is completely wrong since the
	whole purpose of the tests in this module is to test the old
	interface.

2003-11-18  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py (PostGISConnection.MatchesParameters):
	New. Test whether the connection matches a set of connection
	parameters

	* Thuban/UI/dbdialog.py (DBFrame.conns_changed): Fix doc-string
	(DBFrame.OnAdd): Use the new MatchesParameters method when looking
	for existing connections with the same parameters and break out of
	the loop correctly.

	* test/test_postgis_db.py (TestBriefDescription)
	(TestPostGISSimple.test_brief_description): Rename
	TestBriefDescription to TestPostGISSimple and the test method to
	test_brief_description so that we can add more test methods.
	(TestPostGISSimple.test_matches_parameters): New. Test the new
	MatchesParameters method

2003-11-18  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Lib/connector.py (Publisher): Introduce a new flag,
	_was_destroyed, to indicate whether an publisher instance has
	already been destroyed.
	(Publisher.Unsubscribe): Only disconnect if the publisher has not
	been destroyed yet.
	(Publisher.Destroy): Set the _was_destroyed flag to true.

	* test/test_connector.py
	(TestPublisher.test_unsubscribe_after_destroy): New. Test that
	calling Unsubscribe after Destroy doesn't raise an exception

2003-11-14  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/identifyview.py (IdentifyView.selected_shape): Fix
	typo in doc-string

2003-11-13  Bernhard Herzog  <bh@intevation.de>

	Quote table and column names properly for postgis.

	* Thuban/Model/postgisdb.py (quote_identifier): New. Function to
	quote an identifier for use in an sql statement
	(PostGISColumn.__init__): Add the quoted_name attribute
	(PostGISTable.__init__): New instance variable quoted_tablename
	(PostGISTable._fetch_table_information): Use the quoted table
	name. New isntance variable quoted_geo_col with a quoted version
	of geometry_column
	(PostGISTable.NumRows, PostGISTable.RowIdToOrdinal)
	(PostGISTable.RowOrdinalToId): Use the quoted table name
	(PostGISTable.ReadValue, PostGISTable.ValueRange)
	(PostGISTable.UniqueValues, PostGISTable.SimpleQuery)
	(PostGISShapeStore.BoundingBox, PostGISShapeStore.Shape)
	(PostGISShapeStore.AllShapes, PostGISShapeStore.ShapesInRegion):
	Use quoted table and column names

	* test/test_postgis_db.py (TestPostGISSpecialCases)
	(TestPostGISIgnoredColumns): Rename the class to
	TestPostGISSpecialCases because that better describes the new
	cases
	(TestPostGISSpecialCases.test_unsupported_types)
	(TestPostGISSpecialCases.test): Rename the method to
	test_unsupported_types because we need a more descriptive name now
	that there are more methods
	(TestPostGISSpecialCases.test_table_name_quoting)
	(TestPostGISSpecialCases.test_column_name_quoting)
	(TestPostGISSpecialCases.test_shapestore_name_quoting): New test
	cases to test quoting of table and column names in PostGISTable
	and PostGISShapeStore

	* test/postgissupport.py
	(skip_if_addgeometrycolumn_does_not_use_quote_ident): New. Skip if
	AddGeometryColumn desn't support table or column names with sapces
	or double quotes

2003-11-12  Jan-Oliver Wagner <jan@intevation.de>

	* Extensions/wms/__init__.py: New: Init to make this
	directory a package.

	* Extensions/wms/wms.py: New: Provide layers via OGC WMS.

2003-11-11  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/resource.py (EPSG_DEPRECATED_PROJ_FILE): New.
	Constant for the file woth deprecated epsg projections
	(get_system_proj_file): Update doc-string

	* Thuban/UI/projdialog.py (ProjFrame.build_dialog): Add a space
	above the EPS widgets, introduce a check box for the deprecated
	eps projections and a label for the epsg widgets
	(ProjFrame._OnShowEPSG): Handle the deprecated EPSG projections
	too

2003-11-11  Bernhard Herzog  <bh@intevation.de>

	Avoid warnings when run under Python 2.3

	* Thuban/UI/baserenderer.py (BaseRenderer.draw_point_shape)
	(BaseRenderer.draw_label_layer): Coordinates must be ints.

	* Thuban/UI/renderer.py (MapRenderer.make_point): Turn this into a
	real method so that we can convert to int.
	(MapRenderer.label_font): The font size mist be an int.

	* Thuban/UI/common.py (Color2wxColour): The color values must be
	ints. Also, remove the unnecessary asserts.

	* test/test_load_0_8.py (TestUnicodeStrings.file_contents)
	(TestUnicodeStrings.test): Python source code should not contain
	non-ascii characters unless an encoding is specified in the file.
	Therefore use \x escapes in the string literals for non-ascii
	characters.

2003-11-11  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/resource.py (get_system_proj_file): Add a filename
	parameter so that this function can be used for all proj files in
	Resource/Projections
	(DEFAULT_PROJ_FILE, EPSG_PROJ_FILE): New. Predefined filenames for
	get_system_proj_file

	* Thuban/UI/projdialog.py (ProjFrame.__init__): Instead of one
	ProjFile self.__sysProjFile use a dictionary of system ProjFile
	objects self._sys_proj_files
	(ProjFrame.build_dialog): Adapt to the new changes in the
	ProjectionList constructor. Add a check button to toggle whether
	EPSG projections are shown
	(ProjFrame._OnShowEPSG): New. Handler for the epsg check button
	events.
	(ProjFrame.load_user_proj, ProjFrame.load_system_proj): Only show
	the busy cursor if the files have not yet been loaded by the
	dialog.
	(ProjFrame.load_system_proj): Add a parameter for the name of the
	proj file. Maintain the dictionary of system projections
	self._sys_proj_files

	* Thuban/UI/projlist.py (ProjectionList): Merge the system_projs,
	user_projs parameters into one parameter proj_files which is a
	list of proj files.
	(ProjectionList._subscribe_proj_files)
	(ProjectionList._unsubscribe_proj_files): New. Move
	subscription/unsubscription of projfile messages to separate
	methods
	(ProjectionList.Destroy): The unsubscribe is now done in
	_unsubscribe_proj_files
	(ProjectionList.update_projections): We now have a list of proj
	file objects
	(ProjectionList.SetProjFiles): New method to set a new list of
	proj file objects

	* test/test_proj.py (ProjFileReadTests.test_get_system_proj_file):
	Specify explicitly which system proj file to load.

2003-11-11  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/load.py (SessionLoader.Destroy): New. Clear all
	instance variables to cut cyclic references. The GC would have
	collected the loader eventually but it can happen that it doesn't
	run at all until thuban is closed (2.3 but not 2.2 tries a bit
	harder and forces a collection when the interpreter terminates)
	(load_session): Call the handler's Destroy method to make sure
	that it gets garbage collected early. Otherwise it will be
	collected very late if at all and it holds some references to e.g.
	shapestores and the session which can lead to leaks (of e.g. the
	temporary files)

	* test/test_load.py (TestSingleLayer.test_leak): New. test for the
	resource leak in load_session

2003-11-10  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/baserenderer.py: Add a way to specify how layers in
	extensions are to be rendered.
	(_renderer_extensions): New. List with renderer for layers in
	extensions
	(add_renderer_extension): New. Add a renderer extension
	(init_renderer_extensions): New. Init the renderer extensions
	(BaseRenderer.render_map_incrementally): Search
	_renderer_extensions for how to draw unknown layer types
	(BaseRenderer.draw_raster_data): Add format parameter so that
	formats other than BMP can be drawn
	(BaseRenderer.draw_raster_layer): Pass an explicit format to
	draw_raster_data

	* Thuban/UI/renderer.py (raster_format_map): New. Mapping form the
	strings of the format parameter of draw_raster_data method to wx
	constants
	(MapRenderer.draw_raster_data): Add the format parameter and use
	raster_format_map to map it to the right wxwindows constant for
	wxImageFromStream

	* test/test_baserenderer.py (SimpleRenderer.draw_raster_data): Add
	the format parameter and record it
	(TestBaseRenderer.test_raster_no_projection): check the format
	paramter of the draw_raster_data method
	(TestBaseRenderer.test_renderer_extension): New. Test the renderer
	extension facility

2003-11-07  Bernhard Herzog  <bh@intevation.de>

	Tweak the usage of the sqlite database to make common use cases
	more responsive. In most cases copying the data to the sqlite
	database takes so long that using sqlite doesn't have enough
	advantages.

	* Thuban/Model/transientdb.py (TransientTableBase.ValueRange): Add
	comments about performance and query the min and max in separate
	statements because only that way will indexes be used.
	(TransientTableBase.UniqueValues): Add some comments about
	performance.
	(AutoTransientTable.ValueRange, AutoTransientTable.UniqueValues):
	Do not copy the data to the transient DB but use the transient
	copy if it exists. See the new comments for the performance trade
	offs

	* test/test_transientdb.py
	(TestTransientTable.test_auto_transient_table): Make sure that the
	data is copied to the transient database at some point.

2003-11-03  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/data.py (ShapefileStore.ShapesInRegion): Bind some
	globals to locals so that it's a bit faster

2003-11-03  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/baserenderer.py
	(BaseRenderer.draw_shape_layer_incrementally): Use the ReadValue
	method. ReadValue is faster than ReadRowAsDict since it only reads
	one cell especially now that the dbf file objects actually
	implement it.

	* Thuban/Model/table.py (DBFTable.ReadValue): Use the new
	read_attribute method of the dbf objects

2003-11-03  Bernhard Herzog  <bh@intevation.de>

	* Extensions/profiling/profiling.py (popup_dialog_box): New config
	variable to indicate whether the result should be shown in a
	dialog box
	(profile_screen_renderer, time_screen_renderer): Only show a
	dialog box if popup_dialog_box is true.
	(profile_screen_renderer): Flush stdout after the printing the
	first part of the "profiling..." message

	* Thuban/UI/baserenderer.py
	(BaseRenderer.draw_shape_layer_incrementally): Cache the pens and
	brushes for the groups so that they're not created over and over
	again

	* Thuban/Model/classification.py (Classification.__getattr__)
	(Classification._compile_classification)
	(Classification._clear_compiled_classification): New. Methods to
	manage a 'compiled' representation of the classification groups
	which is created on demand
	(Classification.InsertGroup, Classification.RemoveGroup)
	(Classification.ReplaceGroup): reset the compiled representation
	(Classification.FindGroup): Use the compiled representation to
	find the matching group
	(ClassGroupRange.GetRangeTuple): New. Return the range as a tuple

2003-10-31  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/classification.py (Classification.SetDefaultGroup):
	Send a CLASS_CHANGED message
	(Classification.RemoveGroup): Send a CLASS_CHANGED message and do
	not return the removed group since it wasn't used.

	* test/test_classification.py
	(TestClassification.test_set_default_group): New. Test the
	SetDefaultGroup method
	(TestClassification.test_insert_group): New. Test the InsertGroup
	method
	(TestClassification.test_remove_group): New. Test the RemoveGroup
	method
	(TestClassification.test_replace_group): New. Test the
	ReplaceGroup method

2003-10-31  Bernhard Herzog  <bh@intevation.de>

	* test/test_classification.py (TestClassification.setUp):
	Subscribe to the CLASS_CHANGED messages
	(TestClassification.tearDown): New. Destroy the classification
	properly
	(TestClassification.test_defaults): Add tests for the default line
	width and whether no messages were sent yet
	(TestClassification.test_set_default_properties): Add tests for
	messages and setting the default line width
	(TestClassification.test_add_singleton)
	(TestClassification.test_add_range)
	(TestClassification.test_multiple_groups): Add tests for messages

2003-10-31  Bernhard Herzog  <bh@intevation.de>

	Some more refactoring in preparation for new tests:

	* test/test_classification.py (TestClassification.setUp): New.
	Instantiate the classification here. Update the test methods
	accordingly.
	(TestClassification.test_multiple_groups): Make sure that the two
	singletons matching 1 are considered different.

2003-10-31  Bernhard Herzog  <bh@intevation.de>

	* test/test_classification.py (red, green, blue): New. These
	constants were used in several cases. Update the relevant methods.
	(TestClassification.test_defaults)
	(TestClassification.test_set_default_properties)
	(TestClassification.test_add_singleton)
	(TestClassification.test_add_range)
	(TestClassification.test_multiple_groups)
	(TestClassification.test_deepcopy): New. These were formerly all
	part of the single method test.
	(TestClassification.test_deepcopy): Removed.
	(TestClassIterator): Removed. The test case is now a method of
	TestClassification since it tests part of the public interface of
	Classification
	(TestClassification.test_iterator): New. Used to be
	TestClassIterator effectively

2003-10-31  Jan-Oliver Wagner <jan@intevation.de>

	GUIfied the functions of the profiling extension.

	* /Extensions/profiling/__init__.py: New: Init to make this
	directory a package.

	* Extensions/profiling/profiling.py: Moved menu entries to
	the Extensions menu. Applied _() for strings.
	(profile_screen_renderer): Catch the detailed printout and present
	it in a dialog.
	(time_screen_renderer): Raise a dialog to present the result instead
	of printing it to stdout.

2003-10-31  Bernhard Herzog  <bh@intevation.de>

	* test/test_classification.py (TestClassGroupProperties)
	(TestClassGroup, TestClassGroupDefault, TestClassGroupRange)
	(TestClassGroupSingleton, TestClassIterator, TestClassification):
	Split TestClassification into several classes, one for each class
	being tested. TestClassification itself now only tests
	Classification. This split makes changes to the tests a bit easier

2003-10-31  Bernhard Herzog  <bh@intevation.de>

	* Extensions/profiling/profiling.py: New. Extension to measure
	Thuban performance

2003-10-31  Frank Koormann <frank@intevation.de>

	Added two items to legend popup menu: Remove Layer and Show Layer Table

	* Thuban/UI/legend.py (LegendPanel._OnRemoveLayer,
	LegendPanel._OnShowTable): New event handlers, call the corresponding 
	mainwindow methods.
	(LegendTree._OnRightClick): Added items to popup menu.

2003-10-30  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/dialogs.py (ThubanFrame.__init__): Handle
	EVT_WINDOW_DESTROY
	(ThubanFrame.OnDestroy): New. Handler for EVT_WINDOW_DESTROY. Does
	nothing but is convenient for the derived classes.

	* Thuban/UI/tableview.py
	(TableFrame.OnDestroy, LayerTableFrame.OnDestroy): New.
	Unsubscribe the messages here not in OnClose because that might
	get called multiple times. Fixes RT #2196
	(TableFrame.OnClose, LayerTableFrame.OnClose): Removed. Not needed
	anymore.

	* README: Update the minimum requirement for wxPython. Since we
	now use the EVT_WINDOW_DESTROY event, we need at least 2.4.0.4,
	the version in which that was introduced for all platforms

2003-10-30  Frank Koormann <frank@intevation.de>

	* Thuban/UI/join.py (JoinDialog.OnJoin): Wrapped the major parts of 
	the join process in a ThubanBeginBusyCursor, ThubanEndBusyCursor
	frame.

2003-10-30  Jan-Oliver Wagner <jan@intevation.de>

	Improved APR import extension, added further EPSG definitions
	and some cleanup regarding string class.

	* test/test_proj.py (TestProjection.test_get_projection_units_geo):
	Added test for alias 'longlat'.

	* Resources/Projections/epsg-deprecated.proj: New. Contains
	deprecated EPSG definitions.

	* Extensions/importAPR/odb.py (ODBBaseObject.TreeInfo): Added
	the variable names for objects.

	* Extensions/importAPR/apr.py (APR_BLnSym, APR_BMkSym, APR_BShSym): New.
	Copied from importAPR and provided with documentation.

	* Extensions/importAPR/importAPR.py (APR_BLnSym, APR_BMkSym, APR_BShSym):
	Moved to apr.py.
	(APR_View): Added object ref 'ITheme'.

	* Thuban/Lib/fileutil.py, Thuban/UI/proj4dialog.py: Replaced string
	split function by corresponding use of the string class method.

	* Thuban/Model/xmlwriter.py: Replaced string replace function by
	corresponding string method.

2003-10-29  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/baserenderer.py
	(BaseRenderer.draw_shape_layer_incrementally): Speed up the
	special case of a classification that only has the default group

2003-10-27  Bernhard Herzog  <bh@intevation.de>

	* po/fr.po, po/es.po: Updated translations from Daniel Calvelo

	* po/de.po: Update.

	* Thuban/UI/application.py
	(ThubanApplication.ShowExceptionDialog): Handle translation of the
	dialog message properly

2003-10-27  Bernhard Herzog  <bh@intevation.de>

	Rework how localization works so that we use wx's translation
	functions when running Thuban as a normal application but not when
	we don't need any UI, such as in the test suite. See the comment
	in Thuban/__init__.py for details

	* Thuban/__init__.py (_): Add one level of indirection to make the
	translation handling more flexible and to make it possible to use
	either wx's translation services or not.
	(gettext_identity, translation_function_installed)
	(install_translation_function): New function to help with this

	* Thuban/UI/__init__.py: Install the wx specific translation
	function if it's OK to do that

	* test/support.py (initthuban): Install a dummy translation
	function so that importing Thuban.UI doesn't install a wx specific
	one for which would need to import wxPython

2003-10-27  Bernhard Herzog  <bh@intevation.de>

	* HOWTO-Release: Source archives should be created first and the
	binary packages should be created from the source archives.
	There's an official debian package now so there's no need to test
	the rpm on debian anymore

2003-10-27  Bernhard Herzog  <bh@intevation.de>

	Several rendering changes:

	 - Render the selection into a separate bitmap so that only that
	   bitmap needs to be redrawn when the selection changes

	 - Render incrementally showing previews and allowing interaction
	   before rendering is complete

	 - Update the renderer interface a bit. Most parameters of
	   RenderMap are now parameters of the constructor

	* Thuban/UI/baserenderer.py (BaseRenderer.__init__): Add the map
	and the update region as parameters. Update the doc-string
	(BaseRenderer.render_map_incrementally): New. Generator function
	to renders the map incrementally
	(BaseRenderer.render_map): Remove the map argument (it's now in
	the constructor) and simply iterate over the
	render_map_incrementally generator to draw the map.
	(BaseRenderer.draw_shape_layer_incrementally)
	(BaseRenderer.draw_shape_layer): Renamed to
	draw_shape_layer_incrementally and changed into a generator that
	yields True every 500 shapes. Used by render_map_incrementally to
	render shape layers incrementally

	* Thuban/UI/renderer.py (ScreenRenderer.RenderMap): Removed the
	map and region parameters which are now in the constructor
	(ScreenRenderer.RenderMapIncrementally): New. Public frontend for
	the inherited render_map_incrementally.
	(BaseRenderer.draw_shape_layer): Removed.
	(ScreenRenderer.draw_selection_incrementally): New. The selection
	drawing part of the removed draw_shape_layer as a generator
	(ScreenRenderer.layer_shapes): Update because of the region
	parameter change
	(ExportRenderer.__init__): New. Extend the inherited constructor
	with the destination region for the drawing
	(ExportRenderer.RenderMap): Removed the map and region parameters
	which are now in the constructor

	* Thuban/UI/view.py (MapCanvas.PreviewBitmap): New. Return a
	bitmap suitable for a preview in a tool
	(CanvasPanTool.MouseMove): Use the PreviewBitmap method to get the
	bitmap
	(MapPrintout.draw_on_dc): Adapt to new renderer interface
	(MapCanvas.OnPaint): Handle drawing the selection bitmap if it
	exists
	(MapCanvas.OnIdle): Update the logic to deal with incremental
	rendering and the selection bitmap
	(MapCanvas._do_redraw): Handle the instantiation of the render
	iterator and the redraws during rendering
	(MapCanvas._render_iterator): New. Generator to incrementally
	redraw both bitmaps
	(MapCanvas.Export): Adapt to new renderer interface.
	(MapCanvas.full_redraw): Reset the selection bitmap and the
	renderer iterator too
	(MapCanvas.redraw_selection): New. Force a redraw of the selection
	bitmap
	(MapCanvas.shape_selected): Only redraw the selection bitmap

	* test/test_baserenderer.py
	(TestBaseRenderer.test_polygon_no_projection)
	(TestBaseRenderer.test_raster_no_projection)
	(TestBaseRenderer.test_point_map_projection)
	(TestBaseRenderer.test_point_layer_and_map_projection)
	(TestBaseRenderer.test_point_layer_projection)
	(TestBaseRenderer.test_point_with_classification): Adapt to new
	renderer interface

2003-10-24  Bernhard Herzog  <bh@intevation.de>

	* libraries/thuban/wxproj.cpp (draw_polygon_shape)
	(point_in_polygon_shape, shape_centroid): Raise an exception if
	the shape can't be read. Previously invalid shape ids would lead
	to a segfault.

	* test/test_wxproj.py (TestShapeCentroid.test_invalid_shape_id):
	New. test whether an exception is raised for invalid shape ids

2003-10-24  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/Model/proj.py (Projection.GetProjectedUnits): Added 'longlat'
	as alias for 'latlong'.

	* Thuban/UI/projdialog.py (ProjFrame.__init__): Added 'longlat'
	as alias for 'latlong'.

2003-10-24  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/projdialog.py (ProjFrame.proj_selection_changed): Set
	the projection even for the UnknownPanel.
	(UnknownProjPanel.__init__): Define the text and create the textctrl
	widget.
	(UnknownProjPanel._DoLayout): Replaced static text widget by the
	textctrl created in __init__.
	(UnknownProjPanel.SetProjection): Set the text for the text ctrl
	including the parameters of the projection.
	
2003-10-24  Jan-Oliver Wagner <jan@intevation.de>

	* Resources/Projections/epsg.proj: New. This is a list of
	EPSG codes with parameters for proj. The list has been
	generated using devtools/create_epsg.py based on the
	file nad/epsg of the proj 4.4.7 package. Four projection
	definitions have been deleted as they are not accepted by proj:
	"CH1903+ / LV95", "Bern 1898 (Bern) / LV03C", "CH1903 / LV03"
	and "HD72 / EOV".

2003-10-22  Bernhard Herzog  <bh@intevation.de>

	Some more tweaks to the projection dialog which should fix RT
	#1886.

	* Thuban/UI/projlist.py (ProjectionList.Destroy): Unsubscribe from
	the ProjFile's messages and call the base class methods correctly
	(ProjectionList.SelectProjection): Set the wxLIST_STATE_FOCUSED
	flag on the newly selected item too. Otherwise some other item is
	focused and the first time the focus is moved with the keyboard
	the selection moves in unexpected ways.

	* Thuban/UI/projdialog.py (ProjFrame.__init__): Do not set the
	focus on the OK button, only on the projection list. That way the
	list really has the focus initially
	(ProjFrame.OnClose): Call the projection list's Destroy method to
	make it unsubscribe all messages

2003-10-21  Bernhard Herzog  <bh@intevation.de>

	Rework the projection dialog to fix a few bugs, including RT 2166
	and most of 2168

	* Thuban/UI/projlist.py: New. The class ProjectionList is a
	special wxListCtrl to show a list of projections in a more MVC
	fashion

	* Thuban/UI/projdialog.py (ProjFrame): Substantial changes
	throughout the class. The main change is to use the ProjectionList
	class instead of a normal wxListBox. Also, add an explicit
	"Unknown" projection to the projection choice control.
	(ProjPanel.__init__): Add an "unknown" ellipsoid
	(TMPanel.__init__, LCCPanel.__init__): Tweak the order of
	instantiation of the panel's controls to make the tab-order more
	natural

2003-10-21  Bernhard Herzog  <bh@intevation.de>

	* test/test_load.py (TestSingleLayer.file_contents)
	(TestSingleLayer.test): Add non-ascii characters to the titles of
	session, map and layer. This is effectively a port of the
	TestUnicodeStrings test in test_load_0_8.py which for some reason
	was only added there.

	* test/test_load_0_9.py (TestSingleLayer.file_contents)
	(TestSingleLayer.test): Same as in test_load.py: add non-ascii
	characters to the titles of session, map and layer,.

2003-10-21  Bernhard Herzog  <bh@intevation.de>

	Add EPSG projection handling to .thuban files

	* test/test_save.py (SaveSessionTest.dtd)
	(SaveSessionTest.testEmptySession)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table)
	(SaveSessionTest.test_save_postgis): Update to 1.0-dev namespace
	(SaveSessionTest.testSingleLayer): Update to 1.0-dev namespace and
	use a and epsg projection to test saving them

	* test/test_load.py (LoadSessionTest.dtd): Update to 1.0-dev
	namespace
	(TestLayerVisibility.file_contents, TestLabels.file_contents)
	(TestLayerProjection.file_contents)
	(TestRasterLayer.file_contents, TestJoinedTable.file_contents)
	(TestPostGISLayer.file_contents)
	(TestPostGISLayerPassword.file_contents)
	(TestLoadError.file_contents, TestLoadError.test): Update to use
	1.0-dev namespace
	(TestSingleLayer.file_contents, TestSingleLayer.test): Update to
	use 1.0-dev namespace and use an EPSG projection to test whether
	loading it works

	* test/test_load_0_9.py: New. Effectively a copy of test_load.py
	as of Thuban 0.9. These are now tests to determine whether Thuban
	can still read files generated by Thuban 0.9

	* Thuban/Model/save.py (SessionSaver.write)
	(SessionSaver.write_session): Use the 1.0 dtd and 1.0-dev
	namespace
	(SessionSaver.write_projection): Write the projection's epsg
	attribute

	* Thuban/Model/load.py (SessionLoader.__init__): Also accept the
	thuban-1.0-dev.dtd namespace
	(SessionLoader.check_attrs): Allow a callable object as conversion
	too
	(SessionLoader.start_projection, SessionLoader.end_projection)
	(SessionLoader.start_parameter): Handle the epsg attribute and
	rename a few instance variables to lower case

	* Resources/XML/thuban-1.0.dtd: New. Only difference to
	thuban-0.9.dtd is the epsg attribute for projections.

2003-10-21  Bernhard Herzog  <bh@intevation.de>

	* test/runtests.py (main): Let the user specify which tests to run
	on the command line

	* test/support.py (ThubanTestResult.getDescription): Override to
	give a better short description. The description can be used as a
	parameter to run_tests to run that particular test in isolation.

2003-10-21  Frank Koormann   <frank@intevation.de>

	Popup menu for legend. Scheduled for the 1.2 release this was too
	simple to implement: The popup menu is bound to the legend tree, while
	the events are hanlded by its anchestor, the legend panel. This
	allows reuse of all the event handlers already implemented for the 
	legend toolbar buttons.

	* Thuban/UI/legend.py (LegendPanel.__init__): EVT_MENU macros 
	to add handlers for the events issued by the popup menu.
 	(LegendPanel._OnToggleVisibility): Handler for toggling layer
	visibility event
    	(LegendPanel._OnProjection): Handler for layer projection event.
	(LegendTree.__init__): Added EVT_TREE_ITEM_RIGHT_CLICK
	(LegendTree._OnRightClick): Event handler for right click, select item
	and pop up menu.
	(LegendTree.ToggleVisibility): Toggle layer visibility
	(LegendTree.LayerProjection): Raise layer projection dialog for
	current layer.

2003-10-21  Bernhard Herzog  <bh@intevation.de>

	* Resources/Projections/defaults.proj: Use correct DOCTYPE
	declaration. The top-level element is projectionlist not projfile

2003-10-20  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/projdialog.py (ProjFrame.write_proj_file): New. helper
	method to write a projfile and display a busy cursor and error
	dialogs.
	(ProjFrame._OnSave, ProjFrame._OnAddToList, ProjFrame._OnImport)
	(ProjFrame._OnExport, ProjFrame._OnRemove): Use write_proj_file
	(ProjFrame.__FillAvailList): Translate "<None>" too and display a
	busy cursor while loading the user and system prj files.

2003-10-16  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/resource.py (projfile_cache): Introduce a cache for
	ProjFile objects
	(clear_proj_file_cache): New function to clear the cache. Mainly
	useful for use by the test suite
	(read_proj_file): Use the cache.

	* test/test_proj.py (TestProjFile): Clarify the doc-string
	(ProjFileReadTests): Update doc-string
	(ProjFileReadTests.test_get_system_proj_file): Check whether the
	system proj files is cached.
	(ProjFileLoadTestCase): New base class for the proj file tests
	derived from support.FileLoadTestCase to provide some common
	behavior.
	(TestLoadingProjFile)
	(TestLoadingProjFileWithEmptyProjectionlist.file_contents)
	(TestProjFileWithInvalidParameters.file_contents): Derive from
	ProjFileLoadTestCase
	(TestLoadingProjFile.test_caching): New. Test whether the cache
	works

2003-10-16 	Silke Reimer	<silke@intevation.de>

	* debian/*: New directory with configuration files for building a thuban
	  deb-package.

2003-10-14  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py: Execute support.run_tests when run as
	__main__ so that missing unsubscribes are detected
	(TestProjFile.tearDown): Destroy the proj_file properly

2003-10-14  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/messages.py (PROJECTION_ADDED)
	(PROJECTION_REPLACED, PROJECTION_REMOVED): New message types for
	the ProjFile objects

	* Thuban/Model/proj.py (ProjFile): Derive from Publisher so we can
	easily send messages when the projections change
	(ProjFile.Add, ProjFile.Remove, ProjFile.Replace): Issue messages
	when the change was successful

	* test/test_proj.py (TestProjFile.setUp): Subscribe to some of the
	proj file messages
	(TestProjFile.test_add_remove)
	(TestProjFile.test_remove_non_existing)
	(TestProjFile.test_replace)
	(TestProjFile.test_replace_non_existing): Test whether the right
	messages are sent

2003-10-14  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py (TestProjFile.test): Refactor into several
	tests
	(TestProjFile.test_add_remove)
	(TestProjFile.test_remove_non_existing)
	(TestProjFile.test_replace)
	(TestProjFile.test_replace_non_existing): Some of the new
	individual test cases
	(TestProjFileSimple): New class for the rest of the test cases
	that came out of the refactoring
	(ProjFileTest): Derive from xmlsupport.ValidationTest so that the
	derived classes don't have to

2003-10-13  Bernhard Herzog  <bh@intevation.de>

	Add an optional EPSG code to the projection objects and extend the
	.proj file format accordingly.

	* Resources/XML/projfile.dtd (element projection): Add epsg
	attribute

	* Thuban/Model/proj.py (Projection.__init__): New parameter and
	instance variable epsg. Update doc-string
	(Projection.EPSGCode, Projection.Label): New methods to provide
	access to EPSG code and a label for use in dialogs

	* Thuban/Model/resource.py (ProjFileReader.start_projection)
	(ProjFileReader.end_projection, ProjFileSaver.write_projfile):
	Handle the epsg code attribute when reading or writing proj files

	* Thuban/UI/projdialog.py (ProjFrame._OnSave)
	(ProjFrame._OnAddToList, ProjFrame.__DoOnProjAvail)
	(ProjFrame.__FillAvailList): Use the projection's Label method to
	get the string for the list box

	* test/test_proj.py (TestProjection.test_label)
	(TestProjection.test_label_epsg)
	(TestProjection.test_epsgcode_for_non_epsg_projection)
	(TestProjection.test_epsgcode_for_real_epsg_projection): New tests
	for the label and EPSGCode methods
	(WriteProjFileTests.doTestWrite, WriteProjFileTests.test_write)
	(WriteProjFileTests.test_write_empty_file): Create the ProjFile
	objects in the test cases and put the expected contents into the
	test case methods too. Update doTestWrite accordingly
	(TestLoadingProjFile)
	(TestLoadingProjFileWithEmptyProjectionlist): New classes with the
	read tests from TestProjFile.
	(TestProjFile.doTestRead, TestProjFile.testRead): Removed. These
	tests are now in the new classes.
	(sample_projfile, sample_projfile_data)
	(sample_projfile2, sample_projfile_data2): Removed. Not used
	anymore.
	(TestProjFile.test_read_unreadable_file): No need to reset the
	permissions at the end anymore since we use a unique filename

2003-10-13  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py: Some more refactoring of the test cases
	(ProjFileTest): New base class for the proj file tests.
	(TestProjFile): Derive from ProjFileTest
	(TestProjFile.test_read_unreadable_file)
	(TestProjFile.test_read_empty_file, TestProjFile.doTestRead): Use
	the new filename method to get a unique filename
	(TestProjFile.doTestWrite, TestProjFile.testWrite): Removed.
	(WriteProjFileTests): New class for proj file write tests.
	Contains the write test that were in TestProjFile originally.

2003-10-13  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py (TestProjFile.testRead)
	(TestProjFile.test_read_non_existing_file)
	(TestProjFile.test_read_unreadable_file)
	(TestProjFile.test_read_empty_file): Split into several methods.

2003-10-10  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/sizers.py: New file with custom sizers.

	* Thuban/UI/projdialog.py (ProjFrame.build_dialog): Instantiate
	all projection type specific panels and put them into a
	NotebookLikeSizer. This way the dialog doesn't change its size
	when a different projection is selected
	(ProjFrame.__init__): Rename projection_panels
	projection_panel_defs and reuse projection_panels for a list of
	the instantiated panels.
	(ProjFrame._show_proj_panel, ProjFrame.__DoOnProjAvail)
	(ProjFrame.__DoOnProjChoice): Changes due to the new handling of
	the panels
	(UnknownProjPanel._DoLayout): Place the newlines in the message
	differently to make the panel narrower.
	(TMPanel._DoLayout): Layout the parameters in one column.

2003-10-10  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/projdialog.py (ProjFrame.build_dialog): New method
	that contains all the setup for the dialog's widgets, layout and
	event handling.
	(__): Call build_dialog to build the dialog.
	(ProjFrame.__set_properties, ProjFrame.__do_layout): Removed.
	Their functionality is now in build_dialog
	(ProjFrame.__VerifyButtons, ProjFrame.__VerifyButtons)
	(ProjFrame.__DoOnProjAvail, ProjFrame.__DoOnProjAvail)
	(ProjFrame.__DoOnProjChoice): Small updates due to slightly
	different widget names and hierarchy introduced with build_dialog.

2003-10-10  Bernhard Herzog  <bh@intevation.de>

	* README: Fix typo.

2003-10-09  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/proj.py (ProjFile.Add): Do not check whether the
	projection is already in the list. This is *a lot* faster when
	loading files with hundreds of projections since it saves a linear
	search. OTOH this will allow adding the same projection to the
	user.proj file multiple times in the projection dialog but we'll
	deal with that later

2003-10-09  Jan-Oliver Wagner <jan@intevation.de>

	* devtools: New. Directory for developer tools that are not intended
	for the regular user.

	* devtools/create_epsg.py: New. Convert the epsg file of proj into
	a python .proj file.

2003-10-09  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py
	(TestProjection.test_get_parameter_without_equals_sign): New. Test
	whether GetParameter handles parameters without "=" sign correctly

	* Thuban/Model/proj.py (Projection.GetParameter): Handle
	parameters that do not contain a "=". Update the doc-string

2003-10-08  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/projdialog.py (ProjFrame.__set_properties): Remove the
	length limit on the projname text control

2003-10-08  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py (TestProjection.test_get_projection_units_geo)
	(TestProjection.test_get_projection_units_normal): New. Tests for
	the Projection.GetProjectedUnits method

2003-10-08  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/Model/resource.py (get_user_proj_file): small bug-fix:
	Added missing 'val' parameter.

2003-10-08  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/projdialog.py (ProjFrame.__DoOnProjAvail): When the
	projection type of the currently selected projection is not known,
	i.e. there's no panel for it, use the UnknownProjPanel
	(ProjFrame.__DoOnProjChoice, ProjFrame._show_proj_panel): Split
	the actual replacing of the proj panel into the new method
	_show_proj_panel.
	(UnknownProjPanel): Add doc-string.
	(UnknownProjPanel._DoLayout): Insert a newline into the text so
	that the panel is not so wide.

2003-10-08  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/resource.py (read_proj_file): Return the warnings
	too. Update the doc-string
	(get_proj_files): Removed. It wasn't used anywhere
	(get_system_proj_files, get_system_proj_file): Rename to
	get_system_proj_file and return the ProjFile object and not a list
	of ProjFile objects. Update the callers.
	(get_user_proj_files, get_user_proj_file): Rename to
	get_user_proj_file return the ProjFile object and not a list of
	ProjFile objects. Update the callers.
	(ProjFileReader.__init__): New instance variable for the warnings.
	Rename the __pf ivar to projfile. Update the methods referring to
	__pf
	(ProjFileReader.end_projection): Catch any errors raised when
	instantiating the projection and record that as an error. The
	projection will not be in the final ProjFile object.
	(ProjFileReader.GetWarnings): New method to return the warnings.

	* Thuban/UI/projdialog.py (ProjFrame.show_warnings): New method to
	show the warnings from the projfile reader
	(ProjFrame._OnImport): Deal with any warnings returned by
	read_proj_file
	(ProjFrame.__FillAvailList): Deal with any warnings returned by
	get_system_proj_file or get_user_proj_file.

	* test/test_proj.py (TestProjFile.doTestRead): Check the warnings.
	(TestProjFileWithInvalidParameters.file_contents): New test cases
	to test whether read_proj_file handles invalid projection
	parameters correctly
	(TestProjFile.test_get_system_proj_file): New. Simple test for
	resource.get_system_proj_file

2003-10-07  Bernhard Herzog  <bh@intevation.de>

	* test/test_derivedshapestore.py
	(TestDerivedShapeStoreExceptions.tearDown): Clear the session
	properly so that the temporary directories get deleted correctly

2003-10-06  Bernhard Herzog  <bh@intevation.de>

	Handle the title changes in a proper MVC way.

	* Thuban/UI/mainwindow.py (MainWindow.__init__): Subscribe to the
	canvas' TITLE_CHANGED messages
	(MainWindow.update_title): New. Update the main window's title
	(MainWindow.__SetTitle): Removed. Use update_title instead.
	(MainWindow.SetMap): Use update_title instead of __SetTitle
	(MainWindow.RenameMap): Do change the window title explicitly
	here. That's handled in a proper MVC way now.
	(MainWindow.title_changed): New. Subscriber for the TITLE_CHANGED
	messages

	* Thuban/Lib/connector.py (Conduit): New class to help classes
	that forward messages

	* Thuban/UI/viewport.py: Forward the map's TITLE_CHANGED messages
	(ViewPort): Derive from Conduit instead of Publisher
	(ViewPort.Subscribe, ViewPort.Unsubscribe): Use the new base class
	when calling the inherited versions
	(ViewPort._subscribe_map, ViewPort._unsubscribe_map): New helper
	methods to subscribe and unsubscribe map messages
	(ViewPort.SetMap, ViewPort.Destroy): Use the new helper methods to
	handle the map subscriptions
	(ViewPort.Map, ViewPort.map_projection_changed) 
	(ViewPort.layer_projection_changed): Add or update doc-strings

	* test/test_connector.py (TestPublisher.test_issue_simple): Fix
	typo
	(MyConduit): Helper class for the Conduit test.
	(TestConduit): Test cases for Conduit

	* test/test_connector.py: Use support.run_tests as main.

	* test/test_viewport.py (ViewPortTest.setUp): Also subscribe to
	the TITLE_CHANGED messages
	(ViewPortTest.test_forwarding_title_changed): New test to check
	whether the viewport forwards the map's TITLE_CHANGED messages
	(TestViewportWithPostGIS.tearDown): Call the map's Destroy method
	after the port's because the latter may require a still functional
	map.

2003-10-06  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/application.py (ThubanApplication.maps_changed): Add
	doc-string

2003-10-06  Bernhard Herzog  <bh@intevation.de>

	* test/test_viewport.py (ViewPortTest.setUp)
	(SimpleViewPortTest.test_init_with_size): Move the test for the
	initial size as a constructor parameter from ViewPortTest.setUp
	method to a new separate test in SimpleViewPortTest.

2003-10-06  Bernhard Herzog  <bh@intevation.de>

	* test/test_viewport.py (MockView): New class derived from
	ViewPort with a mock implementation of GetTextExtent to be used in
	the test cases
	(ViewPortTest.setUp): Use MockView instead of ViewPort

	* Thuban/UI/viewport.py (ViewPort.GetTextExtent): Turn this method
	into what would be a "pure virtual function" in C++: always raise
	NotImplementedError. Mock implementations for test cases don't
	belong into the real code

2003-10-02  Bernhard Herzog  <bh@intevation.de>

	* test/test_layer.py (TestLayer.test_empty_layer): Explicitly
	close the dbf file we create so that it's contents have been
	written properly.

	* libraries/shapelib/shptree.c, libraries/shapelib/shpopen.c,
	libraries/shapelib/shapefil.h, libraries/shapelib/dbfopen.c:
	Update to shapelib 1.2.10

2003-10-01  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/tree.py, Thuban/UI/main.py: Remove the #! line as
	it annoys lintian which warns about these files not being
	executable. The #! isn't necessary here since if you absolutely
	must execute them you can always say "python <filename>".

2003-09-26  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/classgen.py (GenQuantiles0): Removed since it's
	only used in GREAT-ER but not used in Thuban itself. When GREAT-ER
	is ported to a newer the import will fail, so it should be noticed
	immediately that this function is gone.
	Fixes RT#1919

2003-09-26  Bernhard Herzog  <bh@intevation.de>

	Add a DTD for the projection files and make thuban write valid
	projection files

	* Resources/XML/projfile.dtd: New. DTD for thuban's projection
	files

	* Thuban/Model/resource.py (ProjFileSaver.write): Use
	'projectionlist' as the name in the document type declaration so
	that it matches the element type of the root element.

	* test/test_proj.py (sample_projfile, sample_projfile2): Use
	'projectionlist' as the name in the document type declaration just
	as it is done now in the files thuban would write
	(sample_projfile, sample_projfile_data): Fix spelling of
	"Mercator"
	(TestProjFile.doTestWrite): Validate the written and the expected
	XML data
	(TestProjFile): Derive from ValidationTest so that we can run xml
	validation tests

2003-09-24  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/renderer.py (ExportRenderer.render_legend): Do not
	modify the list returned by map.Layers() in place since it is the
	actual list of layers used by the map.

2003-09-23  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual.xml: Added subsection to chapter
	Extensions to describe the extensions coming with the Thuban
	standard package (gns2shp and importAPR).

2003-09-23  Bernhard Herzog  <bh@intevation.de>

	* libraries/thuban/wxproj.cpp (project_point): if there's an
	inverse but no forward projection, convert to degrees after
	applying the inverse projection. Fixes RT#2096

	* test/test_wxproj.py: New. Test cases for wxproj.so. One test
	implicitly tests for the fix to RT#2096

	* test/support.py (FloatComparisonMixin.assertFloatSeqEqual):
	Check that the sequences have the same lengths

	* Resources/Projections/defaults.proj (Geographic projection): Use
	a much more precise value for the to_meter attribute.

2003-09-22  Bernhard Herzog  <bh@intevation.de>

	* test/support.py (initthuban): Make sure to unset the LANG env.
	var. so that tests that compare translated strings work. Solves RT
	#2094

2003-09-22  Jan-Oliver Wagner <jan@intevation.de>

	Small improvement of APR import.

	* Extensions/importAPR/test/test_apr.py (aprTest.test_LClass): 
	Added tests for text-ranges.

	* Extensions/importAPR/apr.py (APR_LClass.GetThubanRange): Now
	returns a string object if the range is based on text.

	* Extensions/importAPR/importAPR.py (import_apr_dialog): Unified
	range retrieval.

2003-09-22  Jan-Oliver Wagner <jan@intevation.de>

	Initial version of the importAPR extension which is in
	experimental state.

	* /Extensions/importAPR/, /Extensions/importAPR/samples/,
	/Extensions/importAPR/test/: New directories.

	* /Extensions/importAPR/samples/README: New: Howto load the samples.

	* /Extensions/importAPR/samples/iceland.apr: New: A sample APR
	file which refers to the Thuban Iceland demo data.

	* /Extensions/importAPR/test/README: New: Howto execute the tests.

	* /Extensions/importAPR/test/test_apr.py: New: Tests for APR classes.

	* /Extensions/importAPR/apr.py: New: Classes for ArcView Objects
	as in '.apr'-files.

	* /Extensions/importAPR/odb.py: New: Classes for generic ArcView
	ODB Objects as in '.apr', '.avl' and other files.

	* /Extensions/importAPR/__init__.py: New: Init to make this
	directory a package.

	* /Extensions/importAPR/importAPR.py: New: Import a ArcView
	project file (.apr) and convert it to Thuban.

2003-09-22  Jan-Oliver Wagner <jan@intevation.de>

	* Extensions/gns2shp.gns2shp.py: The main module of gns2shp.

2003-09-19  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual.xml: Extended section 'Installation'
	with description on RPM installation and RPM binary package
	creation.

2003-09-18  Bernhard Herzog  <bh@intevation.de>

	* setup.py (data_files): Only add the mo files if the Locales
	directory actually exists, so that setup.py works with a fresh CVS
	checkout

2003-09-12  Jan-Oliver Wagner <jan@intevation.de>

	* Examples/simple_extensions/simple_tool.py: bugfix: Tool is now
	in viewport, not anymore in view

2003-09-04  Jan-Oliver Wagner <jan@intevation.de>

	Introducing first Extension (gns2shp).

	* Extensions, Extensions/gns2shp, Extensions/gns2shp/test: New.

	* Extensions/__init__.py: New. init to make this dir a package.

	* Extensions/gns2shp/__init__.py: New. init to make this dir a package.

	* Extensions/gns2shp/test/README: New. some info on this test directory.

	* Extensions/gns2shp/test/ls.txt: New. test data set (Liechtenstein).

	* Extensions/gns2shp/test/test_gns2shp.py: New. Test for correct creation
	of Shapefile from GNS text file format

2003-09-03  Jan-Oliver Wagner <jan@intevation.de>

	Fix/workaround for bug #2019:
	https://intevation.de/rt/webrt?serial_num=2019

	* Thuban/UI/identifyview.py (IdentifyView.ID_STOP): New.
	(IdentifyView.__init__): Added another button that allows to
	stop the identify mode.
	(IdentifyView.OnStop): New. Stops the identify mode.

2003-09-03  Jan-Oliver Wagner <jan@intevation.de>

	Introducing a new exception dialog that allows to exit the
	application immediately.
	This fixes bug #2060: https://intevation.de/rt/webrt?serial_num=2060

	* Thuban/UI/exceptiondialog.py: New. A special exception dialog.

	* Thuban/UI/application.py (ThubanApplication.ShowExceptionDialog):
	Made strings available to translations. Exchanged the simple
	ScrolledMessageDialog by the new ExceptionDialog.

2003-09-01  Bernhard Herzog  <bh@intevation.de>

	* NEWS: New. Summary of changes and release notes.

	* MANIFEST.in: Add NEWS

2003-09-01  Bernhard Herzog  <bh@intevation.de>

	* MANIFEST.in: Correct the include statement for the mo-files and
	include the documentation too.

	* setup.py (data_files): Add the .mo files
	(setup call): Up to version 0.9.0

2003-09-01  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/dbdialog.py (ChooseDBTableDialog.__init__): Change the
	parameter list to just parent and session
	(ChooseDBTableDialog.__set_properties): Removed. Setting the
	selection of empty list boxes is not allowed (and produces C++
	assertion errors) and the rest of the setup is better done in
	__init__ anyway.
	(ChooseDBTableDialog.OnCancel, ChooseDBTableDialog.OnOK)
	(ChooseDBTableDialog.OnLBDClick, DBDialog.OnOK): Use the Python
	builtins True/False for booleans to avoid warnings from wxPython

	* Thuban/UI/mainwindow.py (MainWindow.AddDBLayer): Adapt to new
	ChooseDBTableDialog constructor parameters.

2003-09-01  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py
	(PostGISTable): Extend doc-string
	(PostGISTable._fetch_table_information): Set the column index
	correctly, pretending ignored columns don't exist.

	* test/test_postgis_db.py (TestPostGISIgnoredColumns): New tests
	for postgis tables with data types not yet supported by thuban.

2003-08-29  Bernhard Herzog  <bh@intevation.de>

	* HOWTO-Release: Tweak item about running the tests.

2003-08-29  Jan-Oliver Wagner <jan@intevation.de>

	* /Doc/manual/thuban-manual.xml: updated to version 1.0pre2.

2003-08-29  Bernhard Herzog  <bh@intevation.de>

	Add some missing parameters to projections. Proj complains about
	them on windows but for some reason not on Linux.

	* test/test_save.py (SaveSessionTest.testLayerProjection): Add
	missing required projection parameters

	* test/test_proj.py (TestProjFile.test): Add missing required
	projection parameters

	* test/test_load_0_8.py (TestLayerProjection.file_contents)
	(TestLayerProjection.test): Add missing required projection
	parameters and tests for them

	* test/test_load.py (TestLayerProjection.file_contents)
	(TestLayerProjection.test): Add missing required projection
	parameters and tests for them

	* test/test_layer.py (TestLayer.test_base_layer): Add missing
	required projection parameters

2003-08-29  Bernhard Herzog  <bh@intevation.de>

	* libraries/pyprojection/Projection.i: Use pj_get_errno_ref to
	access the pj_errno because directly accessing pj_errno doesn't
	work on windows if the proj library is in a DLL

	* libraries/pyprojection/Projection_wrap.c: Update from Projection.i

2003-08-28  Bernhard Herzog  <bh@intevation.de>

	* test/test_proj.py: Import things from Thuban after calling
	initthuban

	* test/test_load.py (LoadSessionTest.filenames): New class
	variable with the filename attributes to normalize
	(LoadSessionTest.check_format): Pass self.filenames to
	sax_eventlist to normalize the filename attributes

	* test/xmlsupport.py: Add cvs keywords
	(SaxEventLister.__init__): New parameter filenames which indicates
	attributes that contain filenames
	(SaxEventLister.startElementNS): Normalize the filename attributes
	with os.path.normpath
	(sax_eventlist): New parameter filenames to pass through to
	SaxEventLister

	* test/test_derivedshapestore.py: Make this file callable as a
	program to execute the tests
	(TestDerivedShapeStoreExceptions.test_table_with_wrong_size): Bind
	the session to self.session so that it gets destroyed properly

	* test/test_layer.py (TestLayer.tearDown): Call the session's
	Destroy method

	* test/test_map.py (TestMapBase.tearDown): Destroy self.session
	too if it exists
	(TestMapAddLayer.test_add_layer): Bind the session to self.session
	so that it gets destroyed properly

	* test/postgissupport.py (reason_for_not_running_tests): Add a
	test for the existence of popen2.Popen4.

	* test/test_save.py (SaveSessionTest.tearDown): New. Provide a
	reliable way to destroy the sessions created in the test cases
	(SaveSessionTest.test_dbf_table): Bind the session to self.session
	so that it gets destroyed properly
	(SaveSessionTest.testLayerProjection): Bind the session to
	self.session so that it gets destroyed properly

	* test/test_session.py (UnreferencedTablesTests.tearDown): Make
	sure that the session is destroyed properly

	* test/test_shapefilestore.py: Make this callable as a program to
	execute the tests

	* test/test_scalebar.py: Remove unnecessary import of _ from
	Thuban

	* test/support.py (print_garbage_information): Call initthuban
	here because it may be called indirectly from test cases that test
	test support modules which do not use anything from thuban itself
	(ThubanTestProgram.runTests): Remove unnecessary debug print

2003-08-28  Bernhard Herzog  <bh@intevation.de>

	* Thuban/version.py (longversion): Update to 0.9

	* Thuban/UI/mainwindow.py: Remove some unused imports

	* README: Add section about required additional software. Add date
	and revision CVS keywords

	* HOWTO-Release: Add item about the translations. Add date and
	revision CVs keywords and change formatting to match README a bit
	better

	* po/de.po: Update for 0.9

	* test/README: Tweak the wording a little because many tests are
	not really unittest.

2003-08-27  Bernhard Herzog  <bh@intevation.de>

	As preparation for the 0.9 release, switch thuban files to a
	non-dev namespace

	* Thuban/Model/save.py (SessionSaver.write_session): Write files
	with the http://thuban.intevation.org/dtds/thuban-0.9.dtd
	namespace

	* Thuban/Model/load.py (SessionLoader.__init__): Accept the
	http://thuban.intevation.org/dtds/thuban-0.9.dtd namespace too

	* test/test_save.py (SaveSessionTest.dtd)
	(SaveSessionTest.testEmptySession)
	(SaveSessionTest.testSingleLayer)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table)
	(SaveSessionTest.test_save_postgis): Update for new namespace

	* test/test_load.py (LoadSessionTest.dtd, TestSingleLayer)
	(TestLayerVisibility.file_contents, TestLabels.file_contents)
	(TestLayerProjection.file_contents)
	(TestRasterLayer.file_contents, TestJoinedTable.file_contents)
	(TestPostGISLayer.file_contents)
	(TestPostGISLayerPassword.file_contents)
	(TestLoadError.file_contents, TestLoadError.test): Update for new
	namespace

2003-08-27  Bernhard Herzog  <bh@intevation.de>

	Make the table interface distinguish between row ids (an integer
	that uniquely identifies a row) and row ordinals (a simple row
	count from 0 to NumRows() - 1)

	* Thuban/Model/postgisdb.py (PostGISTable.RowIdToOrdinal)
	(PostGISTable.RowOrdinalToId): New methods to conver between row
	ids and row ordinals
	(PostGISTable.ReadRowAsDict, PostGISTable.ReadValue): New keyword
	parameter row_is_ordinal to indicate whether the row parameter is
	the row id or the ordinal

	* Thuban/Model/transientdb.py (TransientTableBase.RowIdToOrdinal)
	(TransientTableBase.RowOrdinalToId)
	(AutoTransientTable.RowIdToOrdinal)
	(AutoTransientTable.RowOrdinalToId): Same new methods as in
	PostGISTable.
	(TransientTableBase.ReadRowAsDict, TransientTableBase.ReadValue)
	(AutoTransientTable.ReadRowAsDict, AutoTransientTable.ReadValue):
	Same new parameter as in PostGISTable.

	* Thuban/Model/table.py (DBFTable.RowIdToOrdinal)
	(DBFTable.RowOrdinalToId, MemoryTable.RowIdToOrdinal)
	(MemoryTable.RowOrdinalToId): Same new methods as in PostGISTable.
	(DBFTable.ReadValue, DBFTable.ReadRowAsDict)
	(MemoryTable.ReadValue, MemoryTable.ReadRowAsDict): Same new
	parameter as in PostGISTable.

	* Thuban/UI/tableview.py (DataTable.RowIdToOrdinal)
	(DataTable.RowOrdinalToId): New methods to convert between row ids
	and row ordinals.
	(TableGrid.SelectRowById): New method to select a row based on its
	ID as opposed to its ordinal
	(DataTable.GetValue, TableGrid.OnRangeSelect)
	(TableGrid.OnSelectCell, LayerTableGrid.select_shapes)
	(QueryTableFrame.OnQuery, QueryTableFrame.get_selected)
	(LayerTableFrame.__init__): Convert between row ids and row
	ordinals as appropriate

	* test/postgissupport.py (PostGISDatabase.__init__): Add
	doc-string.
	(PostGISDatabase.initdb): The optional third item in a tuple in
	tables is now a (key, value) list with additional arguments to
	pass to upload_shapefile
	(upload_shapefile): New parameter gid_offset to allow gids that
	are not the same as the shapeids in the shapefile
	(PostgreSQLServer.get_default_static_data_db): Use the new
	gid_offset to make the gids in landmarks 1000 higher than the
	shapeids in the shapefile

	* test/test_viewport.py
	(TestViewportWithPostGIS.test_find_shape_at_point): Adapt to the
	new shapeids in the landmarks table

	* test/test_transientdb.py
	(TestTransientTable.run_iceland_political_tests)
	(TestTransientTable.test_transient_joined_table): Add tests for
	the new table methods and new keywords arguments.

	* test/test_postgis_db.py
	(TestPostGISTable.test_read_row_as_dict_row_count_mode)
	(TestPostGISTable.test_read_value_row_count_mode)
	(TestPostGISTable.test_row_id_to_ordinal)
	(TestPostGISTable.test_row_oridnal_to_id): New test for the new
	table methods and the new arguments
	(TestPostGISShapestorePoint.test_shapes_in_region)
	(TestPostGISShapestorePoint.test_shape_raw_data)
	(TestPostGISShapestorePoint.test_shape_points)
	(TestPostGISShapestorePoint.test_shape_shapeid)
	(TestPostGISShapestorePoint.test_all_shapes)
	(TestPostGISTable.test_simple_query)
	(TestPostGISTable.test_simple_query)
	(TestPostGISTable.test_simple_query)
	(TestPostGISTable.test_read_value)
	(TestPostGISTable.test_read_row_as_dict): Adapt to the new
	shapeids in the landmarks table

	* test/test_memory_table.py
	(TestMemoryTable.test_read_row_as_dict_row_count_mode)
	(TestMemoryTable.test_read_value_row_count_mode)
	(TestMemoryTable.test_row_id_to_ordinal)
	(TestMemoryTable.test_row_oridnal_to_id): New test for the new
	table methods and the new arguments

	* test/test_dbf_table.py
	(TestDBFTable.test_read_row_as_dict_row_count_mode)
	(TestDBFTable.test_read_value_row_count_mode)
	(TestDBFTable.test_row_id_to_ordinal)
	(TestDBFTable.test_row_oridnal_to_id): New test for the new table
	methods and the new arguments

2003-08-26  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py (PostGISShapeStore.BoundingBox): Use a
	more postgis specific but much faster method to get the bounding
	box

2003-08-26  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py (PostGISTable.Title)
	(PostGISShapeStore.AllShapes): Add these missing methods.
	(PostGISShapeStore.ShapesInRegion): No need to raise
	StopIteration. We can simply return

	* test/test_postgis_db.py (TestPostGISTable.test_title)
	(TestPostGISShapestorePoint.test_all_shapes): New tests for the
	new methods

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py (shapetype_map): Add MUTLIPOLYGON.

	* test/test_postgis_db.py (PolygonTests): New class containing
	those tests from TestPostGISShapestorePolygon that can also be
	used to test MUTLIPOLYGON tables
	(TestPostGISShapestorePolygon): Most tests are now in PolygonTests
	so derive from that
	(TestPostGISShapestoreMultiPolygon): New class with tests for
	MUTLIPOLYGON tables

	* test/postgissupport.py (PostGISDatabase.initdb): Allow the
	tables argument to have tuples with three items to override the
	WKT type used.
	(PostgreSQLServer.get_default_static_data_db): Use the above to
	create a polygon table with MUTLIPOLYGONs
	(point_to_wkt, coords_to_point, polygon_to_wkt, coords_to_polygon)
	(arc_to_wkt, coords_to_multilinestring): Rename from *_to_wkt to
	coords_to*
	(coords_to_multipolygon): New. Convert to MUTLIPOLYGON
	(wkt_converter): New. Map WKT types to converters
	(upload_shapefile): New parameter force_wkt_type to use a
	different WKT type than the default

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/application.py
	(ThubanApplication.run_db_param_dialog): New. Suitable as a
	db_connection_callback. Main difference is that the dialog run
	from this method doesn't have a parent so it can be used even when
	there is no main window
	(ThubanApplication.OpenSession): Use self.run_db_param_dialog if
	no db_connection_callback was given. This way the dialog pops up
	even when the .thuban file was given as a command line parameter.

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/view.py (MapCanvas.OnLeftUp): Release the the mouse
	before calling MouseLeftUp. MouseLeftUp may pop up modal dialogs
	which leads to an effectively frozen X session because the user
	can only interact with the dialog but the mouse is still grabbed
	by the canvas.
	Also, call the tool's Hide method before MouseLeftUp because
	MouseLeftUp may change the tool's coordinates.

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/application.py (ThubanApplication.OpenSession): Catch
	LoadCancelled exceptions and handle them by returning immediately.

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	GUI part of loading sessions with postgis connections which may
	require user interaction to get passwords or updated parameters

	* Thuban/UI/dbdialog.py (DBDialog): Reimplement to make it look a
	bit nucer and be more generic.
	(DBFrame.OnAdd): Adapt to new DBDialog interface

	* Thuban/UI/application.py (ThubanApplication.OpenSession): New
	optional parameter db_connection_callback which is passed to
	load_session.

	* Thuban/UI/mainwindow.py (MainWindow.run_db_param_dialog): New.
	Suitable as a db_connection_callback
	(MainWindow.OpenSession): Use self.run_db_param_dialog as the
	db_connection_callback of the application's OpenSession method


2003-08-25  Bernhard Herzog  <bh@intevation.de>

	Basic loading of sessions containing postgis connections:

	* Thuban/Model/load.py (LoadError): Add doc-string
	(LoadCancelled): New exception class to indicate a cancelled load
	(SessionLoader.__init__): Add the db_connection_callback parameter
	which will be used by the loader to get updated parameters and a
	password for a database connection
	(SessionLoader.__init__): Add the new XML elements to the
	dispatchers dictionary
	(SessionLoader.check_attrs): Two new conversions, ascii to convert
	to a byte-string object and idref as a generic id reference
	(SessionLoader.start_dbconnection)
	(SessionLoader.start_dbshapesource): New. Handlers for the new XML
	elements
	(load_session): Add the db_connection_callback to pass through the
	SessionLoader

	* test/test_load.py (TestPostGISLayer, TestPostGISLayerPassword):
	New classes to test loading of sessions with postgis database
	connections.

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/mainwindow.py (__ThubanVersion__): Remove this and
	replace it and the comment with __BuildDate__ by the Source: and
	Id: cvs keywords as used in the other files.

2003-08-25  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/load.py (SessionLoader.check_attrs): Raise a
	LoadError when a required attribute is missing. The code used to
	be commented out for some reason, but probably should have been
	active.

	* test/test_load.py (TestLoadError.test): Test the message in the
	LoadError too to make sure it really is about the missing
	attribute

2003-08-22  Bernhard Herzog  <bh@intevation.de>

	* test/test_save.py (SaveSessionTest.test_dbf_table) 
	(SaveSessionTest.test_joined_table): Add XML validation tests.

2003-08-22  Bernhard Herzog  <bh@intevation.de>

	Implement saving a session with a postgis connection

	* Resources/XML/thuban-0.9.dtd (dbconnection, dbshapesource) New
	elements for database connections and shapestores using db
	connections
	(session): Add the dbconnections to the content model

	* Thuban/Model/save.py (SessionSaver.write_db_connections): New.
	Write the db connections
	(SessionSaver.write_session): Call write_db_connections to write
	the connection before the data sources
	(SessionSaver.write_data_containers): Handle postgis shapestores

	* test/test_save.py (SaveSessionTest.thubanids)
	(SaveSessionTest.thubanidrefs): Update for new DTD
	(SaveSessionTest.test_save_postgis): New. Test saving a session
	with postgis connections

	* Thuban/Model/postgisdb.py (PostGISTable.DBConnection)
	(PostGISTable.TableName): New accessor methods for the connection
	and table name

	* test/test_postgis_db.py (TestPostGISTable.test_dbconn)
	(TestPostGISTable.test_dbname): New methods to test the new
	PostGISConnection methods

2003-08-22  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/postgisdb.py (ConnectionError): New exception class
	for exceptions occurring when establishing a Database connection
	(PostGISConnection.connect): Catch psycopg.OperationalError during
	connects and raise ConnectionError.

	* test/test_postgis_db.py (TestPostgisDBExceptions): New class for
	tests for database exceptions

2003-08-22  Bernhard Herzog  <bh@intevation.de>

	Prepare the test suite for tests with required authentication

	* test/postgissupport.py (PostgreSQLServer.__init__): Add instance
	variables with two predefined users/passwords, one for the admin
	and one for a non-privileged user.
	(PostgreSQLServer.createdb): Pass the admin name to initdb and add
	the non-privileged user to the database and set the admin password
	(PostgreSQLServer.wait_for_postmaster): Use the admin user name.
	Better error reporting
	(PostgreSQLServer.connection_params)
	(PostgreSQLServer.connection_string): New methods to return
	information about how to connect to the server
	(PostgreSQLServer.execute_sql): New. Convenience method to execute
	SQL statements
	(PostgreSQLServer.require_authentication): Toggle whether the
	server requires authentication
	(PostgreSQLServer.create_user, PostgreSQLServer.alter_user): New.
	Add or alter users
	(PostGISDatabase.initdb): Pass the admin name one the
	subprocesses' command lines. Grant select rights on
	geometry_columns to everybody.
	(upload_shapefile): Use the admin name and password when
	connecting. Grant select rights on the new table to everybody.

	* test/test_viewport.py (TestViewportWithPostGIS.setUp): Use the
	server's new methods to get the connection parameters.

	* test/test_postgis_session.py (TestSessionWithPostGIS.setUp)
	(TestSessionWithPostGIS.test_remove_dbconn_exception): Use the
	server's new methods to get the connection parameters.

	* test/test_postgis_db.py
	(TestPostGISConnection.test_gis_tables_empty)
	(TestPostGISConnection.test_gis_tables_non_empty)
	(PostGISStaticTests.setUp): Use the server's new methods to get
	the connection parameters.

2003-08-22  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/about.py (About.__init__): Add the psycopg version.

	* Thuban/version.py: Add psycopg version

	* Thuban/Model/postgisdb.py (psycopg_version): New. Return the
	version of the psycopg module

2003-08-22  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/dbdialog.py (DBPwdDlg): Removed because it's not used.
	(DBFrame.OnEdit): Removed because it's not used and wouldn't work
	at the moment. The functionality should probably be implemented
	some time, though.
	(DBFrame.OnRemove): Display a message if the connection can't be
	removed because it's still in use.

2003-08-22  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/about.py (About.__init__): split up the huge about
	text into elements/lists for easier translation. This fixes bug
	https://intevation.de/rt/webrt?serial_num=2058
	Also, made some forgotten string available for the i18n.

2003-08-21  Bernhard Herzog  <bh@intevation.de>

	Make postgis support really optional including insensitive menu
	items.

	* Thuban/Model/postgisdb.py (has_postgis_support): New. Return
	whether the postgis is supported.

	* Thuban/UI/dbdialog.py: Put the psycopg import into try..except
	to make postgis support optional

	* Thuban/UI/mainwindow.py (_has_postgis_support): New. Context
	version of Thuban.Model.postgisdb.has_postgis_support
	(database_management command): Make it only sensitive if postgis
	is supported.

2003-08-21  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual.xml: Added CVS revision for rev-history.
	(section Adding and Removing Layers): Added text and described
	multi-selection.
	(chapter Extensions): New.

2003-08-21  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.AddLayer): Changed dialog
	settings to allow multiple files to load into the map.
	Also reduced selection to *.shp as a default.

2003-08-20  Bernhard Herzog  <bh@intevation.de>

	Add dialogs and commands to open database connections and add
	database layers.

	* Thuban/UI/mainwindow.py (MainWindow.DatabaseManagement): New
	method to open the database connection management dialog
	(MainWindow.AddDBLayer): New method to add a layer from a database
	(_has_dbconnections): New helper function to use for sensitivity
	(database_management command, layer_add_db command): New commands
	that call the above new methods.
	(main_menu): Add the new commands to the menu.

	* Thuban/Model/postgisdb.py (PostGISConnection.__init__)
	(PostGISConnection.connect): Establish the actual connection in a
	separate method and call it in __init__. This makes it easier to
	override the behavior in test cases
	(PostGISConnection.BriefDescription): New method to return a brief
	description for use in dialogs.

	* test/test_postgis_db.py (NonConnection): DB connection that
	doesn't actually connect
	(TestBriefDescription): New class with tests for the new
	BriefDescription method

2003-08-19  Jan-Oliver Wagner <jan@intevation.de>

	Moved anything from extensions to libraries.

	* libraries: New.

	* libraries/ pyprojection, pyshapelib, shapelib, thuban: New.

	* libraries/pyprojection/ LICENSE, MANIFEST.in, Projection.i,
	Projection.py, Projection_wrap.c, setup.py, swighelp.txt: These files have
	been moved here from thuban/extensions/pyprojection/
	See there in the Attic for the older history.

	* libraries/pyshapelib/ COPYING, ChangeLog, NEWS, README, dbflib.i,
	dbflib.py, dbflib_wrap.c, pyshapelib_api.h, pytest.py, setup.py,
	shapelib.i, shapelib.py, shapelib_wrap.c, shptreemodule.c: These files
	have been moved here from thuban/extensions/pyshapelib/
	See there in the Attic for the older history.

	* libraries/shapelib/ dbfopen.c, shapefil.h, shpopen.c, shptree.c: These
	files have been moved here from thuban/extensions/shapelib/
	See there in the Attic for the older history.

	* libraries/thuban/ bmpdataset.cpp, cpl_mfile.cpp, cpl_mfile.h,
	gdalwarp.cpp, wxproj.cpp: These files have been moved here from
	thuban/extensions/thuban/
	See there in the Attic for the older history.

	* MANIFEST.in, setup.cfg, setup.py: renamed extensions to libraries.

	* extensions/thuban/ bmpdataset.cpp, cpl_mfile.cpp, cpl_mfile.h,
	gdalwarp.cpp, wxproj.cpp: Moved to libraries/thuban.

	* extensions/shapelib/ dbfopen.c, shapefil.h, shpopen.c, shptree.c:
	Moved to libraries/shapelib.

	* extensions/pyshapelib/ COPYING, NEWS, dbflib.py, pytest.py,
	shapelib.py, README, dbflib_wrap.c, setup.py, shapelib_wrap.c,
	ChangeLog, dbflib.i, pyshapelib_api.h, shapelib.i, shptreemodule.c:
	Moved to libraries/pyshapelib.

	* extensions/pyprojection/ MANIFEST.in, Projection.py, setup.py,
	LICENSE, Projection.i, Projection_wrap.c, swighelp.txt:
	Moved to libraries/pyprojection.

	* extensions/ pyprojection, pyshapelib, shapelib, thuban: Removed.

	* extensions: Removed.

2003-08-19  Bernhard Herzog  <bh@intevation.de>

	* test/test_viewport.py (ViewPortTest): We don't use the
	facilities of FileTestMixin so don't derive from it.
	(TestViewportWithPostGIS): New class with tests for using a
	viewport on a map with postgis layers.

2003-08-19  Bernhard Herzog  <bh@intevation.de>

	Add the db connection management to the session.

	* Thuban/Model/session.py (Session.__init__): New instance
	variable db_connections
	(Session.AddDBConnection, Session.DBConnections)
	(Session.HasDBConnections, Session.CanRemoveDBConnection)
	(Session.RemoveDBConnection): New methods to manage and query the
	db connections managed by the session
	(Session.OpenDBShapeStore): New method to open a shapestore from a
	db connection

	* Thuban/Model/messages.py (DBCONN_REMOVED, DBCONN_ADDED): New
	messages for the db connection handling in the session

	* test/test_postgis_session.py: New. test cases for the session's
	db connection handling with postgis connections

2003-08-19  Bernhard Herzog  <bh@intevation.de>

	Add very basic postgis database support and the corresponding test
	cases. The test cases require a PostgreSQL + postgis installation
	but no existing database. The database will be created
	automatically by the test cases

	* test/README: Add note about skipped tests and the requirements
	of the postgis tests.

	* Thuban/Model/postgisdb.py: New. Basic postgis database support.

	* test/test_postgis_db.py: New. Test cases for the postgis
	support.

	* Thuban/Model/wellknowntext.py: New. Parser for well-known-text
	format

	* test/test_wellknowntext.py: New. Test cases for the
	wellknowntext parser

	* test/postgissupport.py: New. Support module for tests involving
	a postgis database.

	* test/support.py (execute_as_testsuite): Shut down the postmaster
	if it's still running after the tests

	* Thuban/Model/data.py (RAW_WKT): New constant for raw data in
	well known text format

2003-08-19  Jan-Oliver Wagner <jan@intevation.de>

	* Examples/simple_extensions/hello_world.py: New. Raises a Hello World
	message dialog.

2003-08-18  Bernhard Herzog  <bh@intevation.de>

	* test/support.py (ThubanTestResult.printErrors): Indent the
	reason for the skips in the output to make it a bit more readable.
	(execute_as_testsuite): New helper function to run a test suite
	and print some more information.
	(run_tests): Use execute_as_testsuite to run the tests

	* test/runtests.py (main): Use execute_as_testsuite to run the
	tests

2003-08-18  Bernhard Herzog  <bh@intevation.de>

	Fix some bugs in Thuban and the test suite that were uncovered by
	changes introduced in Python 2.3:

	* Thuban/Model/table.py (DBFTable.__init__): Make sure the
	filename is an absolute name

	* Thuban/Model/layer.py (RasterLayer.__init__): Make sure the
	filename is an absolute name

	* test/test_save.py (SaveSessionTest.testRasterLayer): Use a
	unique filename to save to and use the correct relative filename
	in the expected output.
	(SaveSessionTest.test_dbf_table): Use the correct relative
	filename in the expected output.

	* test/test_layer.py (TestLayer.test_raster_layer): Update the
	test to check whether the filename is absolute.

2003-08-18  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/about.py (About.__init__): Added Silke Reimer.

2003-08-15  Bernhard Herzog  <bh@intevation.de>

	Change the way shapes are returned by a shape store. The
	ShapesInRegion method returns an iterator over actual shape
	objects instead of a list of shape ids.

	* Thuban/Model/data.py (ShapefileShape.ShapeID): New. Return shape
	id.
	(ShapefileStore.ShapesInRegion): Return an iterator over the
	shapes which yields shape objects instead of returning a list of
	shape ids
	(ShapefileStore.AllShapes): New. Return an iterator over all
	shapes in the shape store
	(DerivedShapeStore.AllShapes): New. Like in ShapefileStore

	* Thuban/Model/layer.py (Layer.ShapesInRegion): Update
	doc-string.

	* Thuban/UI/baserenderer.py
	(BaseRenderer.layer_ids, BaseRenderer.layer_shapes): Rename to
	layer_shapes and make it return an iterator containg shapes
	instead of a list of ids.
	(BaseRenderer.draw_shape_layer): Update doc-string; Adapt to
	layer_shapes() change

	* Thuban/UI/renderer.py (ScreenRenderer.layer_ids)
	(ScreenRenderer.layer_shapes): Rename as in BaseRenderer

	* Thuban/UI/viewport.py (ViewPort._find_shape_in_layer): Adapt to
	changes in the ShapesInRegion return value.
	(ViewPort._get_hit_tester): Remove commented out code

	* test/mockgeo.py (SimpleShapeStore.ShapesInRegion): Adapt to the
	new return value.
	(SimpleShapeStore.AllShapes): New. Implement this method too.

	* test/test_layer.py (TestLayer.test_arc_layer)
	(TestLayer.test_polygon_layer, TestLayer.test_point_layer)
	(TestLayer.test_point_layer_with_projection)
	(TestLayer.test_derived_store): Adapt to changes in the
	ShapesInRegion return value.

	* test/test_shapefilestore.py
	(TestShapefileStoreArc.test_shapes_in_region)
	(TestShapefileStorePolygon.test_shapes_in_region)
	(TestShapefileStorePoint.test_shapes_in_region): Adapt to changes
	in the ShapesInRegion return value.
	(TestShapefileStorePoint.test_all_shapes)
	(TestShapefileStoreArc.test_shape_shapeid): New tests for the new
	methods

	* test/test_derivedshapestore.py
	(TestDerivedShapeStore.test_shapes_in_region): Adapt to changes in
	the ShapesInRegion return value.
	(TestDerivedShapeStore.test_all_shapes)
	(TestDerivedShapeStore.test_shape_shapeid): New tests for the new
	methods

2003-08-15  Bernhard Herzog  <bh@intevation.de>

	Make the renderers deal correctly with raw vs. python level
	representation of shape geometries

	* Thuban/UI/baserenderer.py (BaseRenderer.low_level_renderer):
	Return a flag useraw in addition to the callable and the parameter
	to indicate whether the callable can deal with the raw shape data
	or uses the higher level python lists of coordinates. The callable
	now should accept either the raw data or the return value of the
	shape's Points() method.
	(BaseRenderer.draw_shape_layer): Adapt to the low_level_renderer
	change
	(BaseRenderer.projected_points): Instead of the shape id use the
	points list as parameter.
	(BaseRenderer.draw_polygon_shape, BaseRenderer.draw_arc_shape)
	(BaseRenderer.draw_point_shape): Adapt to projected_points()
	change and accept the points list as parameter instead of the
	shape id.

	* Thuban/UI/renderer.py (MapRenderer.low_level_renderer): Return
	the useraw flag as required by the BaseRenderer
	(ScreenRenderer.draw_shape_layer): Adapt to low-level renderer
	changes.

	* test/test_baserenderer.py
	(TestBaseRenderer.test_point_with_classification): New test for
	rendering a map with classifications.

2003-08-15  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/viewport.py (ViewPort.find_shape_at)
	(ViewPort._find_shape_in_layer, ViewPort._find_shape_in_layer)
	(ViewPort._get_hit_tester, ViewPort.projected_points)
	(ViewPort._hit_point, ViewPort._hit_arc, ViewPort._hit_polygon)
	(ViewPort._find_label_at): Split the find_shape_at method into
	several new methods and use the functions in the hit-test module.

	* Thuban/UI/hittest.py: New module with Python-level hit-testing
	functions

	* test/test_hittest.py: New. Test for the new hittest module

2003-08-15  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/layer.py (Layer.ShapesInRegion): Apply the layer
	projection to all corners of the bounding box to get a better
	approximation of the projected bounding box

	* test/test_layer.py (TestLayer.test_point_layer_with_projection):
	New. Test coordinate handling of a layer with a projection.
	Catches the bug fixed in Layer.ShapesInRegion

2003-08-15  Bernhard Herzog  <bh@intevation.de>

	Move some of the mock objects in test_baserenderer into their own
	module so they can easily be used from other tests

	* test/mockgeo.py: New test helper module with some mock objects
	for geometry related things like shapes, shapestores and
	projections.

	* test/test_mockgeo.py: New. Tests for the new helper module

	* test/test_baserenderer.py: Some of the mock-objects are in
	mockgeo now.

2003-08-12  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/about.py (About.__init__): Added Björn Broscheit.

2003-08-12  Bernhard Herzog  <bh@intevation.de>

	* po/de.po: New. German translations by Bjoern Broscheit

2003-08-12  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/projdialog.py (UnknownProjPanel._DoLayout): Translated
	strings have to be one string literal.

2003-08-11  Bernhard Herzog  <bh@intevation.de>

	* test/support.py (FloatComparisonMixin.assertPointListEquals):
	New. This method was used in various derived classes, but it's
	better to have it here.

	* test/test_shapefilestore.py
	(ShapefileStoreTests.assertPointListEquals): Removed. It's now in
	FloatComparisonMixin

	* test/test_layer.py (TestLayer.assertPointListEquals): Removed.
	It's now in FloatComparisonMixin

	* test/test_derivedshapestore.py
	(TestDerivedShapeStore.assertPointListEquals): Removed. It's now
	in FloatComparisonMixin

2003-08-11  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/join.py (JoinDialog.OnJoin): Add missing space to
	error message

2003-08-08  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual.xml: Now use authorgroup. Added revhistory
	with version number.
	Changed title to reflect version number of Thuban.

2003-08-08  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/about.py (About.__init__): Reworked the hall of fame. Now
	the list corresponds to the "About" web page.

2003-08-08  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/projdialog.py (UTMProposeZoneDialog.dialogLayout):
	Make sure translated strings are recognized as one string literal.

	* Thuban/UI/proj4dialog.py (UTMProposeZoneDialog.dialogLayout):
	Make sure translated strings are recognized as one string literal.

	* Thuban/UI/classgen.py (ClassGenDialog.OnOK): Make sure
	translated strings are recognized as one string literal.

	* Thuban/UI/application.py (ThubanApplication.OpenSession): Make
	sure translated strings are recognized as one string literal.

2003-08-07  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/data.py (DerivedShapeStore.RawShapeFormat): New.
	Simply delegates to the original shapestore.

	* test/test_derivedshapestore.py
	(TestDerivedShapeStore.test_raw_format): New. Test case for
	DerivedShapeStore.RawShapeFormat

2003-08-07  Bernhard Herzog  <bh@intevation.de>

	Add raw data interface to shape objects.

	* Thuban/Model/data.py (ShapefileShape, Shape): Rname the shape
	class to ShapefileShape which now holds shapefile specific
	information.
	(ShapefileShape.compute_bbox): Simplified to not cache any
	information. The way this method is used that shouldn't matter
	performance wise.
	(ShapefileShape.RawData): New. Return the shapeid which is the raw
	data format for shapes from shapefiles.
	(ShapefileStore.RawShapeFormat): New. Return the raw datatype used
	in the shape objects returned by a shapestore. For a
	ShapefileStore this is always RAW_SHAPEFILE.
	(RAW_PYTHON, RAW_SHAPEFILE): Constants for the RawShapeFormat
	method.

	* test/test_shapefilestore.py
	(TestShapefileStore.test_raw_format): New test to test the raw
	format feature of shapes.

	* Thuban/Model/layer.py: Remove the unused import of Shape from
	data. It was only there for interface compatibility but it's not
	used inside of Thuban and the generic Shape class has gone away.

	* Thuban/UI/renderer.py (MapRenderer.low_level_renderer): Check
	the raw data format and only use an optimized version of its a
	shapefile.

2003-08-07  Bernhard Herzog  <bh@intevation.de>

	* test/test_baserenderer.py (SimpleShape): Shape class for the
	tests.
	(SimpleShapeStore.Shape): Use SimpleShape instead of
	Thuban.Model.data.Shape to make the tests independed of the coming
	changes.

2003-08-07  Bernhard Herzog  <bh@intevation.de>

	* test/support.py (SkipTest, ThubanTestResult, ThubanTestRunner)
	(ThubanTestProgram): New classes that extend the respective
	classes from unittest. These new version support skipping tests
	under certain expected conditions. In the Thuban test suite we
	uses this for tests that require the optional gdal support.
	(run_tests): Use ThubanTestProgram instead of the unittest.main()

	* test/runtests.py (main): Use the new ThubanTestRunner instead of
	the normal one from unittest

	* test/test_layer.py (TestLayer.test_raster_layer): If this test
	is not run because gdal support isn't available report this to the
	runner.

	* test/test_baserenderer.py
	(TestBaseRenderer.test_raster_no_projection): Do not run this test
	if gdal support isn't available and report this to the runner.

2003-08-06  Bernhard Herzog  <bh@intevation.de>

	Rearrange the renderers a bit, partly in preparation for changes
	required for the postgis merge, partly to make it more testable.
	Also make the representation of coordinates in Shapes more
	consistent.

	* Thuban/UI/renderer.py (MapRenderer): Most of the code/methods in
	this class is now in BaseRenderer. This class is now practically
	only a specialization of BaseRenderer for rendering to an actual
	wx DC.
	(ScreenRenderer.draw_shape_layer): Use self.low_level_renderer()
	to get the shapetype specific rendering functions.

	* Thuban/UI/baserenderer.py: New file with the basic rendering
	logic. The code in this file is completely independend of wx.
	(BaseRenderer): Class with the basic rendering logic

	* test/test_baserenderer.py: New. Test cases for BaseRenderer

	* Thuban/UI/view.py (MapCanvas.__init__): New instance variable
	error_on_redraw to guard agains endless loops and stack overflows
	when there's a bug in the rendering code that raises exceptions.
	(MapCanvas.OnIdle, MapCanvas._do_redraw): Split the actual
	rendering into a separate method _do_redraw so that error handling
	is a bit easier. When an exception occurs, set error_on_redraw to
	true. When it's true on entry to OnIdle do nothing and return
	immediately.

	* Thuban/Model/data.py (ShapefileStore.Shape): For consistency, a
	Shape object will always have the coordinates as a list of list of
	coordinate pairs (tuples).
	(Shape.compute_bbox): Adapt to new representation.

	* Thuban/UI/viewport.py (ViewPort.find_shape_at)
	(ViewPort.LabelShapeAt): Adapt to new coordinate representation in
	Shape objects.

	* test/test_shapefilestore.py
	(ShapefileStoreTests.assertFloatTuplesEqual)
	(ShapefileStoreTests.assertPointListEquals): Rename to
	assertPointListEquals and change purpose to checking equality of
	the lists returned by Shape.Points().
	(TestShapefileStoreArc.test_shape)
	(TestShapefileStorePolygon.test_shape)
	(TestShapefileStorePoint.test_shape): Use the new
	assertPointListEquals instead of assertFloatTuplesEqual

	* test/test_layer.py (TestLayer.assertFloatTuplesEqual)
	(TestLayer.assertPointListEquals): Rename to assertPointListEquals
	and change purpose to checking equality of the lists returned by
	Shape.Points().
	(TestLayer.test_arc_layer, TestLayer.test_arc_layer)
	(TestLayer.test_polygon_layer, TestLayer.test_point_layer)
	(TestLayer.test_derived_store): Use the new assertPointListEquals
	instead of assertFloatTuplesEqual

	* test/test_derivedshapestore.py
	(TestDerivedShapeStore.assertFloatTuplesEqual)
	(TestDerivedShapeStore.assertPointListEquals): Rename to
	assertPointListEquals and change purpose to checking equality of
	the lists returned by Shape.Points().
	(TestDerivedShapeStore.test_shape): Use the new
	assertPointListEquals instead of assertFloatTuplesEqual

2003-08-06  Jan-Oliver Wagner <jan@intevation.de>

	* Thuban/UI/projdialog.py (UTMPanel._OnPropose): Added test for
	a bounding box. A dialog is raised in case, no bounding box
	is found. This fixes bug #2043:
	https://intevation.de/rt/webrt?serial_num=2043

2003-08-05  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/color.py (Color.__repr__): Make the repr of a color
	object look like a Color instantiation. Formerly it looked like a
	tuple.

	* test/test_color.py (TestColor.test_repr)
	(TestColor.test_equality, TestColor.test_inequality): New. test
	some more apects of the Color class
	(TestTransparent.test_repr, TestTransparent.test_hex)
	(TestTransparent.test_equality): New. Test cases for the
	Transparent object.

2003-08-04  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual.xml: a number of small improvements.
	The resulting file is the version submitted for GREAT-ER II.

2003-08-01  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/resource.py, Thuban/UI/projdialog.py,
	Thuban/UI/join.py, Thuban/UI/classgen.py, Thuban/UI/about.py,
	Thuban/Model/resource.py: Insert cvs keywords and doc-strings.

	* Thuban/UI/common.py: Insert cvs keywords and doc-strings.
	(Color2wxColour, wxColour2Color, ThubanBeginBusyCursor)
	(ThubanEndBusyCursor): Add doc-strings

2003-08-01  Bernhard Herzog  <bh@intevation.de>

	First step towards PostGIS integration. More abstraction by movin
	more code from the layer to the shapestore. More methods of the
	layer are now simply delegated to the equivalent method of the
	shapestore. The SHAPETYPE_* constants are now in data not in
	layer.

	* Thuban/Model/data.py (SHAPETYPE_POLYGON, SHAPETYPE_ARC)
	(SHAPETYPE_POINT, Shape): Move these constants and classes from
	layer.py to data.py
	(ShapefileStore.__init__): More Initialization for the new methods
	and functionality.
	(ShapefileStore.ShapeType, ShapefileStore.NumShapes)
	(ShapefileStore.BoundingBox, ShapefileStore.ShapesInRegion)
	(ShapefileStore.Shape): New methods that were formerly implemented
	in the layer.
	(DerivedShapeStore.Shape, DerivedShapeStore.ShapesInRegion)
	(DerivedShapeStore.ShapeType, DerivedShapeStore.NumShapes)
	(DerivedShapeStore.BoundingBox): New. DerivedShapeStore
	equivalents of the new shape methods. These versions are simply
	delegated to the original shapstore.

	* Thuban/Model/layer.py (SHAPETYPE_POLYGON, SHAPETYPE_ARC)
	(SHAPETYPE_POINT, Shape): Removed. They're now in data.py
	(Layer.SetShapeStore): Removed the initializatin of instance
	variables that were needed for the stuff that's now in
	ShapefileStore
	(Layer.BoundingBox, Layer.NumShapes, Layer.ShapeType)
	(Layer.Shape, Layer.ShapesInRegion): Simply delegate to the
	shapestore.

	* Thuban/UI/classifier.py, Thuban/UI/renderer.py,
	Thuban/UI/viewport.py: Import the SHAPETYPE_* constants from data
	instead of layer.

	* test/test_shapefilestore.py: New. Tests for ShapefileStore.

	* test/test_derivedshapestore.py: New. Tests for DerivedShapeStore.

	* test/test_layer.py: Import the SHAPETYPE_* constants from data
	instead of layer.
	(TestLayer.test_derived_store): Remove the test for the exception
	when instantiating the DerivedShapeStore with an incompatible
	table which is now in test_derivedshapestore.py. Add some more
	tests of the layer methods to determine whether they work for a
	DerivedShapeStore as well.

2003-07-31  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: Fix the list of required packages
	by just listing the name and where they can be found.

2003-07-31  Frank Koormann   <frank.koormann@intevation.de>

	* Doc/manual/thuban-manual.xml: 
	Changed the screenshot elements to figure.
	Changed some variablelist elements to itemizedlist.
	Added section on GDAL formats.

2003-07-31  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: Added a few sentences about
	the Fix Border Color option when generating classes.

2003-07-30  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/classgen.py: Add docstrings. Rename specific
	Ramp instances to use lower_case_style.

	* Thuban/UI/classgen.py: Use renamed Ramp instances.
	
	* Thuban/UI/classifier.py: Add docstrings.

	* Thuban/UI/dock.py: Add docstrings.

	* test/test_classgen.py: Use renamed Ramp instances.

2003-07-30  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Lib/connector.py (QueueingPublisher): Removed. This class
	was never used in Thuban.

2003-07-30  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/join.py (JoinDialog.__init__): Use the table's Title()
	method directly instead of going through the transient_table
	method. This faster because transient_table may force the copy of
	a DBF file into the transient database and setting a table's title
	doesnm't affect the title of the associated transient table, so
	this fixes RT #2042

	* Thuban/UI/main.py (__version__): Don't import the already
	removed show_exception_dialog.

2003-07-29  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/application.py (ThubanApplication.ShowExceptionDialog):
	Put back this method and remove the equivalent function since we
	are setting the exception hook from within this class (OnInit).

2003-07-29  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/images/5_2_custom_ramp.png,
	Doc/manual/images/5_2_quantiles.png,
	Doc/manual/images/5_2_uniform_dist.png,
	Doc/manual/images/5_2_unique_values.png,
	Doc/manual/images/8_int_error.png: New screen shots.

	* Doc/manual/thuban-manual.xml: Fixed typos and wording, clarified
	some points, and added more screen shots.

2003-07-29  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/data.py: Remove the now unused import of warnings

2003-07-29  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/data.py (SimpleStore): Removed. This class has been
	deprecated since before the 0.8 release and isn't used in Thuban
	itself anymore.

	* Thuban/Model/transientdb.py: Remove some unnecessary imports

2003-07-29  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/application.py (ThubanApplication.OnInit): set the 
	python exception hook here so that we are sure to catch any
	Thuban exception that happen during initialization.

	* Thuban/UI/main.py (main): Don't set the exception hook here,
	it will get set in ThubanApplication.OnInit.

2003-07-29  Jonathan Coles   <jonathan@intevation.de>
                                                                            
	* Thuban/UI/application.py (ThubanApplication.ShowExceptionDialog):
	Removed and called it show_exception_dialog() so that the exception
	handler can be set before the class is created.
                                                                            
	* Thuban/UI/main.py (main): Install the exception handler before
	a ThubanApplication is created.
                                                                                
2003-07-29  Bernhard Herzog  <bh@intevation.de>

	* po/it.po: New. Italian translation by Maurizio Napolitano

	* po/ru.po: New. Russian translation by Alex Shevlakov

2003-07-29  Frank Koormann   <frank.koormann@intevation.de>

	* Doc/manual/thuban-manual.xml: Extended section on supported
	projections.
	
2003-07-29  Frank Koormann   <frank.koormann@intevation.de>

	* Doc/manual/thuban-manual.xml: gaspell-checked.

2003-07-29  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/images/3_5_legend.png: Added border to improve look
	on white background.

2003-07-29  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: Fixed grammar and typos. Added 
	descriptions for the legend toolbar.

	* Doc/manual/images/4_2_raster_layer_properties.png: Removed
	cursor from dialog box.

2003-07-28  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: More screenshots and more chapters.

	* Doc/manual/images/2_4_session_tree.png, 
	Doc/manual/images/3_5_legend.png, Doc/manual/images/3_rename_map.png,
	Doc/manual/images/4_2_layer_properties.png, 
	Doc/manual/images/4_2_raster_layer_properties.png,
	Doc/manual/images/5_3_genclass.png, 
	Doc/manual/images/5_classification.png, 
	Doc/manual/images/6_projection.png,
	Doc/manual/images/7_1_table_view.png, 
	Doc/manual/images/7_2_5_join.png: New screenshots.

2003-07-24  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: Chapter on Projection Management.

2003-07-24  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: Added EPS images and wrote
	chapter on Layer Management.

	* Doc/manual/Makefile: New. Makefile to generate all formats for the
	manual and images.

2003-07-24  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/range.py, Thuban/version.py: Remove the #! line as
	it annoys lintian which warns about these files not being
	executable. The #! isn't necessary here since if you absolutely
	must execute them you can always say "python <filename>".

	* Thuban/UI/renderer.py (ScreenRenderer.draw_shape_layer): Remove
	superfluous code to set brush and pen for point shapes

	* Thuban/UI/viewport.py: Remove commented out code that wouldn't
	belong in viewport anyway

2003-07-24  Frank Koormann   <frank.koormann@intevation.de>

	* Doc/manual/thuban-manual.xml: Added section on table management.

2003-07-24  Bernhard Herzog  <bh@intevation.de>

	* test/runtests.py (main): Recognize the long "verbose" option
	correctly.

2003-07-22  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/thuban-manual.xml: Continue to write first revision
	of the manual.

	* Thuban/UI/renderer.py (MapRenderer.render_map): Wrap method
	with Begin/EndDrawing() calls to ensure we aren't doing to
	many updates to the dc during rendering.
	(ScreenRenderer.draw_shape_layer): self.draw_point_shape takes
	a pen and brush argument so they need to be passed to the function.

	* Thuban/UI/viewport.py (ViewPort.calc_min_max_scales): New.
	Calculates the minimum and maximum scale values. Factored out
	of set_view_transform so that it could be used to zoom all the
	way into a single point.
	(ViewPort.set_view_transform): Call calc_min_max_scales().
	(ViewPort.FitSelectedToWindow): Zoom to the maximum scale
	if only a single point is selected.

	* Doc/manual/images/1_2_legend_close.png,
	Doc/manual/images/1_2_legend_dock.png,
	Doc/manual/images/1_2_mainwindow.png,
	Doc/manual/images/1_2_mainwindow.ps,
	Doc/manual/images/1_2_mainwindow.sk,
	Doc/manual/images/3_2_fullextent.png,
	Doc/manual/images/3_2_fulllayerextent.png,
	Doc/manual/images/3_2_fullshapeextent.png,
	Doc/manual/images/3_2_pan.png,
	Doc/manual/images/3_2_zoomin.png,
	Doc/manual/images/3_2_zoomout.png,
	Doc/manual/images/3_3_identify.png,
	Doc/manual/images/3_3_label.png,
	Doc/manual/images/3_5_invisible.png,
	Doc/manual/images/3_5_movedown.png,
	Doc/manual/images/3_5_moveup.png,
	Doc/manual/images/3_5_props.png,
	Doc/manual/images/3_5_tobottom.png,
	Doc/manual/images/3_5_totop.png,
	Doc/manual/images/3_5_visible.png: New. Images for the documentation.

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/messages.py (MAP_REPLACED): New message.

	* Thuban/UI/viewport.py (ViewPort.SetMap): Issue MAP_REPLACED
	after the new map has been assigned

	* Thuban/UI/mainwindow.py (MainWindow.delegated_messages):
	Delegate MAP_REPLACED to the canvas too
	(MainWindow.prepare_new_session): Removed. Thanks to the new
	MAP_REPLACED message it's no longer needed
	(MainWindow.OpenSession, MainWindow.NewSession):
	prepare_new_session has been removed.

	* Thuban/UI/classifier.py (Classifier.__init__): Subscribe to
	MAP_REPLACED so that we can close the dialog if a new map is set.
	(Classifier.unsubscribe_messages): Unsubscribe from MAP_REPLACED
	(Classifier.map_replaced): Handle MAP_REPLACED by closing the
	dialog

	* test/test_viewport.py (SimpleViewPortTest)
	(SimpleViewPortTest.test_default_size): Add doc-strings
	(ViewPortTest.setUp): Bind map to self.map so we can use it in
	tests. Subscribe to MAP_REPLACED messages too.
	(ViewPortTest.tearDown): No need to explicitly unsubscribe
	(ViewPortTest.test_set_map): New test for the SetMap method.

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* test/test_viewport.py (SimpleViewPortTest.test_default_size):
	Move this test from ViewPortTest.setUp to this new separate test
	case. setUp is not the place for the actual tests.
	(ViewPortTest.test_inital_settings, ViewPortTest.setUp): Move some
	more of the test from setUp to the new test test_inital_settings.
	(ViewPortTest.test_win_to_proj, ViewPortTest.test_proj_to_win)
	(ViewPortTest.test_proj_conv): Split test_proj_conv into
	test_win_to_proj and test_proj_to_win and make the tests easier to
	understand
	(ViewPortTest.testFitRectToWindow, ViewPortTest.testZoomFactor)
	(ViewPortTest.testZoomOutToRect, ViewPortTest.testTranslate)
	(ViewPortTest.test_unprojected_rect_around_point)
	(ViewPortTest.test_find_shape_at, ViewPortTest.testTools):
	Reformat to increase readability.

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/view.py (MapCanvas.OnLeftDown): Capture the mouse.

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* test/runtests.py: The test suite can now be run without an X
	connection. To make sure this remains true, remove the DISPLAY
	environment variable so that an error occurs if the wxGTK is
	imported accidentally

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/viewport.py: Remove unused imports

	* Thuban/UI/view.py: Remove unused imports

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* test/test_export.py Remove unused imports. The OutputTransform
	function is now in viewport.py and is called output_transform
	(TestScalebar.test_output_transform)
	(TestScalebar.test_OutputTransform): Renamed to
	test_output_transform and updated to use output_transform instead
	of OutputTransform

	* Thuban/UI/view.py (OutputTransform): Moved to viewport.py and
	renamed.
	(MapCanvas.Export, MapPrintout.draw_on_dc): OutputTransform was
	renamed to output_transform

	* Thuban/UI/viewport.py (OutputTransform, output_transform):
	Rename to output_transform

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/layer.py (Layer.__init__): Rename
	classificationField to classificatin_column and init it here so
	that it can be used in SetClassificationColumn
	(Layer.GetClassificationColumn, Layer.GetClassificationField):
	Rename to GetClassificationColumn.
	(Layer.SetClassificationColumn, Layer.SetClassificationField):
	Rename to SetClassificationColumn and issue a LAYER_CHANGED
	message if the column changes.
	(Layer._classification_changed, Layer.ClassChanged): Rename to
	_classification_changed. Update the callers.
	(Layer.SetShapeStore): Further field->column renames.

	* Thuban/Model/load.py (SessionLoader.start_classification) 
	(SessionLoader.start_clpoint): Updates because of
	field->column method name changes in the Layer class

	* Thuban/Model/save.py (SessionSaver.write_classification): Updates
	because of field->column method name changes in the Layer class

	* Thuban/UI/classifier.py (Classifier.__init__)
	(Classifier._OnTry, Classifier._OnRevert): Updates because of
	field->column method name changes in the Layer class

	* Thuban/UI/renderer.py (MapRenderer.draw_shape_layer): Updates
	because of field->column method name changes in the Layer class

	* Thuban/UI/viewport.py (ViewPort.find_shape_at): Updates because
	of field->column method name changes in the Layer class

	* test/test_save.py (SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.testClassifiedLayer): Update because of
	field->column method name changes in the Layer class

	* test/test_layer.py (SetShapeStoreTests.setUp)
	(SetShapeStoreTests.test_sanity): Update because of field->column
	method name changes in the Layer class
	(TestLayerModification.setUp): Subscribe to LAYER_CHANGED as well
	(TestLayerModification.test_sanity)
	(TestLayerModification.test_initial_settings): remove unsued code
	and rename to test_sanity.
	(TestLayerModification.test_set_classification): New test for
	SetClassification and SetClassificationField.

2003-07-18  Bernhard Herzog  <bh@intevation.de>

	* test/test_classgen.py (TestFixedRamp.test): Extend test to check
	the non-fixed values as well. The old test would have accepted a
	fixed ramp that only returnes the fixed properties

2003-07-17  Jonathan Coles   <jonathan@intevation.de>

	* Doc/manual/mainwindow.png, Doc/manual/mainwindow.xcf: Screen
	shots for the manual. The XCF file is the source image and
	has additional layers to support changes.

	* Doc/manual/thuban-manual.xml: Wrote an initial Introduction.

	* Thuban/UI/classifier.py (Classifier.__BuildClassification):
	Return both the new class and the field name.

	* Thuban/UI/mainwindow.py (MainWindow.ToggleLegend): Don't 
	fit the map to the window as this changes any zoom level that
	the user may have set.

2003-07-16  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/classgen.py (generate_singletons,
	generate_uniform_distribution, generate_quantiles): Remove
	fixes parameter, but maintain the same functionality by having
	the calling function pass a FixedRamp object for the ramp.
	(FixedRamp): New. Adapts a ramp to have fixed property values.

	* Thuban/Model/classification.py: Use new CLASS_CHANGED message.
	(Classification): Inherit from Publisher.
	(Classification.__init__): Remove the layer parameter. 
	Classifications no longer need to have a parent layer.
	(Classification.GetField, Classification.GetFieldType, 
	Classification.SetFieldInfo): Removed. The field name is stored
	in the layer, and the type can be retreived by calling
	Layer.GetFieldType().
	(Classification._set_layer, Classification.GetLayer): Removed.
	Classifications no longer have a parent layer.

	* Thuban/Model/layer.py (Layer.Destroy): Unsubscribe from the
	classification. 
	(Layer.SetShapeStore): Reset the classification first while
	we still have the old shape store to work with.
	(Layer.GetClassificationField, Layer.SetClassificationField):
	New. Method for getting/setting the field to classify on.
	(Layer.SetClassification): Simplified now that the layer 
	simply has to hold a reference to the classification and not
	tell the classification who owns it.
	Fixes RTbug #2023.

	* Thuban/Model/load.py (SessionLoader.start_classification):
	Set the field name on the layer, not the classification.

	* Thuban/Model/messages.py: Add CLASS_CHANGED for when a
	classification is modified.

	* Thuban/Model/save.py (SessionSaver.write_classification):
	Get the field name and type from the layer.

	* Thuban/Model/table.py (table_to_dbf, table_to_csv): Renamed
	parameter records to rows and add docstring. Fixes RTbug #1997.

	* Thuban/UI/classgen.py (ClassGenDialog.OnOK): Use a fixed
	ramp when we need to fix certain values of a ramp rather than
	using the old fixes parameter. Fixes RTbug #2024.

	* Thuban/UI/classifier.py (ClassGrid.CreateTable): Add fieldType
	parameter.
	(ClassTable.Reset): Add fieldType parameter and use it, rather
	than asking the classification.
	(Classifier.__init__): Remember the original class's field
	and ask the layer for the field type, rather than the classification.
	(Classifier.__SetGridTable): Retrieve the field and field type
	for the table because they are not in the classification.
	(Classifier._OnTry, Classifier._OnRevert): Set the classification
	field on the layer in addition to the classification itself.

	* Thuban/UI/renderer.py (MapRenderer.draw_shape_layer): Get the
	classification field from layer.

	* Thuban/UI/viewport.py (ViewPort.find_shape_at): Get the
        classification field from layer. Split up tests and remove
	*-imports. Fixes RTbug #1992.

	* test/test_classgen.py (TestFixedRamp): Test for the FixedRamp class.

	* test/test_classification.py
	(TestClassification.test_classification): Remove tests for methods
	that no longer exist.

	* test/test_layer.py (SetShapeStoreTests.setUp): Classification
	__init__ no longer has a field parameter, use SetClassificationField.
	(SetShapeStoreTests.test_sanity): Use layer object to get class
	field info.

	* test/test_save.py (SaveSessionTest.testClassifiedLayer): Use
	SetClassificationField on layer to set class field info.

	* test/test_viewport.py: Renamed from test/test_view.py.

2003-07-16  Jan-Oliver Wagner <jan@intevation.de>

	* Doc/manual/thuban-manual.xml: Added authors and an initial
	coarse structure.

2003-07-15  Bernhard Herzog  <bh@intevation.de>

	* test/support.py (FloatComparisonMixin): This is a mix-in class
	and therefore should not be derived from any other class.

	* test/test_range.py (RangeTest): FloatComparisonMixin is a
	mix-in, so derive from TestCase as well.

2003-07-15  Bernhard Herzog  <bh@intevation.de>

	* Thuban/UI/renderer.py (MapRenderer.draw_shape_layer): Rework the
	draw_func handling a bit to remove one layer of indirection. This
	makes the renderer about 10% faster in the non-classifying case
	and the code a bit cleaner
	(MapRenderer.draw_point_shape): Add the pen and brush parameters
	and set them in the dc. Now the draw_point_shape method and
	wxproj's draw_polygon_shape function have basically the same
	signature so that both can be directly used as draw_func

2003-07-15  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/save.py (SessionSaver.write_classification): Encode
	string values (in addition to the labels) as UTF 8

	* Thuban/Model/load.py (SessionLoader.start_clpoint): Decode the
	values if the field type is string

	* test/test_save.py (SaveSessionTest.testClassifiedLayer): Test
	saving a session with non-ascii string classification values.

	* test/test_load.py (TestClassification.file_contents)
	(TestClassification.test): Check for non-ascii values in string
	classifications

2003-07-14  Jonathan Coles   <jonathan@intevation.de>

	* test/test_view.py: New. Tests for ViewPort.

2003-07-14  Frank Koormann   <frank@intevation.de>

	* Thuban/Model/load.py (SessionLoader.start_map): Encode map 
	title to latin1.  Fixes https://intevation.de/rt/webrt?serial_num=2013

	* test/test_load_0_8.py (TestUnicodeStrings): New, test load of 
	unicode strings from session file: session title, map title and 
	projection name.
	
2003-07-10  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/viewport.py (Tool.MouseUp): Should have called
	drag_stop, not drag_move when the mouse is released.

2003-07-10  Jonathan Coles   <jonathan@intevation.de>

	The most important part of this is the seperation of view.py into
	two pieces. viewport.py now has a class called ViewPort which
	contains all the non-wx parts of view.py and can therefore be
	tested. view.py contains only the wx-specific parts and is fairly
	simple.

	* Thuban/UI/view.py: Stripped out all non-wx functionality. Fixes
	RTTbug #1992.
	* Thuban/UI/viewport.py: New. Contains non-wx view functionality.
	RTTbug #1992.

	* Thuban/Model/classgen.py (generate_singletons,
	generate_uniform_distribution, generate_quantiles):
	Added 'fixes' parameter so that property attributes can
	be held constant over the generated classification groups.
	(CustomRamp.GetProperties): Remove unused variables.

	* Thuban/Model/map.py (Map.SetProjection): Send the old
	projection as an argument to listeners of the MAP_PROJECTION_CHANGED
	event.

	* Thuban/Model/table.py (table_to_dbf, table_to_csv): Added 'records' 
	parameter which is a list of records that restricts which
	records are saved. Fixes RTbug #1997.

	* Thuban/UI/application.py (ThubanApplication.ShowExceptionDialog):
	Port exception dialog from GREAT-ER. Fixes RTbug #1993.

	* Thuban/UI/classgen.py (ClassGenDialog.__init__): Add controls
	to allow the user to fix line color/width on generated groups.
	(ClassGenDialog.OnOK): Use new 'fixes' parameter of the generate_*
	functions to optionally fix group properties.

	* Thuban/UI/main.py (main): Set exception hook to the 
	ShowExceptionDialog. Fixes RTbug #1993.

	* Thuban/UI/mainwindow.py (MainWindow.ShowTableView): Raise
	the table window when it is selectd to be shown.

	* Thuban/UI/tableview.py (QueryTableFrame.__init__): Add an
	Export Selection button and move the export buttons underneath
	the table.
	(QueryTableFrame.UpdateStatusText): Added event argument so
	that it can respond to grid selection events. The status text
	is now updated even when the table is not associated with a
	layer as was previously assumed.
	(QueryTableFrame.OnGridSelectRange, OnGridSelectCell): Removed.
	UpdateStatusText responds to these events.
	(QueryTableFrame.OnSaveAs): Renamed to doExport.
	(QueryTableFrame.doExport): Helper function that saves the
	entire table, or selected rows, to a file.
	(QueryTableFrame.OnExport, QueryTableFrame.OnExportSel): New.
	Respond to export button events and call doExport.

	* extensions/thuban/gdalwarp.cpp (ProjectRasterFile): Make sure
	the function doesn't return NULL without first setting a Python
	Error.

	* test/runtests.py (main): Only print "Unknown option" for
	unsupported options.

	* test/support.py (FloatComparisonMixin.assertFloatEqual): Take
	optional epsilon argument to specify floating point accuracy.
	(FloatComparisonMixin.assertFloatSeqEqual): Call assertFloatEqual
	for each item test.

	* test/test_csv_table.py (TestCSVTable.test_table_to_cvs): Add
	tests for saving selected records.

	* test/test_dbf_table.py (TestTableToDBF.test_table_to_dbf): Add
        tests for saving selected records.

	* test/test_map.py (TestMapWithContents.test_set_projection):
	MAP_PROJECTION_CHANGED events send the old projection.

	* test/test_session.py 
	(TestSessionWithContent.test_forward_map_projection): 
	MAP_PROJECTION_CHANGED events send the old projection.

	* test/test_table.py (TableTest): Update tests to use non-deprecated
	functions.

2003-07-08  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/transientdb.py (TransientTableBase.Width): The type
	constants in the column objects are the standard ones defined in
	the table module.

	* test/test_transientdb.py
	(TestTransientTable.test_transienttable_to_dbf): New. Test whether
	exporting transient tables as DBF works. This should catch the bug
	just fixed in TransientTableBase.Width.

2003-07-08  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/classgen.py (CustomRamp.GetProperties): Compute the
	interpolated colors correctly.

	* test/test_classgen.py (TestCustomRamp.test_color_interpolation):
	New. Test case for the fix in classgen.py

2003-07-08  Bernhard Herzog  <bh@intevation.de>

	* test/runtests.py (main): Make the default output less verbose
	and add a verbosity option (-v) to get the old output

2003-07-08  Bernhard Herzog  <bh@intevation.de>

	* Resources/XML/thuban-0.9.dtd: New. This will become the DTD for
	0.9.

	* Thuban/Model/transientdb.py (TransientJoinedTable.JoinType):
	New. Return the join type

	* Thuban/Model/save.py (SessionSaver.write_session): Use new 0.9
	DTD
	(SessionSaver.write_data_containers): Save the join type for
	joined tables

	* Thuban/Model/load.py (SessionLoader.__init__): Add the new 0.9
	namespace
	(SessionLoader.start_jointable): Handle the jointype attribute

	* test/test_load_0_8.py: New. Effectively a copy of test_load.py
	as of Thuban 0.8. These are now tests to determine whether Thuban
	can still read files generated by Thuban 0.8

	* test/test_load.py (LoadSessionTest.dtd)
	(TestSingleLayer.file_contents)
	(TestLayerVisibility.file_contents, TestLabels.file_contents)
	(TestLayerProjection.file_contents)
	(TestRasterLayer.file_contents, TestJoinedTable.file_contents)
	(TestJoinedTable.file_contents)
	(TestLoadError.file_contents): Update for new DTD
	(TestJoinedTable.file_contents, TestJoinedTable.setUp): Add test
	for new join type attribute

	* test/test_save.py (SaveSessionTest.dtd)
	(SaveSessionTest.testEmptySession)
	(SaveSessionTest.testSingleLayer)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer)
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table): Update for new DTD
	(SaveSessionTest.test_joined_table): Add test for new join type
	attribute

2003-07-04  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/table.py (_find_dbf_column_names): New. Helper
	function for table_to_dbf
	(table_to_dbf): Deal with names longer than the 10 character limit

	* test/test_dbf_table.py (TestTableToDBF.test_table_to_dbf): Add
	doc-string
	(TestTableToDBF.test_table_to_dbf_long_col_names): New test for
	long column names

2003-07-03  Bernhard Herzog  <bh@intevation.de>

	* Doc/manual/thuban-manual.xml: Fix the CVS Revision Tag syntax

2003-07-03  Bernhard Herzog  <bh@intevation.de>

	* Doc/manual/thuban-manual.xml, Doc/manual/README: New. Skeleton
	for the Thuban manual and README with some basic information about
	the manual

2003-07-03  Bernhard Herzog  <bh@intevation.de>

	* Thuban/Model/transientdb.py (TransientJoinedTable.__init__):
	Update doc-string
	(TransientJoinedTable.create): Do not modify the column objects of
	the input tables in place and copy all columns of the input tables
	into the joined table after all.

	* test/test_transientdb.py
	(TestTransientTable.test_transient_joined_table_same_column_name):
	Update to reflect the new behavior
	(TestTransientTable.test_transient_joined_table_with_equal_column_names):
	Update to reflect the new behavior
	(TestTransientTable.test_transient_joined_table_name_collisions_dont_modify_in_place):
	New test case for a bug which modified the column objects in place

2003-07-02  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/classgen.py (generate_singletons, 
	generate_uniform_distribution, generate_quantiles,
	GenQuantiles0): Make sure maxValue isn't less than
	one, otherwise we could divide by zero.

	* test/test_classgen.py (ClassGenTest.doClassRangeTest,
	ClassGenTest.doClassSingleTest): Call doBoundsTest to
	check the end classification groups against the
	proper property values.
	(ClassGenTest.doBoundsTest): New. Checks the first and
	last classification groups to make sure their properties 
	are the correct upper and lower bounds for a color ramp.

2003-07-02  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/classgen.py (generate_singletons, 
	generate_uniform_distribution, generate_quantiles,
	GenQuantiles0): The denominator was one to high when
	calculating the index for the ramp causing the index
	to never to reach one.

2003-07-02  Jonathan Coles   <jonathan@intevation.de>

	Changed the singature of ClassGroupRange.__init__ and
	ClassGroupRange.SetRange() so that the min/max values are
	passed as a tuple. This makes a better calling scheme for
	when a Range object is passed instead.

	* Thuban/Model/classgen.py: Fixed parameters to 
	ClassGroupRange constructor.

	* Thuban/Model/classification.py (ClassGroupRange.__init__):
	Consolidate the min/max parameters into a single _range which
	can either be a tuple or a Range object.
	(ClassGroupRange.SetRange): Consolidate the min/max parameters 
	into a single _range which can either be a tuple or a Range object.

	* Thuban/Model/load.py (SessionLoader.start_clrange): Fix
	call to ClassGroupRange constructor to use a tuple.

	* Thuban/Model/layer.py (Layer.SetClassification): Switch
	the classification instance variable to the new class 
	before calling _set_layer otherwise subscribers to a 
	LAYER_CHANGED event will not see any difference.

	* test/test_classification.py: Fix tests of ClassGroupRange
	so that they use the new signature.

	* test/test_load.py: Fix use of ClassGroupRange so that it 
	uses the new signature.

	* test/test_load_0_2.py: Fix use of ClassGroupRange so that it 
	uses the new signature.

	* test/test_save.py: Fix use of ClassGroupRange so that it 
	uses the new signature.


2003-07-01  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/classgen.py: Fixes RTbug #1972, 1971.
	Import used objects/class from color.
	(generate_singletons): We don't
	need the numGroups parameter anymore because we are using
	the new ramps with GetProperties().
	(generate_uniform_distribution): Use new ramp method
	GetProperties().
	(generate_quantiles, GenQuantiles0): Use new ramp method 
	GetProperties().
	(CustomRamp.SetNumGroups): Removed. The ramps now map
	a value from 0 to 1 to class properties so the number
	of groups is not needed ahead of time.
	(CustomRamp.next): Removed. CustomRamp does not support
	interation anymore.
	(CustomRamp.GetProperties): Returns a ClassGroupProperties
	object based on the index value from 0 to 1 that is
	passed to it.
	(GreyRamp, RedRamp, GreenRamp, BlueRamp, GreenToRedRamp):
	Made into instances of Monochromatic class instread of
	deriving from it.
	(HotToCold.SetNumGroups): Removed. See CustomRamp.
	(HotToCold.next): Removed. See CustomRamp.

	* Thuban/Model/classification.py: Fixes RTbug #1973, 1971.
	(Classification.SetField, Classification.SetFieldType): 
	Replaced with SetFieldInfo.
	(Classification.SetFieldInfo): New. Does a better job of
	what SetField and SetFieldType used to do by combining
	their function since they should really always be done
	at the same time.
	(Classification.SetLayer): Renamed to _set_layer.
	(Classification._set_layer): Should only be called from
	Layer's SetClassification. This does not cause a recursive 
	call as SetLayer did because we know that Layer knows about
	the classification.

	* Thuban/Model/color.py: Fixes RTbug #1971.
	(_Transparent): Renamed from Transparent so it doesn't
	conflict with the module variable.
	(Transparent, Black): Renamed from Color.Transparent, 
	Color.Black so they are not class variables.

	* Thuban/Model/layer.py: Fixes RTbug #1971, 1973.
	(Layer.Destroy): We don't need to call SetClassification
	anymore to clear out the back reference in the classifcation
	to the layer. It's better to set it to None using _set_layer,
	and we won't be creating another clas object too.
	(Layer.SetClassification): Classification._set_layer is not
	recursive so remove all the locking variables. Also clean
	up the code so that it remains unchanged if something fails.

	* Thuban/Model/load.py: Fixes RTbug #1971.
	(SessionLoader.start_classification): Call 
	Classification.SetFieldInfo().

	* Thuban/Model/save.py: Removed import of Color which wasn't
	being used.

	* Thuban/UI/classgen.py: Fixes RTbug #1972.
	(ClassGenDialog.__init__): Color ramps are now instances 
	already so we don't need to create any new objects.
	(ClassGenDialog.OnOK): Check for numGroups is no longer 
	necessary because we never use it.

	* Thuban/UI/classifier.py: Fixes RTbug #1971.
	(Classifier.__BuildClassification, Classifier.__SetGridTable):
	Call Classification.SetFieldInfo() instead of SetFieldType.

	* Thuban/UI/renderer.py: Fixes RTbug #1971.

	* Thuban/UI/view.py: Fixes RTbug #1974, 1971.
	(MapCanvas.__init__): Subscribe to the idle time event. Set
	background color to white.
	(MapCanvas.OnPaint): Set a flag indicating that we should
	render the map during idle time. If we already have a bitmap
	just draw it now.
	(MapCanvas.OnIdle): New. Render the map only during idle time.
	This also fixes a problem with the busy cursor under gtk.

	* test/test_classgen.py (ClassGenTest.test_generate_singletons):
	Fix calls to generate_singletons because the signature changed.

	* test/test_classification.py: Fix color references and
	change calls to Classification.[SetField|SetFieldType] to
	SetFieldInfo.

	* test/test_load.py: Fix color references.

	* test/test_load_0_2.py: Fix color references.

	* test/test_save.py (SaveSessionTest.testClassifiedLayer):
	Change calls to Classification.[SetField|SetFieldType] to
        SetFieldInfo.

2003-07-01  Frank Koormann   <frank.koormann@intevation.de>

	MERGE from the greater-ms3 branch.

	* test/test_transientdb.py
	(TestTransientTable.test_transient_joined_table_with_equal_column_names):
	New. Test join of two tables with partly equal column names.

	* Thuban/Model/transientdb.py (TransientJoinedTable.create):
	If duplicates in left and right tables column names are found, 
	append '_' (underscores) to the name until it is unique.
	Create always new internal names for the resulting table and reference
	columns in the join statement with <table>.<column>

2003-07-01  Bernhard Herzog  <bh@intevation.de>

	* test/test_transientdb.py
	(TestTransientTable.test_transient_joined_table_same_column_name):
	New. Test whether joining on columns with the same names in both
	tables works.
	
	* Thuban/Model/transientdb.py (TransientJoinedTable.create): Make
	sure to use the right internal names even when joining on field
	with the same names in both tables. Also, detect duplicate names
	in the joined table correctly.

2003-07-01  Frank Koormann   <frank@intevation.de>

	* Thuban/UI/renderer.py (ExportRenderer.render_legend):
	Reverse List of layers to render in same order as in desktop legend.
 
2003-06-30  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/version.py (make_tuple): Takes a version string
	and splits it into a tuple of at most three integers.
	Used make_tuple() to make tuple versions of the version
	numbers.

	* Thuban/UI/about.py: Add Thuban email addresses.

2003-06-30  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/version.py: SQLite/PySQLite version dependencies
	were too high.

2003-06-30  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/version.py: Update version to 0.8.1
	
	* MANIFEST.in: Added Projections so that default.proj is
	included.

2003-06-26  Jonathan Coles   <jonathan@intevation.de>

	New About box with lots more information including library
	versions and credits. More/better version checking before
	Thuban starts.

	* Thuban/UI/about.py: New. New About box that displays
	library version information and credits.

	* Thuban/version.py: Added new 'versions' dictionary which
	contains the verions of various libraries which are checked
	when the module loads.
	(verify_versions): Check all version numbers and returns
	a list of errors.

	* Thuban/UI/classifier.py (Classifier.__EnableButtons):
	Reset the status of the buttons as the situation warrants,
	but in a better more reliable way by not relying on the
	current status to determine what needs to change.

	* Thuban/UI/main.py (wxCHECK_VERSION): Removed. Not needed.
	(verify_versions): Remove most of the code since it is
	now in Thuban.version.verify_versions.o

	* Thuban/UI/mainwindow.py (MainWindow.About): Call new
	About box in Thuban.UI.about.

	* extensions/thuban/gdalwarp.cpp (get_gdal_version): New.
	Returns the version of gdal library being used as a string.

	* extensions/thuban/wxproj.cpp (check_version, check_version_gtk):
	Removed.
	(get_proj_version): Return the version of PROJ that the file
	was compiled with.
	(get_gtk_version): Return th version of GTK that the file
	was compiled with.

2003-06-25  Jonathan Coles   <jonathan@intevation.de>
 
	* Thuban/UI/classifier.py (Classifier.EditSymbol): The parent
	of the SelectPropertiesDialog should be self so the window
	appears on top.
	(ClassGroupPropertiesCtrl.DoEdit): The parent
	of the SelectPropertiesDialog should be self so the window
	appears on top.

	* Thuban/UI/resource.py: Cleaned up how we determine file
	extensions.
	(GetImageResource): Return an wxImage from our Resources.

2003-06-24  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/renderer.py (ExportRenderer.render_legend):
	Check that a layer has a classification before trying
	to get it. Raster layers don't have classifications.

2003-06-23  Jonathan Coles   <jonathan@intevation.de>
	
	* setup.py: Add Resources/XML to resource list.
    
2003-06-23  Jonathan Coles   <jonathan@intevation.de>

	* setup.cfg: Fix copyright dates
    
2003-06-23  Jonathan Coles   <jonathan@intevation.de>

	* MANIFEST.in: Update with Resources/XML

	* setup.py: Don't include Locale resources yet as we don't
	have any and it causes problems building the distribution
	for Windows. Update version to 0.8.0.

	* Doc/thuban.dtd: Removed since it is now in Resources/XML.

	* Thuban/UI/mainwindow.py: Add blank line at the end because
	file was not being read correctly building the Windows
	distribution.

2003-06-23  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/mainwindow.py (MainWindow.About): Fix text.

	* Thuban/version.py: Temporarily update longversion for
	the 0.8 release so that it doesn't have the cvs revision.

2003-06-23  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/common.py (ThubanBeginBusyCursor): Call wxSafeYield
	to make sure that we don't create reentrant possibilities with
	wxYield.

	* Thuban/UI/view.py (MapCanvas.OnPaint): Call wxBeginBusyCursor()
	directly to avoid the wxSafeYield() call which generates an 
	OnPaint event causing infinite recursion. Don't try to catch
	exception anymore. This was for before there were limits on map
	scaling.

2003-06-23  Bernhard Herzog  <bh@intevation.de>

	Bug fix for RT #1961:

	* Thuban/Model/load.py (SessionLoader.start_derivedshapesource):
	Register DerivedShapestores with the session

	* Thuban/Model/session.py (Session.Tables): Make sure each table
	is only listed once.

	* test/test_load.py (TestJoinedTable.test): Add check_format call.
	Update file contents to match the one written out.

2003-06-20  Bernhard Herzog  <bh@intevation.de>

	* test/xmlsupport.py (SaxEventLister.startElementNS)
	(SaxEventLister.endElementNS): Do not include the qname. Python
	2.2.1 and 2.2.2 and 2.2.3 differ in this regard. In 2.2.1 qname it
	is (presumably incorrectly) None, whereas it's a string with the
	element name in the later versions.

	* test/test_xmlsupport.py (TestEventList.test_even_list_simple)
	(TestEventList.test_even_list_namespace): Update tests to reflect
	the new behaviour
	(TestEventList.test_even_list_id_normalization): Fix doc-string

2003-06-20  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/layer.py (BaseLayer.HasShapes): New. Overridden
	by deriving classes to determine if that layer supports shapes.
	(Layer): Override HasShapes and return true.

	* Thuban/UI/classgen.py: Use Thuban[Begin|End]BusyCursor()
	instead of a direct call to wx[Begin|End]CusyCursor().
	(GenUniquePanel._OnRetrieve): Set busy cursor while retrieving
	table data.

	* Thuban/UI/common.py (ThubanBeginBusyCursor, ThubanEndBusyCursor):
	New. Wrappers around the wxWindows functions that allow us to 
	make additional calls such as wxYield which gives the native 
	system a chance to update the cursor correctly.

	* Thuban/UI/tableview.py: Use Thuban[Begin|End]BusyCursor()
        instead of a direct call to wx[Begin|End]CusyCursor().

	* Thuban/UI/view.py: Use Thuban[Begin|End]BusyCursor()
	instead of a direct call to wx[Begin|End]CusyCursor().
	(MapCanvas.find_shape_at): Check if the current search layer
	support shapes, otherwise go on to the next layer.

	* test/test_layer.py: Add tests in each type of layer for
	HasClassification() and HasShapes()

2003-06-20  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/UI/view.py (MapCanvas.OnPaint): Call wxYield after
	turning on the busy cursor to allow the system to change the
	cursor before we begin painting. This fixes a problem that
	was occuring only under GTK. Fixes RTbug #1840.

2003-06-20  Bernhard Herzog  <bh@intevation.de>

	* Resources/XML/thuban-0.8.dtd: New DTD for the new file format
	version.

	* Thuban/Model/save.py (sort_data_stores): New. Make topological
	sort of the data sources so they can be written with sources that
	data sources that depend on other data sources come after the
	sources they depend on.
	(SessionSaver.__init__): Add idmap instance variable to map from
	objects to the ids used in the file.
	(SessionSaver.get_id, SessionSaver.define_id)
	(SessionSaver.has_id): New. Methods to manage the idmap
	(SessionSaver.write): Use thuban-0.8.dtd
	(SessionSaver.write_session): Add a namespace on the session and
	write out the data sources before the maps.
	(SessionSaver.write_data_containers): New. Write the data
	containers.
	(SessionSaver.write_layer): Layer elements now refer to a
	shapestore and don't contain filenames anymore.

	* Thuban/Model/load.py (LoadError): Exception class to raise when
	errors in the files are discovered
	(SessionLoader.__init__): Define dispatchers for elements with a
	thuban-0.8 namespace too.
	(SessionLoader.check_attrs): New helper method to check and
	convert attributes
	(AttrDesc): New. Helper class for SessionLoader.check_attrs
	(SessionLoader.start_fileshapesource)
	(SessionLoader.start_derivedshapesource)
	(SessionLoader.start_filetable, SessionLoader.start_jointable):
	Handlers for the new elements in the new fileformat
	(SessionLoader.start_layer): Handle the shapestore attribute in
	addition to filename.
	(SessionLoader.start_table, SessionLoader.end_table): Removed.
	They were never used in the old formats and aren't needed for the
	new.

	* Thuban/Model/session.py (Session.DataContainers): New method to
	return all "data containers", i.e. shapestores and tables

	* test/xmlsupport.py (SaxEventLister.__init__)
	(SaxEventLister.startElementNS, sax_eventlist): Add support to
	normalize IDs.

	* test/test_xmlsupport.py
	(TestEventList.test_even_list_id_normalization): New test case for
	id normalization

	* test/test_load.py (LoadSessionTest.check_format): Use ID
	normalization
	(LoadSessionTest.thubanids, LoadSessionTest.thubanidrefs): New
	class atrributes used for ID normalization
	(TestSingleLayer, TestLayerVisibility, TestLabels.test)
	(TestLayerProjection.test, TestRasterLayer.test): Adapt to new
	file format
	(TestJoinedTable): New test for loading sessions with joined
	tables.
	(TestLoadError): New. Test whether missing required attributes
	cause a LoadError.

	* test/test_save.py (SaveSessionTest.thubanids)
	(SaveSessionTest.thubanidrefs): New class attributes for ID
	normalization in .thuban files.
	(SaveSessionTest.compare_xml): Use id-normalization.
	(SaveSessionTest.testEmptySession)
	(SaveSessionTest.testLayerProjection)
	(SaveSessionTest.testRasterLayer)
	(SaveSessionTest.testClassifiedLayer): Adapt to new file format.
	(SaveSessionTest.testLayerProjection): The filename used was the
	same as for testSingleLayer. Use a different one.
	(SaveSessionTest.test_dbf_table)
	(SaveSessionTest.test_joined_table): New test cases for saving the
	new data sources structures.
	(TestStoreSort, MockDataStore): Classes to test the sorting of the
	data stores for writing.

	* test/runtests.py: Add CVS keywords

2003-06-20  Jonathan Coles   <jonathan@intevation.de>

	* test/test_session.py
	(UnreferencedTablesTests.test_unreferenced_tables_with_joins):
	Use the cultural_landmark-point.dbf file for the store so that
	the table rows and shape count match.

2003-06-20  Jonathan Coles   <jonathan@intevation.de>

	* Thuban/Model/data.py (DerivedShapeStore.__init__): Raise
	an exception if the number of shapes is different from the
	number of rows in the table. Address RTbug #1933.

	* test/test_layer.py (TestLayer.test_derived_store): Add
	a test for the new exception in DerivedShapeStore.__init__.

	* test/support.py (FloatTestCase): Removed since there is
	already FloatComparisonMixin. Fixes RTbug #1954.
	(FloatComparisonMixin.assertFloatEqual): Include test for
	infinity that was part of FloatTestCase.

	* test/test_range.py (RangeTest): Inherit from
	support.FloatComparisonMixin now that we don't have
	support.FloatTestCase.

2003-06-20  Bernhard Herzog  <bh@intevation.de>

	* test/test_save.py (SaxEventLister, sax_eventlist): Removed. Use
	the implementation in xmlsupport instead.
	(SaveSessionTest.compare_xml): sax_eventlist is now in xmlsupport

	* test/test_proj.py: Import sax_eventlist from xmlsupport instead
	of test_save

2003-06-20  Bernhard Herzog  <bh@intevation.de>

	* test/test_load.py (LoadSessionTest.check_format): New helper
	method to make sure the test files we load might have been written
	by the current thuban version.
	(ClassificationTest.TestLayers, TestSingleLayer.test)
	(TestLayerVisibility.test, TestClassification.test)
	(TestLabels.test, TestLayerProjection.test, TestRasterLayer.test):
	Add check_format() calls and fix the thuban data to match the data
	that would be written by saving the session loaded from it.

	* test/xmlsupport.py (SaxEventLister, sax_eventlist): Copies of
	the same class and function in test_save.

	* test/test_xmlsupport.py (TestEventList): New. test cases for
	sax_eventlist

2003-06-20  Bernhard Herzog  <bh@intevation.de>

